PROGRAM BIOGEO(INPUT,OUTPUT,ENTREEB,SORTIE,LIEN,COORDXY,FICHTRI);               
CONST   MAXLOC=290;        (* Maximum number of localities.                     
                              This value must be >= n. of cases       *)        
        MAXLOCP1=291;      (* MAXLOC + 1                              *)        
        NBBITS =59;        (* N. bits in a PASCAL set                 *)        
        NBBITSL1=58;       (* NBBITS-1                                *)        
        NBMOTS =4;         (* MAXLOC DIV NBBITS (integer quotient)    *)        
        NBCAR = 10;        (* nb. characters in a machine word        *)
        MAXGROUPES=67;     (* Maximum n. of simultaneous groups; easy
	                      values are 16,42,67, or anything larger *)        
        LONGLISTE=0;       (* MAXGROUPES DIV NBBITS(integer quotient) *)        
        FACTMULT=16384;    (* 2^14 for packing 2 integers in 32 bits  *)
                           (* Change if wordlength in computer < 32 b *)
        MAXIMUM=5000;      (* Sorting buffer length                   *)        
        MAXIMU1=5001;      (* MAXIMUM + 1                             *)        
        FACTEUR=2.05;      (* Printing factor: horiz. char./vert. char.         
                              Now set for Macintosh Imagewriter/Monaco*)        
        MAXREEL=1.70E38;   (* Largest REAL number on VAX mainframe    *)        
        DENOMINATEUR=10000;                                                     
        LANG=1;            (* Parametre de langue: 1=FRANCAIS                   
                              Language parameter : 2=ENGLISH          *)        
(* =====================================================================        
Space-constrained proportional-link linkage clustering method.                  
                                                                                
Reference:                                                                      
Legendre, P. & V. Legendre. 1985. Postglacial dispersal of freshwater           
   fishes in the Quebec peninsula. Can. J. Fish. Aquat. Sci. 41:                
   1781-1802.                                                                   
                                                                                
Legendre, P. 1987. Constrained clustering. Pp. 289-307 in:                      
   P. Legendre & L. Legendre [eds.] Developments in numerical                   
   ecology. NATO ASI Series, Vol. G 14. Springer-Verlag, Berlin.                
                                                                                
Files:                                                                          
   INPUT and OUTPUT are connected to the user's terminal.                       
   ENTREEB: A similarity matrix (in binary) written by SIMIL.                   
   SORTIE: The file containing the clustering results and the maps              
           (if requested).                                                      
   LIEN: The file of link edges, used to constrain the clustering               
           activity. This file may have been produced by program AUTOCOR        
           or by program CONNEXIONS of the Macintosh version, or else           
           written (or modified) by hand, using a file editor.                  
   COORDXY: The file of geographic coordinates (X and Y) of the                 
           localities. It is needed only if one chooses to print the            
           maps. The program assumes that the coordinates are measured          
           from the lower left-hand corner of the map.                          
                                                                                
This new version (May 1989) replaces the older programs BIOGEO and              
MAPPING2. It contains its own sorting procedure, so that it is not              
required any more to go first through program SORTRI. Finally, the user         
can now decide on the connectedness of proportional-link linkage that           
he wants to use.                                                                
                                                                                
It is now possible to save the sorted similarity file (FICHTRI)                 
and use it in a further run involving a different level of connec-              
tedness. This option will be useful when running large problems.                
(P.L., LLN, Oct. 1989).                                                         
                                                                                
In order for the printed maps to have the correct proportions, you can          
adjust the program to the pitch of your line printer by changing                
parameter FACTEUR above. This parameter is the ratio of the number              
of characters per inch printed horizontally by your printer, to the             
vertical number of lines per inch.                                              
===================================================================== *)        
                                                                                
TYPE    ENSEMBLE=SET OF 0..NBBITSL1;                                            
        CARTTYPE=ARRAY[0..NBMOTS] OF ENSEMBLE;                                  
        NECETYPE=ARRAY[1..MAXGROUPES,1..MAXGROUPES] OF INTEGER;                 
                (* UPPER TRIANGLE: N. LINKS AMONG GROUPS *)                     
                (* LOWER TRIANGLE: MINIMUM NUMBER OF LINKS FOR CLUST. *)        
        LIENTYPE=ARRAY[1..MAXLOC]OF CARTTYPE;                                   
        LISTTYPE=ARRAY[0..LONGLISTE] OF SET OF 0..NBBITSL1;                     
        MEMTYPE=ARRAY[1..MAXLOCP1] OF INTEGER;                                  
        COORDTYPE=ARRAY[1..2] OF MEMTYPE;                                       
        TRIE=RECORD                                                             
                RE:REAL;                                                        
                INT:INTEGER;                                                    
                END;                                                            
        DATA1=RECORD CASE INTEGER OF                                            
                1:(RE:REAL);                                                 
                2:(INT:INTEGER);
                3:(MATCAR:PACKED ARRAY[1..NBCAR] OF CHAR);            
                END;                                                            
        FICH=FILE OF TRIE;                                                      
        DATAOUT=RECORD                                                          
                RE:REAL;                                                        
                CART:CARTTYPE;                                                  
                END;                                                            
        MATRICE=ARRAY[1..MAXIMU1] OF TRIE;                                      
VAR     I,J,NBGROUPES,PLUSGRANDGROUPE,NBCASES,LARGEUR,NBETAPES,ETAPE,           
                NOBJ1:INTEGER;                                                  
        NUMERATEUR:INTEGER;                                                     
        FACTEURV,FACTEURH,CONNEXITE:REAL;                                       
        FUSIONNE,GRAPHE:BOOLEAN;                                                
        CARTE,FRONTIERE:ARRAY[1..MAXGROUPES] OF CARTTYPE;                       
        NECESSAIRE:NECETYPE;                                                    
        LISTELIBRE:LISTTYPE;                                                    
        MATBIT:LIENTYPE;                                                        
        VOISINS:LIENTYPE;                                                       
        GROUPE:MEMTYPE;               (* RETOURNE LA VALEUR DU GROUPE *)        
        LIEN,COORDXY,SORTIE:TEXT;                                               
        MAT:@MATRICE;                                                           
        FICHTRI,TEMP:FICH;                                                      
        ENTREEB:FILE OF DATA1;                                                  
        ADRESSE:MEMTYPE;                                                        
        COORDINT:COORDTYPE;                                                     
        MATCAR:ARRAY[0..132] OF CHAR;                                           
        ALFABET:ARRAY[1..MAXGROUPES] OF CHAR;                                   
        TITRE:ARRAY[1..80] OF CHAR;                                             
                                                                                
                                                                                
PROCEDURE ENTETE;                                                               
BEGIN                                                                           
IF LANG=1 THEN BEGIN                                                            
WRITELN(' P r o g r a m m e  B I O G E O ');                                    
WRITELN;                                                                        
WRITELN(' Auteur: A. Vaudor ');                                                 
END ELSE BEGIN                                                                  
WRITELN(' P r o g r a m  B I O G E O');                                         
WRITELN;                                                                        
WRITELN(' Author: A. Vaudor');                                                  
END;                                                                            
WRITELN;                                                                        
END;                                                                            
                                                                                
PROCEDURE CREESORTIE;                                                           
VAR J,K:INTEGER;                                                                
BEGIN                                                                           
REWRITE(SORTIE);                                                                
WRITELN(SORTIE);                                                                
IF LANG=1 THEN BEGIN                                                            
WRITELN(SORTIE,' B I O G E O : Groupement sous contrainte spatiale ');          
WRITELN(SORTIE);                                                                
WRITELN(SORTIE,' Auteur: A. Vaudor');                                           
END ELSE BEGIN                                                                  
WRITELN(SORTIE,' B I O G E O : Space-constrained clustering ');                 
WRITELN(SORTIE);                                                                
WRITELN(SORTIE,' Author: A. Vaudor');                                           
END;                                                                            
WRITELN(SORTIE);                                                                
END;                                                                            
                                                                                
PROCEDURE LISFICH(J:INTEGER);                                                   
BEGIN                                                                           
CASE J OF                                                                       
        1:BEGIN                                                                 
          RESET(ENTREEB);                                                       
          END;                                                                  
        2:BEGIN                                                                 
          RESET(LIEN);                                                          
          END;                                                                  
        3:BEGIN                                                                 
          RESET(COORDXY);                                                       
          END;                                                                  
        END;                                                                    
END;                                                                            
                                                                                
PROCEDURE TRI(VAR MAT:MATRICE);
CONST   NBMOTS=1;
        NBCAR=10;   (*NBCAR X NBMOTS>=10 *)
VAR I,J,K,L,LIMITE,IMPAIR,LIGNE,COLONNE: INTEGER;
    DONNEE:DATA1;
    SAUTE:BOOLEAN;

PROCEDURE SHELLSORT(VAR A: MATRICE;N: INTEGER);
LABEL 1;
VAR I,J,K,L,M,O: INTEGER;
    W:TRIE;
BEGIN
M:=(2*N-1) DIV 2;
WHILE M<>0 DO
        BEGIN
        K:=N-M;
        FOR J:=1 TO K DO
                   BEGIN
                   I:=J;
                   WHILE I>=1 DO
                                BEGIN
                                IF A[I+M].RE<=A[I].RE THEN GOTO 1;
                                O:=I+M;
                                W:=A[I];A[I]:=A[O];A[O]:=W;
                                I:=I-M;
                                END;
1:                   END;
        M:=M  DIV 2;
        END;
END;        (* FIN DE SHELLSORT *)

PROCEDURE SORTMRG(VAR FICH1,FICH2:FICH;FILEINIT:BOOLEAN;
                  VAR MAT:MATRICE;LIM:INTEGER);
VAR I,J,K:INTEGER;
    X:REAL;
    DONNEE:TRIE;
BEGIN
J:=1;
IF NOT (FILEINIT) THEN RESET(FICH2);
REWRITE(FICH1);
WHILE (J<=LIMITE) DO
        BEGIN
        IF NOT(EOF(FICH2)) THEN
        WHILE (FICH2@.RE>=MAT[J].RE)AND(NOT(EOF(FICH2))) DO
                BEGIN
                FICH1@:=FICH2@;
                PUT(FICH1);GET(FICH2);
                END;
        IF EOF(FICH2) THEN X:=-(MAXREEL) ELSE X:=FICH2@.RE;
        WHILE(MAT[J].RE>X)AND(J<=LIMITE) DO
                BEGIN
                FICH1@:=MAT[J];
                PUT(FICH1);
                J:=J+1;
                END;
        END;
WHILE (NOT(EOF(FICH2))) DO BEGIN FICH1@:=FICH2@;PUT(FICH1);GET(FICH2);END;
END;        (* FIN SORTMRG *)

BEGIN        (* DEBUT TRI *)
LISFICH(1);
LIGNE:=1;
COLONNE:=2;
DONNEE:=ENTREEB@;
NBCASES:=DONNEE.INT;
GET(ENTREEB);GET(ENTREEB);
IF LANG=1 THEN BEGIN
WRITELN
(' Avez-vous fourni un fichier de similarites deja triees (FICHTRI) ?');
WRITELN(' (O ou N)   ');
END ELSE BEGIN
WRITELN(' Did you provide a sorted similarity file (FICHTRI) ?');
WRITELN(' (Y or N) ');
END;
WHILE INPUT@=' ' DO GET(INPUT);
SAUTE:=INPUT@ IN['0','O','o','Y','y'];
READLN;
IF NOT(SAUTE) THEN
BEGIN
REWRITE(TEMP);REWRITE(FICHTRI);
FOR I:=1 TO 13 DO
   FOR J:=1 TO NBMOTS DO GET(ENTREEB);
DONNEE:=ENTREEB@;
GET(ENTREEB);
IF DONNEE.INT<>0 THEN FOR I:=1 TO NBCASES DO
   FOR J:=1 TO NBMOTS DO GET(ENTREEB);
NOBJ1:=NBCASES*(NBCASES-1) DIV 2;
IMPAIR:=(NOBJ1 DIV MAXIMUM) MOD 2;
FOR I:=0 TO NOBJ1 DIV MAXIMUM DO
        BEGIN
        IF (I+1)*MAXIMUM < NOBJ1 THEN LIMITE:=MAXIMUM
        ELSE LIMITE:=NOBJ1 MOD MAXIMUM;
        MAT[LIMITE+1].RE:=0;
        FOR J:=1 TO LIMITE DO
                BEGIN
                DONNEE:=ENTREEB@;
                GET(ENTREEB);
                MAT[J].RE:=DONNEE.RE;
                (* ENTRER LES ID *)
                WITH MAT[J] DO
                        BEGIN
                        INT:=FACTMULT*COLONNE+LIGNE;
                        END;
                COLONNE:=COLONNE+1;
                IF COLONNE > NBCASES THEN
                        BEGIN
                        LIGNE:=LIGNE+1;
                        COLONNE:=LIGNE+1;
                        END;
                END;
        SHELLSORT(MAT,LIMITE);
        IF I MOD 2=IMPAIR THEN
                SORTMRG(FICHTRI,TEMP,I=0,MAT,LIMITE)
        ELSE SORTMRG(TEMP,FICHTRI,I=0,MAT,LIMITE);
        END;
END;
END;(* TRI *)                                                            
                                                                                
FUNCTION CARD(A:ENSEMBLE):INTEGER;                                              
VAR I,COMPTE:INTEGER;                                                           
BEGIN                                                                           
COMPTE:=0;                                                                      
IF A <> [] THEN FOR I:=0 TO NBBITSL1 DO IF I IN A THEN COMPTE:=COMPTE+1;        
CARD:=COMPTE;                                                                   
END;                                                                            
                                                                                
PROCEDURE ECHANGE(VAR A,B:INTEGER);                                             
VAR I:INTEGER;                                                                  
BEGIN                                                                           
I:=A;                                                                           
A:=B;                                                                           
B:=I;                                                                           
END;  (* ECHANGE *)                                                             
                                                                                
PROCEDURE NULL(VAR MAT:CARTTYPE);                                               
VAR I:INTEGER;                                                                  
BEGIN                                                                           
FOR I:=0 TO NBMOTS DO MAT[I]:=[];                                               
END;                                                                            
                                                                                
PROCEDURE AJOUTE(VAR MAT:CARTTYPE;IND:INTEGER);                                 
VAR I,J:INTEGER;                                                                
BEGIN                                                                           
I:=IND DIV NBBITS;                                                              
J:=IND MOD NBBITS;                                                              
MAT[I]:=MAT[I]+[J];                                                             
END;                                                                            
                                                                                
PROCEDURE UNION(VAR MAT,MAT1:CARTTYPE);                                         
VAR I:INTEGER;                                                                  
BEGIN                                                                           
FOR I:=0 TO NBMOTS DO MAT[I]:=MAT[I]+MAT1[I];                                   
END;                                                                            
                                                                                
PROCEDURE MOINS(VAR MAT,MAT1:CARTTYPE);                                         
VAR I:INTEGER;                                                                  
BEGIN                                                                           
FOR I:=0 TO NBMOTS DO  MAT[I]:=MAT[I]-MAT1[I];                                  
END;                                                                            
                                                                                
PROCEDURE ENTRE(OBJ1,OBJ2:INTEGER);                                             
BEGIN                                                                           
AJOUTE(MATBIT[OBJ1],OBJ2);                                                      
AJOUTE(MATBIT[OBJ2],OBJ1);                                                      
END;                                                                            
                                                                                
FUNCTION PASLIBRE(I:INTEGER):BOOLEAN;                                           
VAR J:INTEGER;                                                                  
BEGIN                                                                           
J:=I MOD NBBITS;                                                                
I:=I DIV NBBITS;                                                                
IF J IN LISTELIBRE[I] THEN PASLIBRE:=TRUE                                       
ELSE PASLIBRE:=FALSE;                                                           
END;                                                                            
                                                                                
PROCEDURE ALLOUE(IND:INTEGER);                                                  
VAR I,J:INTEGER;                                                                
BEGIN                                                                           
J:=IND MOD NBBITS;                                                              
I:=IND DIV NBBITS;                                                              
LISTELIBRE[I]:=LISTELIBRE[I]+[J];                                               
IF IND > PLUSGRANDGROUPE THEN PLUSGRANDGROUPE:=IND;                             
END;                                                                            
                                                                                
PROCEDURE RETOURNE(IND:INTEGER);                                                
VAR I,J:INTEGER;                                                                
BEGIN                                                                           
J:=IND MOD NBBITS;                                                              
I:=IND DIV NBBITS;                                                              
LISTELIBRE[I]:=LISTELIBRE[I]-[J];                                               
IF IND=PLUSGRANDGROUPE THEN                                                     
   REPEAT                                                                       
        PLUSGRANDGROUPE:=PLUSGRANDGROUPE-1                                      
   UNTIL PASLIBRE(PLUSGRANDGROUPE);                                             
END;                                                                            
                                                                                
FUNCTION CARDINALITE(VAR MAT,MAT1:CARTTYPE):INTEGER;                            
VAR I,J:INTEGER;                                                                
BEGIN                                                                           
J:=0;                                                                           
FOR I:=0 TO NBMOTS DO J:=J+CARD(MAT[I]*MAT1[I]);                                
CARDINALITE:=J;                                                                 
END;                                                                            
                                                                                
FUNCTION MEMBRE(VAR MAT:CARTTYPE;OBJ:INTEGER):BOOLEAN;                          
VAR I,J:INTEGER;                                                                
BEGIN                                                                           
I:=OBJ DIV NBBITS;                                                              
J:=OBJ MOD NBBITS;                                                              
IF J IN MAT[I] THEN MEMBRE:=TRUE                                                
ELSE MEMBRE:=FALSE;                                                             
END;                                                                            
                                                                                
FUNCTION NONVIDE(VAR MAT,MAT1:CARTTYPE):BOOLEAN;                                
VAR I,J:INTEGER;                                                                
BEGIN                                                                           
J:=0;                                                                           
FOR I:=0 TO NBMOTS DO J:=J+CARD(MAT[I]*MAT1[I]);                                
NONVIDE:=J<>0;                                                                  
END;                                                                            
                                                                                
PROCEDURE DETECTEGROUPE(VAR I,J,GR1,GR2:INTEGER);                               
VAR K:INTEGER;                                                                  
BEGIN                                                                           
GR1:=GROUPE[I];                                                                 
GR2:=GROUPE[J];                                                                 
IF GR1 > GR2 THEN                                                               
        BEGIN                                                                   
        ECHANGE(GR1,GR2);                                                       
        ECHANGE(I,J);                                                           
        END;                                                                    
END;                                                                            
                                                                                
FUNCTION CONTIGU(A,B:INTEGER):BOOLEAN;                                          
VAR LAT1,LAT2,LONG1,LONG2:INTEGER;                                              
BEGIN                                                                           
CONTIGU:=MEMBRE(VOISINS[A],B);                                                  
END;                                                                            
                                                                                
PROCEDURE CREFRONT;                                                             
VAR I,J,K,NBDELIENS:INTEGER;                                                    
BEGIN                                                                           
   IF LANG=1 THEN                                                               
   WRITELN(' Nombre de paires dans le fichier de liens?  ')                     
   ELSE WRITELN(' Number of edges in the list of constraint links?');           
   READLN(NBDELIENS);                                                           
   LISFICH(2);                                                                  
   FOR I:=1 TO NBCASES DO NULL(VOISINS[I]);                                     
   FOR I:=1 TO NBDELIENS DO                                                     
        BEGIN                                                                   
        READ(LIEN,J,K);                                                         
        AJOUTE(VOISINS[J],K);                                                   
        AJOUTE(VOISINS[K],J);                                                   
        END;                                                                    
END;                                                                            
                                                                                
PROCEDURE ECRITURE(NIVEAU:REAL;GR:INTEGER);                                     
VAR I,J,MAXPT,PT:INTEGER;                                                       
                                                                                
        PROCEDURE ECRITLIGNE;                                                   
        VAR I:INTEGER;                                                          
        BEGIN                                                                   
        WRITE(SORTIE,' !');                                                     
        FOR I:=2 TO LARGEUR-1 DO WRITE(SORTIE,' ');                             
        WRITELN(SORTIE,'!');                                                    
        END;                                                                    
                                                                                
        PROCEDURE ECRITTRAIT;                                                   
        VAR I:INTEGER;                                                          
        BEGIN                                                                   
        WRITE(SORTIE,' ');                                                      
        FOR I:=1 TO LARGEUR DO WRITE(SORTIE,'-');                               
        WRITELN(SORTIE);                                                        
        END;                                                                    
                                                                                
BEGIN                                                                           
IF ETAPE <=NBETAPES THEN                                                        
        BEGIN                                                                   
        WRITE(SORTIE,' ');                                                      
        FOR I:=1 TO 80 DO WRITE(SORTIE,TITRE[I]);WRITELN(SORTIE);               
        IF LANG=1 THEN BEGIN                                                    
        WRITELN(SORTIE,' Niveau:           ',NIVEAU:10:5);                      
        WRITELN(SORTIE,' Connexite:        ',CONNEXITE:10:5);                   
        WRITELN(SORTIE,' Nombre de groupes: ',NBGROUPES:3);                     
        END ELSE BEGIN                                                          
        WRITELN(SORTIE,' Level:           ',NIVEAU:10:5);                       
        WRITELN(SORTIE,' Connectedness:   ',CONNEXITE:10:5);                    
        WRITELN(SORTIE,' Number of groups: ',NBGROUPES:3);                      
        END;                                                                    
        WRITELN(SORTIE);                                                        
        J:=0;                                                                   
        FOR I:=1 TO NBCASES DO                                                  
                BEGIN                                                           
                IF (GROUPE[I] <= PLUSGRANDGROUPE)AND(GROUPE[I] > 0) THEN        
                        BEGIN                                                   
                        J:=J+1;                                                 
                        WRITE(SORTIE,' ',GROUPE[I]:3)                           
                        END                                                     
                ELSE WRITE(SORTIE,'   0');                                      
                IF I MOD 18=0 THEN IF I <> NBCASES THEN WRITELN(SORTIE);        
                END;                                                            
        WRITELN(SORTIE);                                                        
        IF LANG=1 THEN                                                          
        WRITELN(SORTIE,' Nombre de localites groupees:',J:4)                    
        ELSE WRITELN(SORTIE,' Number of clustered localities:',J:4);            
        WRITELN(SORTIE);                                                        
        IF GRAPHE THEN                                                          
                BEGIN                                                           
                PT:=1;                                                          
                MAXPT:=COORDINT[2,1];                                           
                ECRITTRAIT;                                                     
                WHILE MAXPT >= 0 DO                                             
                        BEGIN                                                   
                        FOR I:=0 TO LARGEUR-3 DO MATCAR[I]:=' ';                
                        WHILE COORDINT[2,PT]=MAXPT DO                           
                                BEGIN                                           
                                I:=GROUPE[ADRESSE[PT]];                         
                                IF I <=MAXGROUPES THEN                          
                                     MATCAR[COORDINT[1,PT]]:=ALFABET[I];        
                                PT:=PT+1;                                       
                                END;                                            
                        WRITE(SORTIE,' !');                                     
                        FOR I:=0 TO LARGEUR-3 DO                                
                                WRITE(SORTIE,MATCAR[I]);                        
                        WRITELN(SORTIE,'!');                                    
                        IF MAXPT > 0 THEN                                       
                                BEGIN                                           
                                FOR I:=MAXPT-2 DOWNTO COORDINT[2,PT] DO         
                                    ECRITLIGNE;                                 
                                MAXPT:=COORDINT[2,PT];                          
                                END                                             
                        ELSE MAXPT:=-1;                                         
                        END;                                                    
                ECRITTRAIT;                                                     
                WRITELN(SORTIE);                                                
                END;                                                            
        WRITELN(SORTIE);                                                        
        END;                                                                    
ETAPE:=ETAPE-1;                                                                 
END;                                                                            
                                                                                
PROCEDURE SHELL(VAR A: COORDTYPE;N: INTEGER);                                   
LABEL 1;                                                                        
VAR I,J,K,L,M,O,W: INTEGER;                                                     
BEGIN                                                                           
M:=(2*N-1) DIV 2;                                                               
WHILE M<>0 DO                                                                   
        BEGIN                                                                   
        K:=N-M;                                                                 
        FOR J:=1 TO K DO                                                        
                   BEGIN                                                        
                   I:=J;                                                        
                   WHILE I>=1 DO                                                
                                BEGIN                                           
                                IF A[2,I+M] <= A[2,I] THEN GOTO 1;              
                                O:=I+M;                                         
                                W:=A[1,I];A[1,I]:=A[1,O];A[1,O]:=W;             
                                W:=A[2,I];A[2,I]:=A[2,O];A[2,O]:=W;             
                                W:=ADRESSE[I];ADRESSE[I]:=ADRESSE[O];           
                                ADRESSE[O]:=W;                                  
                                I:=I-M;                                         
                                END;                                            
1:                   END;                                                       
        M:=M  DIV 2;                                                            
        END;                                                                    
END;        (* FIN DE SHELL *)                                                  
                                                                                
PROCEDURE INIT;                                                                 
VAR I,J,K,NBCAR1,NN,N1,A,B:INTEGER;                                                       
    MAXX,MINX,MAXY,MINY,X,Y:REAL;                                               
    CHANGE:BOOLEAN;                                                             
BEGIN                                                                           
CHANGE:=FALSE;                                                                  
NBGROUPES:=0;                                                                   
K:=MAXGROUPES+1;                                                                
PLUSGRANDGROUPE:=0;                                                             
FOR I:=0 TO LONGLISTE DO LISTELIBRE[I]:=[];                                     
FOR I:=1 TO NBCASES DO                                                          
        BEGIN                                                                   
        FOR J:=0 TO NBMOTS DO MATBIT[I,J]:=[];                                  
        GROUPE[I]:=K;                                                           
        END;                                                                    
CREESORTIE;                                                                     
FOR I:=1 TO 80 DO TITRE[I]:=' ';                                                
IF LANG=1 THEN                                                                  
WRITELN(' Titre de ce travail   ')                                              
ELSE WRITELN(' Title of this run   ');                                          
NBCAR1:=0;                                                                      
WHILE NOT(EOLN) DO                                                              
        BEGIN                                                                   
        NBCAR1:=NBCAR1+1;                                                       
        TITRE[NBCAR1]:=INPUT@;                                                  
        GET(INPUT);                                                             
        END;                                                                    
READLN;                                                                         
CREFRONT;                                                                       
IF LANG=1 THEN                                                                  
WRITELN(' Connexite desiree (Max: quatre chiffres significatifs)  ')            
ELSE WRITELN                                                                    
(' Connectedness for clustering algorithm (Max: 4 significant digits)');        
REPEAT                                                                          
      READLN(CONNEXITE);                                                        
      IF (CONNEXITE < 0) OR (CONNEXITE > 1.0) THEN                              
      IF LANG=1 THEN WRITELN(' S.V.P., 0 .. 1.0  ')                             
                ELSE WRITELN(' Please, 0 .. 1.0  ');                            
UNTIL (CONNEXITE >=0) AND(CONNEXITE <=1.0);                                     
NUMERATEUR:=ROUND(CONNEXITE*DENOMINATEUR);                                      
IF LANG=1 THEN BEGIN                                                            
WRITELN(' Il y a ',NBCASES-1:1,' etapes de groupement.');                       
WRITELN(' Combien des dernieres etapes vous interessent? ');                    
END ELSE BEGIN                                                                  
WRITELN(' There are ',NBCASES-1:1,' clustering steps.');                        
WRITELN(' How many of the last steps do you want to see? ');                    
END;                                                                            
REPEAT                                                                          
      READLN(NBETAPES);                                                         
      IF (NBETAPES < 1) OR (NBETAPES >= NBCASES) THEN                           
           IF LANG=1 THEN WRITELN('  S.V.P., 1 .. ',NBCASES-1:3,'  ')           
                     ELSE WRITELN('  Please, 1 .. ',NBCASES-1:3,'  ');          
UNTIL (NBETAPES >= 1) AND (NBETAPES < NBCASES);                                 
IF LANG=1 THEN WRITELN(' Desirez-vous les cartes? (O ou N)  ')                  
          ELSE WRITELN(' Do you want the maps printed? (Y or N) ');             
WHILE INPUT@=' ' DO GET(INPUT);                                                 
GRAPHE:=INPUT@ IN['0','O','o','Y','y'];                                         
READLN;                                                                         
IF  GRAPHE THEN                                                                 
        BEGIN                                                                   
        IF LANG=1 THEN WRITELN                                                  
        (' Largeur des cartes (en caracteres, sans compter le cadre): ')        
        ELSE WRITELN                                                            
        (' Width of the maps (in characters, without the frame): ');            
        READLN(LARGEUR);                                                        
        LISFICH(3);                                                             
        RESET(COORDXY);                                                         
        READ(COORDXY,X,Y);                                                      
        MAXX:=X;MINX:=X;                                                        
        MINY:=Y;MAXY:=Y;                                                        
        FOR I:=2 TO NBCASES DO                                                  
                BEGIN                                                           
                READ(COORDXY,X,Y);                                              
                IF X > MAXX THEN MAXX:=X;                                       
                IF X < MINX THEN MINX:=X;                                       
                IF Y > MAXY THEN MAXY:=Y;                                       
                IF Y < MINY THEN MINY:=Y;                                       
                END;                                                            
        MAXX:=MAXX-MINX;                                                        
        MAXY:=MAXY-MINY;                                                        
(* The following lines, when enabled, make sure that the largest                
   side of the map is always printed vertically.                                
        IF MAXX > MAXY THEN                                                     
                BEGIN                                                           
                CHANGE:=TRUE;                                                   
                X:=MAXX;MAXX:=MAXY;MAXY:=X;                                     
                X:=MINX;MINX:=MINY;MINY:=X;                                     
                END;                                            *)              
        FACTEURH:=LARGEUR/(MAXX+1);                                             
        FACTEURV:=FACTEURH/FACTEUR;                                             
        LARGEUR:=LARGEUR+2;                                                     
        RESET(COORDXY);                                                         
        FOR I:=1 TO NBCASES DO                                                  
                BEGIN                                                           
                IF CHANGE THEN READ(COORDXY,Y,X)                                
                ELSE READ(COORDXY,X,Y);                                         
                COORDINT[1,I]:=ROUND((X-MINX)*FACTEURH);                        
                COORDINT[2,I]:=ROUND((Y-MINY)*FACTEURV);                        
                ADRESSE[I]:=I;                                                  
                END;                                                            
        SHELL(COORDINT,NBCASES);                                                
        COORDINT[2,NBCASES+1]:=-1;                                              
        ALFABET[1]:='1';ALFABET[2]:='2';ALFABET[3]:='3';
        ALFABET[4]:='4';ALFABET[5]:='5';ALFABET[6]:='6';
        ALFABET[7]:='7';ALFABET[8]:='8';ALFABET[9]:='9';
        ALFABET[10]:='#';ALFABET[11]:='$';ALFABET[12]:='%';
        ALFABET[13]:='*';ALFABET[14]:='&';ALFABET[15]:='+';
        ALFABET[16]:='=';
(* For computers using the ASCII character set:                 
        FOR I:=17 TO 42 DO ALFABET[I]:=CHR(I-17+ORD('A'));        *) 
(* For IBM mainframes (EBCDIC); can also be used in all cases:    *)        
ALFABET[17]:='A';ALFABET[18]:='B';ALFABET[19]:='C';ALFABET[20]:='D';
ALFABET[21]:='E';ALFABET[22]:='F';ALFABET[23]:='G';ALFABET[24]:='H';
ALFABET[25]:='I';ALFABET[26]:='J';ALFABET[27]:='K';ALFABET[28]:='L';
ALFABET[29]:='M';ALFABET[30]:='N';ALFABET[31]:='O';ALFABET[32]:='P';
ALFABET[33]:='Q';ALFABET[34]:='R';ALFABET[35]:='S';ALFABET[36]:='T';
ALFABET[37]:='U';ALFABET[38]:='V';ALFABET[39]:='W';ALFABET[40]:='X';
ALFABET[41]:='Y';ALFABET[42]:='Z'; (* end of modification for IBM *)
        IF MAXGROUPES > 42 THEN
           BEGIN
ALFABET[43]:='a';ALFABET[44]:='b';ALFABET[45]:='c';ALFABET[46]:='d';
ALFABET[47]:='e';ALFABET[48]:='f';ALFABET[49]:='g';ALFABET[50]:='h';
ALFABET[51]:='i';ALFABET[52]:='j';ALFABET[53]:='k';
ALFABET[54]:='m';ALFABET[55]:='n';ALFABET[56]:='o';ALFABET[57]:='p';
ALFABET[58]:='q';ALFABET[59]:='r';ALFABET[60]:='s';ALFABET[61]:='t';
ALFABET[62]:='u';ALFABET[63]:='v';ALFABET[64]:='w';ALFABET[65]:='x';
ALFABET[66]:='y';ALFABET[67]:='z';
(*"l" not included in the list because of confusion with "1" or "I"*)
           END;
        IF MAXGROUPES > 67 THEN
           BEGIN
           NN:=67;
           N1:=67;
           A:=(MAXGROUPES DIV N1)-1;
           B:=MAXGROUPES MOD N1;
           FOR I:=1 TO A DO
              BEGIN
              FOR J:=1 TO N1 DO
                 BEGIN
                 NN:=NN+1;
                 ALFABET[NN]:=ALFABET[J];
                 END;
              FOR J:=1 TO B DO
                 BEGIN
                 NN:=NN+1;
                 ALFABET[NN]:=ALFABET[J];
                 END;
              END;
           END;
END;    (* fin de IF GRAPHE THEN ... *)
END;    (* Fin INIT *)                                                         
                                                                                
FUNCTION MINIMA(GR,I:INTEGER):INTEGER;                                          
VAR GR2,TEMP,TEMP1:INTEGER;                                                     
BEGIN                                                                           
GR2:=NECESSAIRE[I,I];                                                           
TEMP:=GR*GR2*NUMERATEUR;                                                        
TEMP1:=TEMP DIV DENOMINATEUR;                                                   
IF TEMP MOD DENOMINATEUR<>0 THEN TEMP1:=TEMP1+1;                                
MINIMA:=TEMP1;                                                                  
END;  (* FIN MINIMA *)                                                          
                                                                                
PROCEDURE CREEFRONTIERE(VAR FRONTIERE:CARTTYPE;IND:INTEGER);                    
VAR LONGITUDE,LATITUDE,TEMP:INTEGER;                                            
BEGIN                                                                           
UNION(FRONTIERE,VOISINS[IND]);                                                  
END;                                                                            
                                                                                
PROCEDURE CREATION (IND1,IND2:INTEGER;VAR GR1:INTEGER);                         
VAR I,J:INTEGER;                                                                
                                                                                
   PROCEDURE CHANGEGROUPE(I,J,K:INTEGER);                                       
   VAR GR:INTEGER;                                                              
   BEGIN                                                                        
   GR:=NECESSAIRE[I,I];                                                         
   NECESSAIRE[K,J]:=2*GR*NUMERATEUR DIV DENOMINATEUR;
 (* Probleme de groupemement lorsque Co faible, solutionne par Esther Beneish *)
   if(necessaire[k,j]=0) then necessaire[k,j]:=1;                 (* mai 1995 *)
   NECESSAIRE[J,K]:=CARDINALITE(CARTE[I],MATBIT[IND1])                          
                        +CARDINALITE(CARTE[I],MATBIT[IND2]);                    
   END;                                                                         
                                                                                
BEGIN                                                                           
NBGROUPES:=NBGROUPES+1;                                                         
IF NBGROUPES > MAXGROUPES THEN                                                  
        BEGIN                                                                   
        IF LANG=1 THEN WRITELN(' Trop de groupes en meme temps')                
                  ELSE WRITELN(' Too many groups at the same time');            
        HALT;                                                                   
        END;                                                                    
        (* RECHERCHE LA PROCHAINE CARTE DISPONIBLE *)                           
GR1:=0;                                                                         
REPEAT                                                                          
        GR1:=GR1+1;                                                             
UNTIL NOT(PASLIBRE(GR1));                                                       
ALLOUE(GR1);                                                                    
NULL(CARTE[GR1]);                                                               
NULL(FRONTIERE[GR1]);                                                           
AJOUTE(CARTE[GR1],IND1);                                                        
AJOUTE(CARTE[GR1],IND2);                                                        
CREEFRONTIERE(FRONTIERE[GR1],IND1);                                             
CREEFRONTIERE(FRONTIERE[GR1],IND2);                                             
MOINS(FRONTIERE[GR1],CARTE[GR1]);                                               
GROUPE[IND1]:=GR1;                                                              
GROUPE[IND2]:=GR1;                                                              
NECESSAIRE[GR1,GR1]:=2;  (* TAILLE DU GROUPE *)                                 
FOR I:=GR1-1 DOWNTO 1 DO IF PASLIBRE(I) THEN CHANGEGROUPE(I,I,GR1);             
FOR I:=GR1+1 TO PLUSGRANDGROUPE DO IF PASLIBRE(I) THEN                          
CHANGEGROUPE(I,GR1,I);                                                          
FUSIONNE:=TRUE;                                                                 
END;   (* FIN CREATION DE GROUPES *)                                            
                                                                                
PROCEDURE OBJETGROUPE(GRP,OBJ:INTEGER);                                         
VAR I,GR1,GR2:INTEGER;                                                          
BEGIN                                                                           
AJOUTE(CARTE[GRP],OBJ);                                                         
CREEFRONTIERE(FRONTIERE[GRP],OBJ);                                              
MOINS(FRONTIERE[GRP],CARTE[GRP]);                                               
GR1:=NECESSAIRE[GRP,GRP]+1;                                                     
NECESSAIRE[GRP,GRP]:=GR1;                                                       
FOR I:=GRP-1 DOWNTO 1 DO IF PASLIBRE(I) THEN                                    
        BEGIN                                                                   
        NECESSAIRE[GRP,I]:=MINIMA(GR1,I);                                       
        NECESSAIRE[I,GRP]:=NECESSAIRE[I,                                        
        GRP]+CARDINALITE(CARTE[I],MATBIT[OBJ]);                                 
        END;                                                                    
FOR I:=GRP+1 TO PLUSGRANDGROUPE DO IF PASLIBRE(I) THEN                          
        BEGIN                                                                   
        NECESSAIRE[I,GRP]:=MINIMA(GR1,I);                                       
        NECESSAIRE[GRP,I]:=NECESSAIRE[GRP,                                      
        I]+CARDINALITE(CARTE[I],MATBIT[OBJ]);                                   
        END;                                                                    
GROUPE[OBJ]:=GRP;                                                               
FUSIONNE:=TRUE;                                                                 
END;   (* FIN FUSION OBJET-GROUPE *)                                            
                                                                                
PROCEDURE FUSION(GR1,GR2:INTEGER);                                              
VAR I,GGR1,GGR2,TEMP:INTEGER;                                                   
BEGIN                                                                           
UNION(CARTE[GR1],CARTE[GR2]);                                                   
UNION(FRONTIERE[GR1],FRONTIERE[GR2]);                                           
MOINS(FRONTIERE[GR1],CARTE[GR1]);                                               
RETOURNE(GR2);                                                                  
GGR1:=NECESSAIRE[GR1,GR1]+NECESSAIRE[GR2,GR2];                                  
FOR I:=GR1-1 DOWNTO 1 DO IF PASLIBRE(I) THEN                                    
        BEGIN                                                                   
        NECESSAIRE[GR1,I]:=MINIMA(GGR1,I);                                      
        NECESSAIRE[I,GR1]:=NECESSAIRE[I,GR1]+NECESSAIRE[I,GR2];                 
        END;                                                                    
FOR I:=GR1+1 TO GR2-1 DO IF PASLIBRE(I) THEN                                    
        BEGIN                                                                   
        NECESSAIRE[I,GR1]:=MINIMA(GGR1,I);                                      
        NECESSAIRE[GR1,I]:=NECESSAIRE[GR1,I]+NECESSAIRE[I,GR2];                 
        END;                                                                    
FOR I:=GR2+1 TO PLUSGRANDGROUPE DO IF PASLIBRE(I) THEN                          
        BEGIN                                                                   
        NECESSAIRE[I,GR1]:=MINIMA(GGR1,I);                                      
        NECESSAIRE[GR1,I]:=NECESSAIRE[GR1,I]+NECESSAIRE[GR2,I];                 
        END;                                                                    
NECESSAIRE[GR1,GR1]:=GGR1;                                                      
GGR1:=0;                                                                        
GGR2:=0;                                                                        
FOR I:=1 TO NBCASES DO                                                          
        BEGIN                                                                   
        GGR1:=GGR1+1;                                                           
        IF GGR1=NBBITS THEN                                                     
                BEGIN                                                           
                GGR1:=0;                                                        
                GGR2:=GGR2+1;                                                   
                END;                                                            
        IF GGR1 IN CARTE[GR2,GGR2] THEN GROUPE[I]:=GR1;                         
        END;                                                                    
FUSIONNE:=TRUE;                                                                 
NBGROUPES:=NBGROUPES-1;                                                         
END;   (* FIN FUSION *)                                                         
                                                                                
PROCEDURE GROUPEMENT;                                                           
VAR I,J,K,OBJ1,OBJ2,GR1,GR2,PTRMOT,PTRBIT,PTRADDR,yy:INTEGER;              (* *)
    TROUVE,ITSAGROUP:BOOLEAN;                                                   
    TEMP:CARTTYPE;                                                              
    DONNEE:TRIE;                                                                
                                                                                
   PROCEDURE NEXTBIT(VAR PTRMOT,PTRBIT,PTRADDR:INTEGER);                        
   VAR GRADDR:INTEGER;                                                          
   BEGIN                                                                        
   TROUVE:=FALSE;                                                               
   WHILE  ((NOT(TROUVE))AND(PTRMOT<=NBMOTS)) DO                                 
        BEGIN                                                                   
        IF CARD(TEMP[PTRMOT]) >0  THEN TROUVE:=TRUE                             
        ELSE                                                                    
                BEGIN                                                           
                PTRMOT:=PTRMOT+1;                                               
                PTRBIT:=0;                                                      
                END;                                                            
        END;                                                                    
   IF TROUVE THEN                                                               
           BEGIN                                                                
           WHILE NOT(PTRBIT IN TEMP[PTRMOT]) DO PTRBIT:=PTRBIT+1;               
           PTRADDR:=PTRMOT*NBBITS+PTRBIT;                                       
           GRADDR:=GROUPE[PTRADDR];                                             
           IF GRADDR>MAXGROUPES THEN TEMP[PTRMOT]:=TEMP[PTRMOT]-[PTRBIT]        
           ELSE                                                                 
                BEGIN                                                           
                MOINS(TEMP,CARTE[GRADDR]);                                      
                ITSAGROUP:=TRUE;                                                
                END;                                                            
           END;                                                                 
   END;   (* FIN CHERCHE BIT *)                                                 
                                                                                
BEGIN                                                                           
RESET(FICHTRI);                                                                 
INIT;                                                                           
ETAPE:=NBCASES-1;                                                               
WHILE NOT(EOF(FICHTRI)) DO                                                      
        BEGIN                                                                   
        FUSIONNE:=FALSE;                                                        
        DONNEE:=FICHTRI@;                                                       
        GET(FICHTRI);                                                           
        WITH DONNEE DO                                                          
                BEGIN                                                           
                OBJ1:=INT MOD FACTMULT;                                         
                OBJ2:=INT DIV FACTMULT;                                         
                END;                                                            
        DETECTEGROUPE(OBJ1,OBJ2,GR1,GR2);                                       
        IF ((GR1 > MAXGROUPES) AND(GR2 > MAXGROUPES)) THEN                      
                BEGIN                                                           
                IF CONTIGU(OBJ1,OBJ2) THEN CREATION(OBJ1,OBJ2,GR1)              
                ELSE ENTRE(OBJ1,OBJ2);                                          
                END                                                             
        ELSE                                                                    
           BEGIN                                                                
           IF GR1 <> GR2 THEN                                                   
                BEGIN                                                           
                IF (GR2 > MAXGROUPES) THEN                                      
                   BEGIN                                                        
                   ENTRE(OBJ1,OBJ2);                                            
                   IF MEMBRE(FRONTIERE[GR1],OBJ2) THEN 
      (* Probleme de groupemement lorsque Co=0, solutionne par Esther Beneish *)
                      begin                                       (* mai 1995 *)
                      yy:=NECESSAIRE[GR1,GR1]*NUMERATEUR;                  (* *)
                      if connexite=0 then yy:=1;                           (* *)
                      IF CARDINALITE(CARTE[GR1],MATBIT[OBJ2])*DENOMINATEUR     
                         >= yy  THEN OBJETGROUPE(GR1,OBJ2);                (* *)
                      end;                                                 (* *)
                   END                                                          
                ELSE                                                            
                   BEGIN                                                        
                   NECESSAIRE[GR1,GR2]:=NECESSAIRE[GR1,GR2]+1;
                   if connexite=0 then  NECESSAIRE[GR1,GR2]:=1;            (* *)
                   IF NONVIDE(CARTE[GR1],FRONTIERE[GR2]) THEN                   
                        IF NECESSAIRE[GR1,GR2]>=NECESSAIRE[GR2,GR1] THEN        
                        FUSION(GR1,GR2);                                        
                   END;                                                         
                END;                                                            
           END;                                                                 
        WHILE FUSIONNE DO                                                       
                BEGIN                                                           
                ECRITURE(DONNEE.RE,GR1);                                        
                TEMP:=FRONTIERE[GR1];                                           
                PTRMOT:=0;PTRBIT:=0;PTRADDR:=0;FUSIONNE:=FALSE;                 
                REPEAT                                                          
                        ITSAGROUP:=FALSE;                                       
                        REPEAT                                                  
                                NEXTBIT(PTRMOT,PTRBIT,PTRADDR);                 
                        UNTIL (TROUVE)OR(PTRMOT >NBMOTS);                       
                        IF TROUVE THEN                                          
                           BEGIN                                                
                           IF NOT(ITSAGROUP) THEN                               
                              BEGIN
                              yy:=NECESSAIRE[GR1,GR1]*NUMERATEUR;          (* *)
                              if connexite=0 then yy:=1;                   (* *)
                              IF CARDINALITE                                    
                              (CARTE[GR1],MATBIT[PTRADDR])*DENOMINATEUR         
                                 >= yy THEN OBJETGROUPE(GR1,PTRADDR);      (* *)
                              END                                               
                           ELSE                                                 
                              BEGIN                                             
                              I:=GROUPE[PTRADDR];                               
                              K:=GR1;                                           
                              IF I < K THEN ECHANGE(I,K);
                              if connexite=0 then NECESSAIRE[I,K]:=1;      (* *)
                              IF NECESSAIRE[K,I]>=NECESSAIRE[I,K] THEN          
                                      BEGIN                                     
                                      GR1:=K;                                   
                                      FUSION(GR1,I);                            
                                      END;                                      
                              END;                                              
                           END;                                                 
                UNTIL (PTRMOT > NBMOTS) OR(FUSIONNE);                           
                END;                                                            
        END;                                                                    
END;   (* FIN GROUPEMENT *)                                                     
                                                                                
BEGIN    (* PROG PRINC *)                                                       
ENTETE;                                                                         
NEW(MAT);                                                                       
TRI(MAT@);                                                                      
DISPOSE(MAT);                                                                   
GROUPEMENT;                                                                     
IF LANG=1 THEN WRITELN(' Fin du programme.')                                    
          ELSE WRITELN(' End of the program.');                                 
END.                                                                            
