PROGRAM CHRONO (INPUT,ENTREEB,FICHTRI,OUTPUT);
CONST MAXGROUPES=120;
      NBSETS=3;
      NBBITS=58;      (* NBSETS*NBBITS >=MAXGROUPES *)
      NBMATS=2000;    (* All permutations are performed up to *)
                      (* a maximum of NBMATS possible permutations *)
      NBITER=1000 ;   (* Number of permutations if COMB > NBMATS *)
      GAMMA=0.5;      (* Contrast parameter: should not be modified *)
      NBMOTS=1;
      NBCAR=10;
      FACTMULT=16384;
      LANG=1;         (* Parametre de langue: 1=FRANCAIS
                         Language parameter : 2=ENGLISH  *)
(* ================================================================== *)
(* The SIMILARITY matrix is sorted by TRI1 included in this program.  *)
(* ================================================================== *)
TYPE DATA=RECORD
          RE: REAL;
          INT: INTEGER;
          END;
      REC=RECORD
          R1,R2:REAL;
          END;
      COMPACT=0..32767;
      (* =15 BITS; STORAGE INDEX=60/N. BITS;HERE=4 *)
      ENS=SET OF 0..NBBITS;
      MATENS=ARRAY[0..NBSETS] OF ENS;
      MATRICE=ARRAY[0..4]OF INTEGER;
      MAT0=ARRAY[1..MAXGROUPES] OF MATENS;
      MAT1=PACKED ARRAY[1..MAXGROUPES,1..MAXGROUPES]OF BOOLEAN;
      MAT2= ARRAY[1..2,0..MAXGROUPES] OF INTEGER;
      MAT3=ARRAY[0..MAXGROUPES] OF INTEGER;
      MAT4=ARRAY[0..MAXGROUPES] OF BOOLEAN;
      MAT5=PACKED ARRAY[1..MAXGROUPES,1..MAXGROUPES]OF COMPACT;
      ENTREE=RECORD CASE integer OF
             1:(re:real);
             2:(INT:INTEGER);
             3:(CAR:PACKED ARRAY[1..NBCAR] OF CHAR);
             END;
      FICH=FILE OF DATA;
VAR NOBJ,GROUPE1,GROUPE2,NBGROUPES,INT1,INT2,LIMCAR,TEMPSEC: INTEGER;
    LIMENSG,LIMENSD:INTEGER;
    CRITERE,PROB,RESULTAT,PLUSGRAND: REAL;
    FUSION,TROUVE1,TROUVE2,ELIMINE,ELIMINABLE,POSSIBLE,
    POSTERIORI: BOOLEAN;
    MATCAR:ARRAY[0..MAXGROUPES] OF CHAR;
(*  REC0:REC;                                 for the IMSL version of GGUBFS *)
    REC0:REAL;         (* for the version of GGUBFS included in this program *)
    MATEST:MAT0;
    MATPTR: MAT2;
    MATCARD: MAT3;
    MATFORTES:MAT1;
    MATELIMINE,TESTGAUCHE,MATPOSSIBLE:MAT4;
    MATRANG:MAT5;
    MATRESULT:ARRAY[0..MAXGROUPES]OF REAL;
    ENTREEB:FILE OF ENTREE;
    FICHTRI: FILE OF DATA;
 
FUNCTION CARD(A:ENS):INTEGER;
VAR I,COMPTE:INTEGER;
BEGIN
COMPTE:=0;
FOR I:=0 TO NBBITS DO IF I IN A THEN
   COMPTE:=COMPTE+1;
CARD:=COMPTE;
END;
 
(* FUNCTION GGUBFS(VAR X:REC):REAL;FORTRAN;             for the IMSL version *)
FUNCTION GGUBFS (VAR DSEED:REAL):REAL;
CONST D2P31M=2147483647.0;
      D2P31 =2147483648.0;
VAR A:REAL;
BEGIN
A:=16807*DSEED;
DSEED:=A-TRUNC(A/D2P31M)*D2P31M;
GGUBFS:=DSEED/D2P31;
END;                        (* end of the PASCAL version of GGUBFS, May 1987 *)

Procedure TRI1;
Const maximum = 10000;
      maximu1 = 10001;   (* maximum + 1 *)
      MAXREEL = 1.70E38; (* modify according to your computer *)

Type  MATRICE=ARRAY[1..MAXIMU1] OF DATA;
      
VAR I,J,K,L,LIMITE,NOBJ,NOBJ1,IMPAIR,LIGNE,COLONNE: INTEGER;
    DONNEE:ENTREE;
    MAT:MATRICE;
    TEMP:FICH;

PROCEDURE SHELLSORT(VAR A: MATRICE;N: INTEGER);
LABEL 1;
VAR I,J,K,L,M,O: INTEGER;
    W:DATA;
BEGIN
M:=(2*N-1) DIV 2;
WHILE M<>0 DO
        BEGIN
        K:=N-M;
        FOR J:=1 TO K DO
                BEGIN
                I:=J;
                WHILE I>=1 DO
                        BEGIN
                        IF A[I+M].RE<=A[I].RE THEN GOTO 1;
                        O:=I+M;
                        W:=A[I];A[I]:=A[O];A[O]:=W;
                        I:=I-M;
                        END;
1:                 END;
        M:=M  DIV 2;
        END;
END;        (* FIN DE SHELLSORT *)

PROCEDURE SORTMRG(VAR FICH1,FICH2:FICH;FILEINIT:BOOLEAN;    (* Modif. 91.02.18*)
                  VAR MAT:MATRICE; LIM:INTEGER);
VAR I,J,K:INTEGER;
    X:REAL;
    DONNEE:DATA;
BEGIN
J:=1;
IF NOT (FILEINIT) THEN RESET(FICH2);                        (* Modif. 91.02.18*)
REWRITE(FICH1);
WHILE (J<=LIMITE) DO
      BEGIN
      IF NOT(EOF(FICH2)) THEN(* Modif. 91.02.18*)
      WHILE ((FICH2@.RE>=MAT[J].RE)AND(NOT(EOF(FICH2)))) DO
            BEGIN
            FICH1@:=FICH2@;
            PUT(FICH1);GET(FICH2);
            END;
      IF EOF(FICH2) THEN X:=-(MAXREEL) ELSE X:=FICH2@.RE;  (* Modif. 91.02.18*)
      WHILE ((MAT[J].RE>X)AND(J<=LIMITE)) DO
            BEGIN
            FICH1@:=MAT[J];
            PUT(FICH1);
            J:=J+1;
            END;
      END;
WHILE (NOT(EOF(FICH2))) DO BEGIN FICH1@:=FICH2@;PUT(FICH1);GET(FICH2);END;
	(* Modif. 91.02.18*)
END;        (* FIN SORTMRG *)

BEGIN       (* DEBUT TRI1 *)
REWRITE(TEMP);REWRITE(FICHTRI);                             (* Modif. 91.02.18*)
RESET(ENTREEB);
LIGNE:=1;
COLONNE:=2;
DONNEE:=ENTREEB@;
NOBJ:=DONNEE.INT;
GET(ENTREEB);GET(ENTREEB);
FOR I:=1 TO 13 DO
   FOR J:=1 TO NBMOTS DO GET(ENTREEB);
DONNEE:=ENTREEB@;
GET(ENTREEB);
IF DONNEE.INT<>0 THEN FOR I:=1 TO NOBJ DO
                         FOR J:=1 TO NBMOTS DO GET(ENTREEB);
NOBJ1:=NOBJ*(NOBJ-1) DIV 2;
IMPAIR:=(NOBJ1 DIV MAXIMUM) MOD 2;
FOR I:=0 TO NOBJ1 DIV MAXIMUM DO
      BEGIN
      IF (I+1)*MAXIMUM<NOBJ1 THEN LIMITE:=MAXIMUM
      ELSE LIMITE:=NOBJ1 MOD MAXIMUM;
      MAT[LIMITE+1].RE:=0;
      FOR J:=1 TO LIMITE DO
            BEGIN
            DONNEE:=ENTREEB@;
            GET(ENTREEB);
            MAT[J].RE:=DONNEE.RE;
            (* ENTRER LES ID *)
            MAT[J].INT:=FACTMULT*COLONNE+LIGNE;
            COLONNE:=COLONNE+1;
            IF COLONNE > NOBJ THEN
                  BEGIN
                  LIGNE:=LIGNE+1;
                  COLONNE:=LIGNE+1;
                  END;
            END;
      SHELLSORT(MAT,LIMITE);
      IF I MOD 2=IMPAIR THEN
       SORTMRG(FICHTRI,TEMP,I=0,MAT,LIMITE)                 (* Modif. 91.02.18*)
      ELSE SORTMRG(TEMP,FICHTRI,I=0,MAT,LIMITE);            (* Modif. 91.02.18*)
      END;
END; (* End TRI1 *)

PROCEDURE ENTETE;
VAR I,J:INTEGER;
    MAT:ENTREE;
 
   PROCEDURE ECRITDATA;
   VAR I,J,K:INTEGER;
   BEGIN
   J:=0;
   FOR I:=1 TO NBMOTS DO
      BEGIN
      MAT:=ENTREEB@;GET(ENTREEB);
      FOR K:=1 TO NBCAR DO
            BEGIN
            J:=J+1;
            IF J<=10 THEN WRITE(MAT.CAR  [K]);
            END;
      END;
   END;  (* END OF PROCEDURE ECRITDATA *)
 
BEGIN
RESET(ENTREEB);WRITELN;
IF LANG=1 THEN WRITELN(' FICHIER D''ENTREE:')
          ELSE WRITELN(' INPUT FILE:');WRITELN;
MAT:=ENTREEB@;
GET(ENTREEB);
IF LANG=1 THEN WRITELN('     NOMBRE D''OBJETS : ',MAT.INT:4)
          ELSE WRITELN('     NUMBER OF OBJECTS : ',MAT.INT:4);
MAT:=ENTREEB@;GET(ENTREEB);
IF LANG=1 THEN WRITELN('     NOMBRE DE VARIABLES : ',MAT.INT:4)
          ELSE WRITELN('     NUMBER OF VARIABLES : ',MAT.INT:4);
IF LANG=1 THEN WRITE('     TITRE : ')
          ELSE WRITE('     TITLE : ');
FOR I:=1 TO 10 DO ECRITDATA;
WRITELN;
WRITE('     DATE : ');
ECRITDATA;
WRITELN;
IF LANG=1 THEN WRITE('     FONCTION : ')
          ELSE WRITE('     RESEMBLANCE FUNCTION USED : ');
ECRITDATA;ECRITDATA;
WRITELN;
END;
PROCEDURE TEMPS;
BEGIN
WRITELN;
IF LANG=1 THEN WRITE(' TEMPS ECOULE: ')
          ELSE WRITE(' ELAPSED TIME: ');
   WRITELN((CLOCK-TEMPSEC)/1000:6:4,' SEC');(* for Pascal CDC and VAX *)
(* WRITELN((CLOCK-TEMPSEC)/1000000:6:4,' SEC');     for Pascal/VS IBM *)
WRITELN;
END;
 
FUNCTION COMB(A,B:INTEGER):REAL;
VAR I:INTEGER;
    X:REAL;
BEGIN
X:=0;
FOR I:=A-B+1 TO A DO X:=X+LN(I);
FOR I:=1 TO B DO X:=X-LN(I);
COMB:=EXP(X);
END;   (* END OF PROCEDURE COMB *)
 
   PROCEDURE NULL(VAR REF1:MATENS);
   VAR I:INTEGER;
   BEGIN
   FOR I:=LIMENSG TO LIMENSD DO REF1[I]:=[];
   END;
 
   PROCEDURE PLUS(VAR REF1:MATENS;I:INTEGER);
   VAR J,K:INTEGER;
   BEGIN
   J:= I DIV NBBITS;
   K:= I MOD NBBITS;
   REF1[J]:=REF1[J]+[K];
   END;
 
   FUNCTION MEMBRE(VAR REF1:MATENS;I:INTEGER):BOOLEAN;
   BEGIN
   MEMBRE:=(I MOD NBBITS) IN (REF1[I DIV NBBITS]);
   END;
 
   PROCEDURE TRI(PTR1G,PTR1D,PTR2G,PTR2D,E:INTEGER;CONDITION:BOOLEAN);
   VAR I,J,K,ANCIENJ,ANCIENK,PTR:INTEGER;
      PROCEDURE CHERCHE;
      BEGIN
      IF NOT(MATELIMINE[K]) THEN
      IF NOT(MEMBRE(MATEST[J],K)) THEN
         IF MATRANG[J,K]>=PTR THEN
            BEGIN
            ANCIENJ:=J;
            ANCIENK:=K;
            PTR:=MATRANG[ANCIENJ,ANCIENK];
            END;
      END;
      PROCEDURE AJUSTE;
      BEGIN
      IF NOT(MEMBRE(MATEST[I],J)) THEN
            BEGIN
            PLUS(MATEST[I],J);
            PLUS(MATEST[J],I);
            E:=E+1;
            END;
      END;
 
   BEGIN
   IF CONDITION THEN K:=PTR1D ELSE K:=PTR2D;
   LIMENSG:=PTR1G DIV NBBITS;
   LIMENSD:=PTR2D DIV NBBITS;
   FOR I:=PTR1G TO PTR2D DO
      NULL(MATEST[I]);
   FOR I:=1 TO E DO
         BEGIN
         PTR:=0;
         FOR J:=PTR1G TO PTR1D DO IF NOT(MATELIMINE[J]) THEN
            FOR K:=PTR1G TO J DO CHERCHE;
         IF NOT(CONDITION) THEN FOR J:=PTR2G TO PTR2D DO
         IF NOT(MATELIMINE[J]) THEN
            BEGIN
            FOR K:=PTR2G TO J DO CHERCHE;
            FOR K:=PTR1G TO PTR1D DO CHERCHE;
            END;
         PLUS(MATEST[ANCIENJ],ANCIENK);
         PLUS(MATEST[ANCIENK],ANCIENJ);
         END;
   FOR I:=PTR1G TO PTR1D DO IF NOT(MATELIMINE[I]) THEN
      FOR J:=PTR1G TO I DO IF NOT(MATELIMINE[J]) THEN
         IF MATRANG[I,J]=PTR THEN AJUSTE;
   IF NOT CONDITION THEN FOR I:=PTR2G TO PTR2D DO
   IF NOT MATELIMINE[I] THEN
      BEGIN
      FOR J:=PTR2G TO I DO IF NOT MATELIMINE[J] THEN
         IF MATRANG[I,J]=PTR THEN AJUSTE;
      FOR J:=PTR1G TO PTR1D DO IF NOT(MATELIMINE[J]) THEN
         IF MATRANG[I,J]=PTR THEN AJUSTE;
      END;
   END;       (* END OF PROCEDURE TRI *)
 
FUNCTION H(VALG,VALD,N1,N2:INTEGER;REF3:MATENS):REAL;
VAR I,J,K,T,NB,PP,PG,EQ,COMPTEUR:INTEGER;
    EQ1:REAL;
    REF1,REFINIT:MATENS;
 
   PROCEDURE MOINS(VAR REF1,REF2,REF3:MATENS);
   VAR I:INTEGER;
   BEGIN
   FOR I:=LIMENSG TO LIMENSD DO REF1[I]:=REF2[I]-REF3[I];
   END;
 
   FUNCTION CARDENS(VAR REF1,REF2:MATENS):INTEGER;
   VAR J,K:INTEGER;
   BEGIN
   K:=0;
   FOR J:=LIMENSG TO LIMENSD DO K:=K+CARD(REF1[J]*REF2[J]);
   CARDENS:=K;
   END;
 
   PROCEDURE ENLEVE(VAR REF1:MATENS;I:INTEGER);
   VAR J:INTEGER;
   BEGIN
   J:=I DIV NBBITS;
   REF1[J]:=REF1[J]-[I MOD NBBITS];
   END;
 
   FUNCTION COMPARE(REF1:MATENS):INTEGER;
   VAR I,J:INTEGER;
       REF2:MATENS;
   BEGIN
   NULL(REF2);
   J:=0;
   MOINS(REF2,REFINIT,REF1);
   MOINS(REF2,REF2,REF3);
   FOR I:=VALG TO VALD DO IF MEMBRE(REF1,I) THEN
      BEGIN
      J:=J+CARDENS(MATEST[I],REF2);
      END;
   COMPARE:=J;
   IF J<NB THEN PP:=PP+1
   ELSE IF J> NB THEN PG:=PG+1
        ELSE EQ:=EQ+1;
   END;   (* END OF PROCEDURE COMPARE *)
 
   PROCEDURE DISTRIBUTION(I,J:INTEGER);
   VAR K:INTEGER;
   BEGIN
   FOR K:= I TO J DO IF NOT(MEMBRE(REF3,K))THEN
         BEGIN
         PLUS(REF1,K);
         IF J=VALD THEN COMPTEUR:=COMPARE(REF1)
         ELSE DISTRIBUTION(K+1,J+1);
         ENLEVE(REF1,K);
         END;
   END;   (* END OF PROCEDURE DISTRIBUTION *)
 
BEGIN  (* H *)
NULL(REF1);
COMPTEUR:=0;
NULL(REFINIT);
FOR I:=VALG TO VALD DO
      BEGIN
      PLUS(REFINIT,I);
      IF MATELIMINE[I] THEN PLUS(REF3,I);
      END;
(* FOR I:=VALG+N1-1 DOWNTO VALG DO 
   IF NOT MATELIMINE[I] THEN PLUS(REF1,I); *)
i:=0;j:=valg; 
repeat
      if not matelimine[j] then 
            begin 
            i:=i+1; 
            plus(ref1,j); 
            end;
      j:=j+1; 
until i=n1; 
NB:=COMPARE(REF1);
NULL(REF1);
PP:=0;PG:=0;EQ:=0;
IF N1>N2 THEN
      BEGIN
      I:=N2;
      N2:=N1;
      N1:=I;
      END;
EQ1:=COMB(N1+N2,N1);
IF EQ1<=NBMATS THEN
      BEGIN
      DISTRIBUTION(VALG,VALD-N1+1);
      H:=(PG+EQ)/(PP+EQ+PG);
      END
ELSE
      BEGIN
      T:=VALD-VALG+1;
      FOR I:=1 TO NBITER DO
            BEGIN
            NULL(REF1);
            K:=0;
            WHILE K<N1 DO
                  BEGIN
                  J:=TRUNC(GGUBFS(REC0)*T)+VALG;
                  IF NOT((MEMBRE(REF1,J))OR(MEMBRE(REF3,J))) THEN
                        BEGIN
                        K:=K+1;
                        PLUS(REF1,J);
                        END;
                 END;
            J:=COMPARE(REF1);
            END;
      EQ1:=EQ+(PP+EQ+PG)/EQ1;
      H:=(PG+EQ1)/(PP+EQ1+PG);
      END;
END;       (* END OF FUNCTION H *)
 
FUNCTION VALIDE(GR1,GR2:INTEGER;CONDITION,FINAL:BOOLEAN):BOOLEAN;
VAR I,J,T,E,S,K,N1,N2,PTR1G,PTR2G,PTR1D,PTR2D: INTEGER;
      REF3:MATENS;
      RESULT:REAL;
   PROCEDURE RETOUR(NB1:INTEGER);
   VAR NB3: INTEGER;
   BEGIN
   IF TESTGAUCHE[NB1] THEN
      BEGIN
      NB3:=NB1+1;
      IF ((TESTGAUCHE[NB3])AND(NOT(MATELIMINE[NB1]))) THEN
         BEGIN
         IF ELIMINABLE THEN
               BEGIN
IF LANG=1 THEN WRITELN(' L''OBJET:',NB1:3,' EST ELIMINE','  H:',
                 MATRESULT[NB1]:8:5,MATRESULT[NB3]:8:5)
          ELSE WRITELN(' OBJECT:',NB1:3,' IS A SINGLETON','  H:',
                 MATRESULT[NB1]:8:5,MATRESULT[NB3]:8:5);
               ELIMINE:=TRUE;
               MATELIMINE[NB1]:=TRUE;
               END
         ELSE MATCAR[NB1]:='@';
         END
      ELSE
         BEGIN
         NB3:=NB1-1;
         IF ((TESTGAUCHE[NB3])AND(NOT(MATELIMINE[NB1]))) THEN
            BEGIN
            IF ELIMINABLE THEN
               BEGIN
IF LANG=1 THEN WRITELN(' L''OBJET ',NB3:3,' EST ELIMINE',
                                 MATRESULT[NB3]:8:5,MATRESULT[NB1]:8:5)
          ELSE WRITELN(' OBJECT ',NB3:3,' IS A SINGLETON',
                                 MATRESULT[NB3]:8:5,MATRESULT[NB1]:8:5);
               ELIMINE:=TRUE;
               MATELIMINE[NB3]:=TRUE;
               END
            ELSE MATCAR[NB3]:='@';
            END;
         END;
      END;
   END;     (* END OF RETOUR AFTER ELIMINATING A SINGLETON*)
 
BEGIN
PTR1G:=MATPTR[1,GR1];
PTR2G:=MATPTR[1,GR2];
PTR1D:=MATPTR[2,GR1];
PTR2D:=MATPTR[2,GR2];
N1:=PTR1D-PTR1G+1;
N2:=PTR2D-PTR2G+1;
FOR I:=PTR2G+1 TO PTR2D-1 DO IF MATELIMINE[I] THEN N2:=N2-1;
FOR I:=PTR1G+1 TO PTR1D-1 DO IF MATELIMINE[I] THEN N1:=N1-1;
IF CONDITION THEN N1:=N1-1;
S:=N1*N2;
RESULT:=2;
IF S>1 THEN
      BEGIN
      T:=(N1+N2);
      T:=T*(T-1) DIV 2;
      E:=TRUNC((GAMMA+10E-10)*T);
      K:=0;
      IF E>0 THEN
         TRI(PTR1G,PTR1D,PTR2G,PTR2D,E,CONDITION);
      NULL(REF3);
      FOR I:=PTR1D+1 TO PTR2G-1 DO PLUS(REF3,I);
 
      RESULT:=H(PTR1G,PTR2D,N1,N2,REF3);
      IF FINAL THEN BEGIN VALIDE:=TRUE;RESULTAT:=RESULT;END
      ELSE
            BEGIN
            MATRESULT[PTR2G]:=RESULT;
            IF RESULT>PROB THEN BEGIN VALIDE:=TRUE;RESULTAT:=RESULT;END
            ELSE
                  BEGIN
                  VALIDE:=FALSE;
                  TESTGAUCHE[PTR2G]:=TRUE;
                  IF N2=1 THEN RETOUR(MATPTR[1,GR2])
                  ELSE IF N1=1 THEN RETOUR(MATPTR[1,GR1]);
                  END;
            END;
 
      END
ELSE
      BEGIN
      VALIDE:=NOT((MATELIMINE[PTR2G])OR(MATELIMINE[PTR1G]));
      IF NOT(FINAL) THEN MATRESULT[PTR2G]:=2.0;
      END;
END;      (* END OF FUNCTION VALIDE *)
 
FUNCTION VALABLE(GR1,GR2:INTEGER):BOOLEAN;
VAR INT1,INT2:INTEGER;
BEGIN
INT1:=MATPTR[2,GR1];
INT2:=MATPTR[1,GR2];
REPEAT INT1:=INT1+1 UNTIL (NOT(MATELIMINE[INT1]))OR(INT1>=INT2);
VALABLE:=INT1=INT2;
END;   (* END OF FUNCTION VALABLE *)
 
PROCEDURE CALCUL;
LABEL 777;
VAR I,J,K,L,NOBJ1,GRP: INTEGER;
    X:REAL;
    DONNEE: DATA;
    TEMP1:ENTREE;
 
FUNCTION CARDINALITE(GR:INTEGER):INTEGER;
VAR I,J:INTEGER;
BEGIN
I:=MATPTR[2,GR]-MATPTR[1,GR]+1;
FOR J:=MATPTR[1,GR] TO MATPTR[2,GR] DO
   IF MATELIMINE[J] THEN I:=I-1;
CARDINALITE:=I;
END;          (* END OF FUNCTION CARDINALITE *)
 
PROCEDURE ECRITGROUPES;
VAR I,J,K,L,LL: INTEGER;
BEGIN
IF NOBJ<=LIMCAR-24 THEN
      BEGIN
      FOR I:=1 TO NOBJ DO IF MATELIMINE[I] THEN  MATCAR[I]:='*'
                           ELSE IF MATCAR[I]<>'@' THEN MATCAR[I]:='-';
      K:=ORD('A');
      L:=-1;
      FOR I:=1 TO NBGROUPES DO
            BEGIN
            IF MATPTR[1,I]<MATPTR[2,I] THEN
                  BEGIN
                  L:=L+1;
                  FOR J:=MATPTR[1,I] TO MATPTR[2,I] DO
                     IF MATELIMINE[J] THEN MATCAR[J]:='*'
(*                   else matcar(.J.):=chr(K+L);    for CDC computers *)
                  ELSE begin (* modification for EBCDIC character set *)
                          LL:=L mod 26;
                          if LL >  8 then LL:=LL+7;
                          if LL > 24 then LL:=LL+8;
                          MATCAR[J]:=CHR(K+LL);
                          end;         (* end of modification for ibm *)
                  END;
            END;
      FOR I:=0 TO NOBJ DO WRITE(MATCAR[I]);
      WRITE('   S:',DONNEE.RE:9:5);
      IF RESULTAT<=1.5 THEN WRITE(' H:',RESULTAT:8:5);
      WRITELN;
      END
ELSE
      BEGIN
      J:=1;
      WRITE(' ');
      FOR I:=1 TO NBGROUPES DO IF MATPTR[1,I]<MATPTR[2,I] THEN
            BEGIN
            J:=J+11;
            IF J>=LIMCAR THEN BEGIN WRITELN;WRITE(' ');J:=12;END;
            WRITE('[',MATPTR[1,I]:3,' .. ',MATPTR[2,I]:3,'] ');
            END
      ELSE IF MATCAR[MATPTR[1,I]]='@' THEN
       WRITE('[',MATPTR[1,I]:3,'] ');
      WRITELN;
      WRITE(' ':LIMCAR-26,'   S:',DONNEE.RE:9:5);
      IF RESULTAT<=1.0 THEN WRITE(' H:',RESULTAT:8:5);
      WRITELN;
      WRITELN;
      END;
END;     (* END OF PROCEDURE ECRITGROUPES *)
 
PROCEDURE INCLUSION(INT: INTEGER;VAR GROUPE: INTEGER;
VAR TROUVE: BOOLEAN);
VAR I: INTEGER;
BEGIN
TROUVE:=FALSE;
I:=0;
REPEAT
      I:=I+1;
UNTIL ((MATPTR[1,I]<=INT)AND(MATPTR[2,I]>=INT))OR(I>NBGROUPES);
IF I<=NBGROUPES THEN TROUVE:=TRUE;
GROUPE:=I;
END;           (* END OF PROCEDURE INCLUSION *)
 
 
PROCEDURE FUSIONNE(GROUPE2:INTEGER);
VAR I,J,K,L,GROUPE1: INTEGER;
   PROCEDURE TESTEGROUPE(GR1,GR2:INTEGER);
   VAR I,J,K,PTR1G,PTR1D,PTR2G,PTR2D:INTEGER;
   BEGIN
   IF VALABLE(GR1,GR2) THEN
      BEGIN
      PTR1G:=MATPTR[1,GR1];PTR1D:=MATPTR[2,GR1];
      PTR2G:=MATPTR[1,GR2];PTR2D:=MATPTR[2,GR2];
      K:=0;
      FOR I:=PTR1G TO PTR1D DO
         FOR J:=PTR2G TO PTR2D DO
            IF MATFORTES[I,J] THEN K:=K+1;
      MATCARD[PTR2G]:=K;
      IF K>=CARDINALITE(GR1)*CARDINALITE(GR2)*CRITERE-10E-20 THEN
            BEGIN
            MATPOSSIBLE[PTR2G]:=TRUE;
            TESTGAUCHE[PTR2G]:=NOT(VALIDE(GR1,GR2,FALSE,FALSE));
            END
      ELSE TESTGAUCHE[PTR2G]:=FALSE;
      END;
   END;   (* END OF TEST ON ADJACENT GROUPS *)
 
BEGIN
GROUPE1:=GROUPE2-1;
MATPTR[2,GROUPE1]:=MATPTR[2,GROUPE2];
NBGROUPES:=NBGROUPES-1;
FOR I:=GROUPE2 TO NBGROUPES DO
      BEGIN
      MATPTR[1,I]:=MATPTR[1,I+1];
      MATPTR[2,I]:=MATPTR[2,I+1];
      END;
TESTGAUCHE[MATPTR[1,GROUPE1]]:=FALSE;
ECRITGROUPES;
IF GROUPE1>1 THEN TESTEGROUPE(GROUPE1-1,GROUPE1);
IF GROUPE1<=NBGROUPES THEN TESTEGROUPE(GROUPE1,GROUPE2);
POSSIBLE:=TRUE;
END;    (* END OF PROCEDURE FUSIONNE *)
 
PROCEDURE CREATION(INT: INTEGER;VAR GROUPE: INTEGER);
VAR I:INTEGER;
BEGIN
MATPTR[1,NBGROUPES+1]:=NOBJ+1;
GROUPE:=0;
REPEAT GROUPE:=GROUPE+1 UNTIL(MATPTR[1,GROUPE]>INT);
FOR I:=NBGROUPES DOWNTO GROUPE DO
      BEGIN
      MATPTR[1,I+1]:=MATPTR[1,I];
      MATPTR[2,I+1]:=MATPTR[2,I];
      END;
NBGROUPES:=NBGROUPES+1;
MATPTR[1,GROUPE]:=INT;
MATPTR[2,GROUPE]:=INT;
TESTGAUCHE[INT]:=FALSE;
MATCARD[INT]:=0;
END;        (* END OF PROCEDURE CREATION *)
 
   PROCEDURE EXPANSION;
   VAR I,J,K,PTRG,PTRD,PTRG1,PTRD1,NECESSAIRE,COMPTEUR,N2:INTEGER;
       REF4:MATENS;
       TERMINE:BOOLEAN;
       HGAUCHE,HDROIT:REAL;
 
      PROCEDURE FUSIONNE;
      VAR I,PTR:INTEGER;
      BEGIN
      IF (((MATCARD[PTRG1]>=MATCARD[PTRD1])AND((HGAUCHE>PROB)AND
       (HGAUCHE<=1))) OR (HDROIT<=PROB)) THEN
            BEGIN
            HDROIT:=HGAUCHE;
            PTR:=PTRG;
            PTRG:=PTRG-1;
            IF MATELIMINE[PTRG] THEN PTRG:=PTRG-1;
            PTRG1:=PTRG-1;
            END
      ELSE
            BEGIN
            PTR:=PTRD;
            PTRD:=PTRD+1;
            IF MATELIMINE[PTRD] THEN PTRD:=PTRD+1;
            PTRD1:=PTRD+1;
            END;
      N2:=0;
      FOR I:=PTRG TO PTRD DO IF NOT(MATELIMINE[I]) THEN N2:=N2+1;
      NECESSAIRE:=TRUNC(N2*CRITERE-10E-10)+1;
      WRITELN('      [',PTRG:4,' .. ',PTRD:4,']  H: ',HDROIT:10:5);
      IF PTRG1 > 0 THEN HGAUCHE:=2 ELSE HGAUCHE:=0;
      IF PTRD1 < NOBJ THEN HDROIT :=2 ELSE HDROIT:=0;
      FOR I:=PTRG1 DOWNTO 1 DO IF MATFORTES[I,PTR] THEN
                               MATCARD[I]:=MATCARD[I]+1;
      FOR I:=PTRD1 TO NOBJ DO  IF MATFORTES[PTR,I] THEN
                               MATCARD[I]:=MATCARD[I]+1;
      POSSIBLE:=FALSE;
      END;     (* END OF PROCEDURE FUSIONNE *)
 
      PROCEDURE ESSAIE(I,J,K:INTEGER;VAR HD:REAL);
      VAR T :INTEGER;
      BEGIN
      POSSIBLE:=FALSE;
      IF MATCARD[I] >= NECESSAIRE THEN
            BEGIN
            T:=(N2*(N2+1) DIV 2 +1) DIV 2;
            IF HD > 1.5 THEN
                  BEGIN
                  NULL(REF4);
                  IF I< K THEN
                        BEGIN
                        TRI(PTRG1,PTRG1,PTRG,PTRD,T,FALSE);
                        HD:=H(J,K,1,N2,REF4);
                        END
                  ELSE
                        BEGIN
                        TRI(PTRG,PTRD,PTRD1,PTRD1,T,FALSE);
                        HD:=H(J,K,N2,1,REF4);
                        END;
                  END;
            IF HD > PROB THEN  POSSIBLE:=TRUE;
            END;
      END;     (* END OF PROCEDURE ESSAIE *)
 
   BEGIN
   WRITELN;
   IF LANG=1 THEN WRITELN(' EXPANSION DES GROUPES')
             ELSE WRITELN(' GROUP EXPANSION TESTS');
   WRITELN;
   FOR K:=1 TO NBGROUPES DO
      BEGIN
      PTRG:=MATPTR[1,K];
      PTRD:=MATPTR[2,K];
      POSSIBLE:=FALSE;
      RESET(FICHTRI);
      FOR I:=1 TO NOBJ DO MATCARD[I]:=0;
      FOR I:=1 TO NOBJ DO FOR J:=I TO NOBJ DO MATFORTES[I,J]:=FALSE;
      COMPTEUR:=0;
      TERMINE:=FALSE;
      N2:=0;
      FOR I:=PTRG TO PTRD DO IF NOT(MATELIMINE[I]) THEN N2:=N2+1;
      NECESSAIRE:=TRUNC(N2*CRITERE-10E-10)+1;
      WRITELN;
      WRITELN('      [',PTRG:4,' .. ',PTRD:4,']');
      PTRG1:=PTRG-1;
      IF ((MATELIMINE[PTRG1])AND(PTRG1<>0)) THEN PTRG1:=PTRG1-1;
      PTRD1:=PTRD+1;
      IF ((MATELIMINE[PTRD1])AND(PTRD1<>NOBJ)) THEN PTRD1:=PTRD1+1;
      IF PTRG1 > 0 THEN HGAUCHE:=2 ELSE HGAUCHE:=0;
      IF PTRD1 < NOBJ THEN HDROIT:=2 ELSE HDROIT:=0;
      WHILE NOT TERMINE DO
            BEGIN
            COMPTEUR:=COMPTEUR+1;
            DONNEE:=FICHTRI@;GET(FICHTRI);
            WITH DONNEE DO
                  BEGIN
                  INT1:=INT MOD FACTMULT;
                  INT2:=INT DIV FACTMULT;
                  END;
            MATFORTES[INT1,INT2]:=TRUE;
            IF ((INT1>=PTRG)AND(INT1<=PTRD)) THEN
                  BEGIN
                  MATCARD[INT2]:=MATCARD[INT2]+1;
                  IF ((INT2=PTRD1)AND(MATCARD[INT2]>=NECESSAIRE)) THEN
                         ESSAIE(INT2,PTRG,PTRD1,HDROIT);
                  END;
            IF ((INT2>=PTRG)AND(INT2<=PTRD)) THEN
                  BEGIN
                  MATCARD[INT1]:=MATCARD[INT1]+1;
                  IF ((INT1=PTRG1)AND(MATCARD[INT1]>=NECESSAIRE)) THEN
                              ESSAIE(INT1,PTRG1,PTRD,HGAUCHE);
                  END;
            WHILE POSSIBLE DO
                  BEGIN
                  FUSIONNE;
                  IF MATCARD[PTRD1]>MATCARD[PTRG1] THEN
                        ESSAIE(PTRD1,PTRG,PTRD1,HDROIT);
                  IF NOT POSSIBLE THEN ESSAIE(PTRG1,PTRG1,PTRD,HGAUCHE);
                  END;
            TERMINE:=((HGAUCHE < PROB)AND(HDROIT < PROB))OR
             (COMPTEUR=NOBJ1);
            END;
      END;
   END;   (* END OF PROCEDURE EXPANSION *)
 
BEGIN                (* DEBUT CALCUL *)
(* REC0.R1:=3;REC0.R2:=0;                     for the IMSL version of GGUBFS *)
REC0:=3;               (* for the version of GGUBFS included in this program *)
FOR I:=1 TO 100 DO X:=GGUBFS(REC0);                       (* initialize REC0 *)
RESET(ENTREEB);
RESET(FICHTRI);
TEMP1:=ENTREEB@;
NOBJ:=TEMP1.INT;
RESET(FICHTRI);
NOBJ1:=NOBJ*(NOBJ-1) DIV 2;
K:=0;X:=1000000;
FOR I:=1 TO NOBJ1 DO
      BEGIN
      DONNEE:=FICHTRI@;GET(FICHTRI);
      IF DONNEE.RE<X THEN K:=K+1;
      X:=DONNEE.RE;
      MATRANG[DONNEE.INT DIV FACTMULT,DONNEE.INT MOD FACTMULT]:=K;
      END;
FOR I:=1 TO NOBJ DO
      BEGIN
      MATELIMINE[I]:=FALSE;
      MATCAR[I]:=' ';
      END;
MATCAR[0]:=' ';
TESTGAUCHE[0]:=TRUE;
TESTGAUCHE[NOBJ+1]:=TRUE;
FOR I:=1 TO NOBJ DO MATRANG[I,I]:=0;
MATRESULT[NOBJ+1]:=0;
777:RESET(FICHTRI);
ELIMINE:=FALSE;
FOR I:=1 TO NOBJ DO BEGIN TESTGAUCHE[I]:=FALSE;MATPOSSIBLE[I]:=FALSE;
END;
FOR I:=1 TO NOBJ DO
   FOR J:=I TO NOBJ DO MATFORTES[I,J]:=FALSE;
NBGROUPES:=0;
FOR I:=1 TO NOBJ1 DO
      BEGIN
      FUSION:=FALSE;
      if(resultat=0.0) then RESULTAT:=2;
      DONNEE:=FICHTRI@;GET(FICHTRI);
      WITH DONNEE DO
            BEGIN
            INT1:=INT MOD FACTMULT;
            INT2:=INT DIV FACTMULT;
            END;
      IF (NOT((MATELIMINE[INT1])OR(MATELIMINE[INT2]))) THEN
         BEGIN
         INCLUSION(INT1,GROUPE1,TROUVE1);
         IF NOT TROUVE1 THEN CREATION(INT1,GROUPE1);
         INCLUSION(INT2,GROUPE2,TROUVE2);
         IF NOT TROUVE2 THEN CREATION(INT2,GROUPE2);
         MATFORTES[INT1,INT2]:=TRUE;
         INT2:=MATPTR[1,GROUPE2];
         IF ((GROUPE1<>GROUPE2)AND(NOT(TESTGAUCHE[INT2]))) THEN
            BEGIN
            IF VALABLE(GROUPE1,GROUPE2)THEN
                  BEGIN
                  MATCARD[INT2]:=MATCARD[INT2]+1;
                  K:=CARDINALITE(GROUPE1)*CARDINALITE(GROUPE2);
                  IF MATCARD[INT2]>=K*CRITERE-10E-10 THEN
                        BEGIN
                        MATPOSSIBLE[INT2]:=TRUE;
                        POSSIBLE:=VALIDE(GROUPE1,GROUPE2,FALSE,FALSE);
                        IF ELIMINE THEN GOTO 777;
                        END;
                  END;
            IF ((POSSIBLE)AND(DONNEE.RE<>FICHTRI@.RE)) THEN
               WHILE POSSIBLE DO
                  BEGIN
                  POSSIBLE:=FALSE;
                  PLUSGRAND:=0;
                  FOR J:=2 TO NBGROUPES DO
                     BEGIN
                     INT2:=MATPTR[1,J];
                     IF MATPOSSIBLE[INT2] THEN
                     IF MATRESULT[INT2]>PLUSGRAND THEN
                         BEGIN
                         PLUSGRAND:=MATRESULT[INT2];
                         GROUPE2:=J;
                         END;
                      END;
                  IF PLUSGRAND>PROB THEN FUSIONNE(GROUPE2);
                   IF ELIMINE THEN GOTO 777;
                  END;
            END;
         END;
      END;
IF ELIMINE THEN GOTO 777;
TEMPS;
IF POSTERIORI THEN
   BEGIN
   EXPANSION;
   TEMPS;
   IF LANG=1 THEN WRITELN(' TESTS ENTRE LES GROUPES ')
             ELSE WRITELN(' TESTS AMONG GROUPS ');
   FOR I:=1 TO NBGROUPES-1 DO
     BEGIN
IF LANG=1 THEN WRITE
(' [',MATPTR[1,I]:3,' .. ',MATPTR[2,I]:3,'] versus  [',MATPTR[1,I+1]:3)
ELSE WRITE
(' [',MATPTR[1,I]:3,' .. ',MATPTR[2,I]:3,'] against [',MATPTR[1,I+1]:3);
   WRITELN(' .. ',MATPTR[2,I+1]:3,']  H:',MATRESULT[MATPTR[1,I+1]]:8:5);
     FOR J:=I+2 TO NBGROUPES DO
           BEGIN
           POSSIBLE:=VALIDE(I,J,FALSE,TRUE);
           WRITE('                      [',
                  MATPTR[1,J]:3,' .. ',MATPTR[2,J]:3,']  H:');
           WRITELN(RESULTAT:8:5);
           END;
     END;
   WRITELN;
   TEMPS;
   IF LANG=1 THEN WRITELN(' TESTS SUR LES OBJETS ELIMINES ')
             ELSE WRITELN(' TESTING SINGLETONS AGAINST ALL GROUPS ');
   WRITELN;
   NOBJ1:=NBGROUPES+1;
   FOR J:=1 TO NOBJ DO IF MATELIMINE[J] THEN
      BEGIN
      MATPTR[1,NOBJ1]:=J;MATPTR[2,NOBJ1]:=J;
      MATELIMINE[J]:=FALSE;
      IF LANG=1 THEN WRITE(' [',J:3,'] versus  ')
                ELSE WRITE(' [',J:3,'] against ');
      FOR K:=1 TO NBGROUPES DO
            BEGIN
            IF K>1 THEN WRITE('         ');
            WRITE('[',MATPTR[1,K]:3,' .. ',MATPTR[2,K]:3,']  H:');
            IF MATPTR[1,K]>J THEN POSSIBLE:=VALIDE(NOBJ1,K,FALSE,TRUE)
            ELSE
                  BEGIN
                  POSSIBLE:=VALIDE(K,NOBJ1,J<MATPTR[2,K],TRUE);
                  END;
            WRITELN(RESULTAT:8:5);
            END;
      MATELIMINE[J]:=TRUE;
      END;
   TEMPS;
   END;
END;
 
BEGIN     (* Main program *)
TEMPSEC:=CLOCK;
WRITELN;
rewrite(Fichtri);
Tri1;
Reset(Fichtri);
IF LANG=1
THEN WRITELN(' G R O U P E M E N T   C H R O N O L O G I Q U E ')
ELSE WRITELN(' C H R O N O L O G I C A L   C L U S T E R I N G ');
WRITELN;
WRITELN(' DEPARTEMENT DE SCIENCES BIOLOGIQUES ');
WRITELN(' UNIVERSITE DE MONTREAL');
WRITELN(' C. P. 6128, SUCC "A"');
WRITELN(' MONTREAL, QUEBEC  H3C 3J7.');
WRITELN;
IF LANG=1 THEN WRITELN(' Reference decrivant la methode:')
          ELSE WRITELN(' Reference describing the method:');
WRITELN(' Legendre,  P.,  S.   Dallot,  and  L.   Legendre.  1985  --');
WRITELN('    Succession of species within a community:  chronological');
WRITELN('    clustering,  with applications to marine  and freshwater');
WRITELN('    zooplankton.  The American Naturalist, 125 (2): 257-288.');
WRITELN;
REPEAT
         IF LANG=1 THEN WRITELN(' CONNEXITE DU GROUPEMENT ?   ')
                   ELSE WRITELN(' CONNECTEDNESS OF CLUSTERING ?   ');
         READLN(CRITERE);
UNTIL (CRITERE>=0)AND(CRITERE<=1.0);
IF LANG=1 THEN WRITELN(' Connexite:    ',CRITERE:5:2)
          ELSE WRITELN(' Connectedness:    ',CRITERE:5:2); WRITELN;
REPEAT
 IF LANG=1
 THEN WRITELN(' NIVEAU ALPHA POUR LE TEST DE FUSION DES GROUPES ? ')
 ELSE WRITELN(' ALPHA LEVEL FOR THE CLUSTER FUSION TEST ? ');
 READLN(PROB);
UNTIL (PROB>=0)AND(PROB<=1.0);
 IF LANG=1
 THEN WRITELN(' Niveau de fusion des groupes (ALPHA): ',PROB:8:5)
 ELSE WRITELN(' Cluster fusion level (ALPHA): ',PROB:8:5);WRITELN;
IF LANG=1 THEN WRITELN(' ELIMINATION DES OBJETS ABERRANTS (O ou N) ?')
          ELSE WRITELN(' REMOVAL OF SINGLETONS (Y or N) ?   ');
WHILE NOT (INPUT@ IN ['0','O','o','Y','y','N','n']) DO GET(INPUT);
ELIMINABLE:=INPUT@ IN ['0','O','o','Y','y']; READLN;
IF NOT(ELIMINABLE) THEN WRITE(' No');
IF LANG=1 THEN WRITELN(' elimination des objets aberrants.')
          ELSE WRITELN(' elimination of singletons.');WRITELN;
IF LANG=1 THEN WRITELN(' LARGEUR DE VOTRE TERMINAL, EN N. DE COLONNES?')
          ELSE WRITELN(' WIDTH OF YOUR TERMINAL, IN N. OF COLUMNS ?  ');
READLN(LIMCAR);WRITELN;
IF LANG=1
 THEN WRITELN(' DESIREZ-VOUS LES TESTS A POSTERIORI (O ou N) ? ')
 ELSE WRITELN(' DO YOU WANT THE A POSTERIORI COMPUTATIONS (Y or N) ? ');
WHILE NOT (INPUT@ IN ['0','O','o','Y','y','N','n']) DO GET(INPUT);
POSTERIORI:=INPUT@ IN ['0','O','o','Y','y']; READLN;
WRITELN;WRITELN;
IF LANG=1 THEN BEGIN
WRITELN(' H  est  la probabilite  que  l''hypothese  principale  soit');
WRITELN(' vraie.  Selon celle-ci,  les deux groupes  soumis  au test');
WRITELN(' sont un artefact  et devraient  etre fusionnes  en un seul');
WRITELN(' groupe. La fusion est accomplie si H est plus eleve que le');
WRITELN(' seuil de probabilite ALPHA etabli plus haut par l''usager. ');
END ELSE BEGIN
WRITELN('  H is the probability that the null hypothesis is true. The');
WRITELN('  null hypothesis says that the two groups being tested  are');
WRITELN('  an artifact and should be fused in a single group.  Fusion');
WRITELN('  occurs if H is larger than the probability level ALPHA set');
WRITELN('  by the user (above). ');
END; WRITELN;
CALCUL;
ENTETE;
WRITELN;
IF LANG=1 THEN WRITELN(' Fin du programme. ')
          ELSE WRITELN(' End of the program. ');
END.
