program DIST(input,output,entree,sortie);
const degresdecimaux = 0;
      degrespointmin = 1;
      degresspmin = 2;
      degptminptsec = 3;
      degspminspsec = 4;
      degmindec = 5;
      radians  = 0;
      degres  = 1;
      noeuds  = 2;
      milles  = 3;
      kilometres = 4;
      epsilon=10e-7;
      rad=57.295779513;       (* 360 / (2 * pi) *)
      LANG=1;               (* Parametre de langue: 1 = francais
                               Language parameter : 2 = English *)
 
(* =====================================================================
Calcul de distances du grand cercle (a la surface de la terre) --
Les fichiers utilises par ce programme sont les suivants:
 
INPUT et OUTPUT: le terminal de l'usager.
ENTREE: Le fichier des coordonnees (lignes = stations, colonnes =
        coordonnees Latitude et Longitude). Le ficher des coordonnees
        doit etre presente de l'une des facons suivantes (Latitude
        en premier):
        - Degres decimaux;
        - Degres [point] minutes (ex.: 35.04);
        - Degres [espace] minutes (ex.: 35 04);
        - Degres [point] minutes [point] secondes (ex.: 35.04.05);
        - Degres [espace] minutes [espace] secondes (ex.: 35 04 05).
        Notez par ailleurs que si les points chevauchent le 0 degre de
        longitude, les longitudes a l'ouest de Greenwich peuvent etre
        presentees soit avec un signe negatif (-), soit sur 360 degres.
        La latitude des points au sud de l'Equateur doit etre
        presentee avec un signe negatif (-). Evidemment, si tous les
        points sont a l'ouest de Greenwich, ou encore dans l'hemisphere
        sud, le signe devient inutile.
SORTIE: Le fichier qui recevra la matrice de distances, en ASCII. Pour
        en faire une matrice binaire de type SIMIL il faudra transformer
        cette matrice a l'aide de SPSSIM (versions "mainframe") ou de
        IMPORT-EXPORT (version Macintosh). Les distances peuvent etre
        exprimees de l'une ou l'autre des facons suivantes: en radians,
        en degres, en milles marins (ou minutes d'arc), en milles ou en
        kilometres, selon le bon plaisir de l'usager.
 
========================================================================
Computing Great Circle Distances (along the earth's curvature) --
The files used by this program are as follows:
 
INPUT and OUTPUT are connected to the user's terminal.
ENTREE: The file of coordinates (lines = stations, columns = Latitude
        and Longitude). The coordinates must be presented in one of the
        following formats (with Latitude first):
        - Decimal degrees;
        - Degrees [period] minutes (ex.: 35.04);
        - Degrees [blank] minutes (ex.: 35 04);
        - Degrees [period] minutes [period] seconds (ex.: 35.04.05);
        - Degrees [blank] minutes [blank] seconds (ex.: 35 04 05);
        Please notice that if points overlap the 0 degree latitude
        coordinate, the points located west of Greenwich can be
        coded either with a minus sign (0), or on the 360-degree
        system. Similarly, points south of the Equator must receive
        a longitude with a minus sign (-). Of course, if all points
        are located west of Greenwich, or south of the Equator, the
        sign becomes unnecessary.
SORTIE: The file that will receive the distance matrix in ASCII. To
        produce a SIMIL-type binary matrix, SORTIE has to be transformed
        using SPSSIM on mainframes, or IMPORT-EXPORT on a Macintosh. The
        distances can be expressed either in radians, in degrees, in
        nautical miles (or minutes of arc), in miles, or in kilometers,
        at the user's choice.
 
===================================================================== *)
 
type coordtype=array[1..3000] of double;
var entree,sortie:text;
    nobj,distance:integer;
    degminsec:set of 0..4;
    coordx,coordy:@coordtype;
    points,seconde,decimal,mindecimal:boolean;
    degconv,noeudconv,milconv,kilconv:double;
 
 
procedure erreur(i,j:integer);
begin
 if lang=1 then begin
   writeln(' erreur fatale ');
   write  (' objet: ',j,' ');
   case i of
   1:writeln(' caractere non valide (point attendu)');
   2:writeln(' caractere non valide (espace attendu)');
   end;
 end else begin
   writeln(' fatal error ');
   write  (' object: ',j,' ');
   case i of
   1:writeln(' invalid character (period expected)');
   2:writeln(' invalid character (space expected)');
   end;
 end;
end;
 
function distangle(lat1,lon1,lat2,lon2:double):double;
begin
lon1:=lon2-lon1;
lat1:=(sin(lat1)*sin(lat2)+cos(lat1)*cos(lat2)*cos(lon1));
if abs(lat1) > epsilon then
 begin
 lat2:=arctan(sqrt(1-lat1*lat1)/lat1);
 if lat1 < -epsilon then lat2:=3.1415926535+lat2;
 case distance of
  radians:distangle:=lat2;
  degres:distangle:=lat2*degconv;
  noeuds:distangle:=lat2*noeudconv;
  milles:distangle:=lat2*milconv;
  kilometres:distangle:=lat2*kilconv;
  end;
 end
else
 case distance of
  radians:distangle:=1.5708;
  degres:distangle:=90;
  noeuds:distangle:=5400;
  milles:distangle:=6218.64;
  kilometres:distangle:=10006.2;
  end;
end; (* distangle *)
 
function fraction(i:integer;point:boolean):double;
var j:integer;
    car:char;
begin
read(entree,car);
if point then
 begin
 if car <> '.' then erreur(1,i);
 end
else if car <> ' ' then erreur(2,i);
read(entree,j);
fraction:=j;
end;
 procedure lecture(var coordx,coordy:coordtype);
 var i,j,xi,yi:integer;
     x,y:double;
 begin
 reset(entree);
 if lang=1 then begin
 writeln(' nombre de points ');readln(nobj);
 writeln(' type d''entree:');
 writeln('   0: degres decimaux       (ex.: 35.07)');
 writeln('   1: degres POINT minutes  (ex.: 35.04)');
 writeln('   2: degres ESPACE minutes (ex.: 35 04)');
 writeln('   3: degres POINT minutes POINT secondes   (ex.: 35.04.05)');
 writeln('   4: degres ESPACE minutes ESPACE secondes (ex.: 35 04 05)');
 writeln('   5: degres ESPACE minutes decimales       (ex.: 35 04.08)');
 end else begin
 writeln(' number of points ');readln(nobj);
 writeln(' input format:');
 writeln('   0: decimal degrees        (ex.: 35.07)');
 writeln('   1: degrees PERIOD minutes (ex.: 35.04)');
 writeln('   2: degrees SPACE minutes  (ex.: 35 04)');
 writeln('   3: degrees PERIOD minutes PERIOD seconds (ex.: 35.04.05)');
 writeln('   4: degrees SPACE minutes SPACE seconds   (ex.: 35 04 05)');
 writeln('   5: degrees SPACE decimal minutes         (ex.: 35 04.08)');
 end;
 readln(i);
 points:=i in [degrespointmin,degptminptsec];
 seconde:= i in [degptminptsec,degspminspsec];
 decimal:=i=degresdecimaux;
 mindecimal:=i=degmindec;
 if lang=1 then begin
 writeln(' type de sortie:');
 writeln('    0: distances en radians');
 writeln('    1: distances en degres');
 writeln('    2: distances en milles marins (ou minutes d''arc)');
 writeln('    3: distances en milles');
 writeln('    4: distances en kilometres');
 end else begin
 writeln(' Type of output:');
 writeln('    0: distances in radians');
 writeln('    1: distances in degrees');
 writeln('    2: distances in nautical miles (or minutes of arc)');
 writeln('    3: distances in miles');
 writeln('    4: distances in kilometres');
 end;
 readln(distance);
  degconv:=rad/60;
  noeudconv:=60*rad;
  milconv:=rad*1.1516*60;
  kilconv:=1.853*60*rad;
 for i:=1 to nobj do
  begin
  if mindecimal then
     begin
     read(entree,xi,x,yi,y);
     x:=xi+x/60.0;
     y:=yi+y/60.0;
     end
  else if decimal then read(entree,x,y)
  else
   begin
   read(entree,xi);
   x:=xi+fraction(i,points)/60.0;
   if seconde then x:=x+fraction(i,points)/3600.0;
   while (entree@ =' ')and(not(eof(entree))) do get(entree);
   read(entree,yi);
   y:=yi+fraction(i,points)/60.0;
   if seconde then y:=y+fraction(i,points)/3600.0;
   end;
   coordx[i]:=x/rad;
   coordy[i]:=y/rad;
  end;
 rewrite(sortie);
 for i:=1 to nobj do
  begin
  for j:=1 to nobj do
   begin
   x:=distangle(coordx[i],coordy[i],coordx[j],coordy[j]);
   if x >= 10000.0 then write(sortie,x:9) else write(sortie,x:9:3);
   write(sortie,' ');
   if j mod 8=0 then writeln(sortie);
   end;
  if nobj mod 8 <>0 then writeln(sortie);
  end;
 end; (* lecture *)
 
begin (* prog princ *)
if lang=1 then begin
writeln(' Programme de calcul de distances geographiques');
writeln(' par A. Vaudor');
end else begin
writeln(' Program for computing geographic distances');
writeln(' by A. Vaudor');
end;
writeln(' Departement de sciences biologiques, Universite de Montreal');
writeln(' C.P. 6128, Succursale A, Montreal, Quebec, Canada H3C 3J7.');
writeln;
new(coordx);
new(coordy);
lecture(coordx@,coordy@);
dispose(coordx);
dispose(coordy);
if lang=1 then writeln(' Fin du programme.')
          else writeln(' End of the program.');
end.
