PROGRAM INTERLNK(INPUT,ENTREEB,SORTIEP,FICHTRI,OUTPUT);
(* ================================================================== *)
(*     ENTREEB is the input SIMIL file.                               *)
(*     SORTIEP is the main output file from this program. It contains *)
(*             the clustering structure (in binary form). It is       *)
(*             passed to program DENDRO, that draws the dendrogram.   *)
(*     FICHTRI contains the similarity file, after sorting in order   *)
(*             of decreasing similarities by program SORTRI.          *)
(*     SORTIEC is an output file, that may contain details on the     *)
(*             clustering steps if the user asks for it. It was       *)
(*             used during the writing and debugging of the program.  *)
(*             This facility was disabled in this version, by removing*)
(*             all WRITELN(SORTIEC) statements (placed in parentheses)*)
(*     INPUT and OUTPUT are the user's terminal.                      *)
(* ================================================================== *)
LABEL 77;
CONST MAXGROUPES=280;
  MAXDIM=512;
  MAXOBJ=1024;           (* =2*MAXDIM , FOR FILE SORTIEP *)
  MAXREEL=140;           (* =SQRT(MAXGROUPES*MAXGROUPES/STORAGE INDEX *)
  FACTMULT=16384;
  NBCAR=10;
  LANG=1;                (* PARAMETRE DE LANGUE: 1 = FRANCAIS
                            LANGUAGE PARAMETER:  2 = ENGLISH  *)
TYPE DATA=RECORD
          RE:  REAL;
          INT:  INTEGER;
          END;


  MULTIPLE=RECORD CASE INTEGER OF
          1:(INT:INTEGER);
          2:(RE:REAL);
          3:(MATCAR:PACKED ARRAY[1..NBCAR] OF CHAR);
          END;


  NOEUDTYPE=RECORD
            VALEUR:  REAL;
            PTRGAUCHE,PTRDROIT:  INTEGER;
            END;
  COMPACT=0..32767 ;     (* =15 BITS; STORAGE INDEX=60/NB BITS;ICI=4 *)
  MAT1=ARRAY[1..MAXOBJ]OF COMPACT;
  MAT2=PACKED ARRAY[0..MAXGROUPES] OF COMPACT;
  MAT3=RECORD CASE BOOLEAN OF
     TRUE: (INT1: PACKED ARRAY[2..MAXGROUPES,1..MAXGROUPES] OF COMPACT);
     FALSE: (RE1:  ARRAY[1..MAXREEL,1..MAXREEL] OF REAL);
     END;
  MAT4=ARRAY[1..MAXGROUPES]OF INTEGER;
VAR COMPTEUR,NOBJ,GROUPE1,GROUPE2,NBGROUPES,INT1,INT2,CLASSE:  INTEGER;
    CRITERE,SUMSIM:  REAL;
    NOEUD:  NOEUDTYPE;
    FUSION,TROUVE1,TROUVE2:  BOOLEAN;
    MATOBJ:  MAT1;
    MATPTR:  MAT2;
    MATADRESSES:  MAT4;
    MATCARDLIENS:  MAT3;
    ENTREEB:  FILE OF MULTIPLE;
    SORTIEP:  FILE OF NOEUDTYPE;
(*  SORTIEC: TEXT; *)
    FICHTRI:  FILE OF DATA;

PROCEDURE CALCUL;
LABEL 777;
VAR I,J,K,NBTROUVE,NOBJ,LIMABS,OBJET,GRP:  INTEGER;
    DONNEE:  DATA;

PROCEDURE COMPACTEMAT(GROUPE1,GROUPE2: INTEGER);
VAR I,J,NBGROUP1:  INTEGER;
    Z: REAL;
BEGIN
NBGROUP1:=NBGROUPES-1;
WITH MATCARDLIENS DO
   CASE CLASSE OF
      1:  BEGIN
         FOR I:=1 TO GROUPE2-1 DO
               BEGIN
               J:=INT1[GROUPE1,I];
               INT1[GROUPE2,I]:=INT1[GROUPE2,I]+J;
               END;
         FOR I:=GROUPE2+1 TO GROUPE1-1 DO
               BEGIN
               J:=INT1[GROUPE1,I];
               INT1[I,GROUPE2]:=INT1[I,GROUPE2]+J;
               END;
         FOR I:=GROUPE1 TO NBGROUPES DO
               BEGIN
               J:=INT1[I,GROUPE1];
               INT1[I,GROUPE2]:=INT1[I,GROUPE2]+J;
               END;
         FOR I:=GROUPE1 TO NBGROUP1 DO
               BEGIN
               FOR J:=1 TO GROUPE1-1 DO INT1[I,J]:=INT1[I+1,J];
               FOR J:=GROUPE1 TO I-1 DO INT1[I,J]:=
                                                    INT1[I+1,J+1];
               END;
         FOR I:= 1 TO NBGROUP1 DO
               BEGIN
               INT1[I+1,NBGROUP1]:=0;
               INT1[NBGROUPES,I]:=0;
               END;
         END;
      2,3:  BEGIN
         FOR I:=1 TO GROUPE2-1 DO
               RE1[GROUPE2,I]:=RE1[GROUPE2,I]
                                           +RE1[GROUPE1,I];
         FOR I:=GROUPE2+1 TO GROUPE1-1 DO
               RE1[I,GROUPE2]:=RE1[I,GROUPE2]
                                           +RE1[GROUPE1,I];
         FOR I:=GROUPE1 TO NBGROUPES DO
               RE1[I,GROUPE2]:=RE1[I,GROUPE2]
                                           +RE1[I,GROUPE1];
         FOR I:=GROUPE1 TO NBGROUP1 DO
               BEGIN
               FOR J:=1 TO GROUPE1-1 DO RE1[I,J]:=RE1[I+1,J];
               FOR J:=GROUPE1 TO I-1 DO RE1[I,J]:=
                                                    RE1[I+1,J+1];
               END;
         FOR I:= 1 TO NBGROUP1 DO
               BEGIN
               RE1[I+1,NBGROUP1]:=0;
               RE1[NBGROUPES,I]:=0;
               END;
         END;
      END;
END;                    (* FIN COMPACTEMAT *)

PROCEDURE PIVOTE(PTR1,PTR2: INTEGER);
VAR I,J,K: INTEGER;
BEGIN
WITH MATCARDLIENS DO FOR I:=PTR1 TO PTR2 DO
      BEGIN
      NBGROUPES:=NBGROUPES+1;
      MATOBJ[LIMABS+1]:=MATOBJ[MATPTR[PTR1]];
      FOR J:=MATPTR[PTR1] TO LIMABS DO MATOBJ[J]:=MATOBJ[J+1];
      (* ICI REMPLACER LES ELEMENTS DE MATRICE *)
      CASE CLASSE OF
         1:  BEGIN
            FOR J:=1 TO PTR1-1 DO
                  BEGIN
                  INT1[NBGROUPES,J]:=INT1[PTR1,J];
                  INT1[PTR1,J]:=0;
                  END;
            FOR J:=PTR1+1 TO NBGROUPES-1 DO
                  BEGIN
                  INT1[NBGROUPES,J]:=INT1[J,PTR1];
                  INT1[PTR1,J]:=0;
                  END;
            END;
         2,3:  BEGIN
            FOR J:=1 TO PTR1-1 DO
                  BEGIN
                  RE1[NBGROUPES,J]:=RE1[PTR1,J];
                  RE1[PTR1,J]:=0;
                  END;
            FOR J:=PTR1+1 TO NBGROUPES-1 DO
                  BEGIN
                  RE1[NBGROUPES,J]:=RE1[J,PTR1];
                  RE1[PTR1,J]:=0;
                  END;
            END;
         END;
      COMPACTEMAT(PTR1+1,PTR1);
      NBGROUPES:=NBGROUPES-1;
      IF CLASSE=3 THEN
            BEGIN
            RE1[1,NBGROUPES]:=RE1[1,PTR1];
            FOR J:=I TO NBGROUPES-1 DO RE1[1,J]:=
                                       RE1[1,J+1];
            END;
      FOR J:=PTR1 TO NBGROUPES-1 DO MATPTR[J]:=MATPTR[J+1]-1;
      END;
END;

PROCEDURE ECRITGROUPES(GROUPE1,GROUPE2:  INTEGER);
VAR I,J,COMPTR1,COMPTR2,LIMG,LIMD:  INTEGER;
   PROCEDURE POINTE(VAR VAL:  INTEGER);
   BEGIN
   IF VAL=I THEN VAL:=COMPTR1;
   END;

BEGIN
(* IF LANG=1 THEN WRITELN(SORTIEC,' NIVEAU:  ',DONNEE.RE:  10:  5)
          ELSE WRITELN(SORTIEC,' LEVEL :  ',DONNEE.RE:  10:  5);
WRITELN(SORTIEC); *)
COMPTR1:=0;
FOR I:=1 TO NBGROUPES DO
      BEGIN
      LIMG:=MATPTR[I-1]+1;
      LIMD:=MATPTR[I];
      IF LIMD-LIMG>0 THEN
            BEGIN
            COMPTR2:=0;
            COMPTR1:=COMPTR1+1;
            POINTE(GRP);
            POINTE(GROUPE1);
            POINTE(GROUPE2);
(*          IF LANG=1 THEN WRITELN(SORTIEC,'    GROUPE',COMPTR1:  3)
                      ELSE WRITELN(SORTIEC,'    GROUP ',COMPTR1:  3);
            WRITE(SORTIEC,'   '); *)
            FOR J:=LIMG TO LIMD DO
                  BEGIN
(*                WRITE(SORTIEC,MATOBJ[J]:  4); *)
                  COMPTR2:=COMPTR2+1;
(*                IF COMPTR2 MOD 20=0 THEN WRITELN(SORTIEC); *)
                  END;
(*          WRITELN(SORTIEC);WRITELN(SORTIEC); *)
            END;
      END;
WITH NOEUD DO
      BEGIN
      COMPTEUR:=COMPTEUR+1;
      VALEUR:=DONNEE.RE;
      IF OBJET>0 THEN
            BEGIN
            PTRDROIT:=OBJET;
            PTRGAUCHE:=MATADRESSES[GRP];
            MATADRESSES[GRP]:=COMPTEUR;
(* IF LANG=1 THEN
   WRITELN(SORTIEC,'    L OBJET',OBJET: 3,'A REJOINT LE GROUPE',GRP: 3)
ELSE
 WRITELN(SORTIEC,'    OBJECT ',OBJET: 3,'HAS JOINED GROUP   ',GRP: 3);*)
            END
      ELSE IF ((NBTROUVE=2)AND(OBJET=0)) THEN
            BEGIN
            PTRDROIT:=MATADRESSES[GROUPE1];
            PTRGAUCHE:=MATADRESSES[GROUPE2];
            FOR J:=GROUPE1 TO NBGROUPES DO 
                 MATADRESSES[J]:=MATADRESSES[J+1];
            MATADRESSES[GROUPE2]:=COMPTEUR;
(*          IF LANG=1 THEN WRITELN(SORTIEC,'      LE GROUPE',GROUPE1:3,
                            ' A FUSIONNE AVEC LE GROUPE',GROUPE2:  3)
                      ELSE WRITELN(SORTIEC,'      GROUP    ',GROUPE1:3,
                            ' HAS FUSED WITH GROUP     ',GROUPE2:  3);*)
            END
          ELSE
            BEGIN
            PTRGAUCHE:=INT1;
            PTRDROIT:=INT2;
            MATADRESSES[GROUPE2]:=COMPTEUR;
            END;
      END;
SORTIEP@:=NOEUD;PUT(SORTIEP);
(* WRITELN(SORTIEC);WRITELN(SORTIEC);WRITELN(SORTIEC); *)
                (* ON REGADE S IL Y A DES GROUPES DE CARDINALITE=1 *)
                (* ET, LE CAS ECHEANT ON VA LES PLACER A LA FIN DE *)
                (* LA LISTE D OBJETS                               *)
I:=1;J:=1;
WHILE ((I<=NBGROUPES)AND(J<=NBGROUPES)) DO
      BEGIN
      WHILE ((MATPTR[I]-MATPTR[I-1]>1)AND(I<=NBGROUPES)) DO I:=I+1;
      J:=I+1;
      WHILE ((MATPTR[J]-MATPTR[J-1]=1)AND(I<=NBGROUPES)) DO J:=J+1;
      IF J<=NBGROUPES THEN PIVOTE(I,J-1);
     END;
END;

PROCEDURE INCLUSION(INT:  INTEGER;VAR GROUPE:  INTEGER;VAR TROUVE:
  BOOLEAN);
VAR I:  INTEGER;
BEGIN
GROUPE:=1;
TROUVE:=FALSE;
I:=0;
REPEAT
      REPEAT
      I:=I+1;
      UNTIL (MATOBJ[I]=INT)OR(I>=MATPTR[GROUPE]);
IF MATOBJ[I]=INT THEN BEGIN TROUVE:=TRUE;NBTROUVE:=NBTROUVE+1;END;
GROUPE:=GROUPE+1;
UNTIL (TROUVE) OR(GROUPE>NBGROUPES);
GROUPE:=GROUPE-1;
END;                 (* FIN INCLUSION *)


PROCEDURE FUSIONNE;
VAR I,J,LIMD1,LIMG2,LIMD2,CARD1,CARD2:  INTEGER;
BEGIN
FUSION:=TRUE;
IF CLASSE=3 THEN WITH MATCARDLIENS DO
      BEGIN
      RE1[1,GROUPE2]:=RE1[1,GROUPE2]
                                  +RE1[1,GROUPE1]
                                  +RE1[GROUPE1,GROUPE2];
      FOR I:=GROUPE2+1 TO GROUPE1-1 DO RE1[1,I]:=RE1[1,I+1];
      RE1[1,GROUPE1]:=0;
      END;
COMPACTEMAT(GROUPE1,GROUPE2);
LIMD2:=MATPTR[GROUPE1];
LIMG2:=MATPTR[GROUPE1-1];
CARD2:=LIMD2-LIMG2;
LIMD1:=MATPTR[GROUPE2];
CARD1:=LIMD1-MATPTR[GROUPE2-1];
IF ((CARD1=1)AND(CARD2>1)) THEN
      BEGIN
      OBJET:=MATOBJ[LIMD1];
      GRP:=GROUPE1;
      END
ELSE IF ((CARD1>1)AND(CARD2=1)) THEN
      BEGIN
      OBJET:=MATOBJ[LIMD2];
      GRP:=GROUPE2;
      END
   ELSE IF ((CARD1=1)AND(CARD2=1)) THEN OBJET:=-1;
FOR I:=1 TO CARD2 DO MATOBJ[I+LIMABS]:=MATOBJ[I+LIMG2];
FOR I:=LIMD2 DOWNTO LIMD1+CARD2 DO MATOBJ[I]:=MATOBJ[I-CARD2];
FOR I:=1 TO CARD2 DO MATOBJ[LIMD1+I]:=MATOBJ[LIMABS+I];
FOR I:=GROUPE2 TO GROUPE1-1 DO MATPTR[I]:=MATPTR[I]+CARD2;
NBGROUPES:=NBGROUPES-1;
FOR I:=GROUPE1 TO NBGROUPES DO MATPTR[I]:=MATPTR[I+1];
END;

PROCEDURE CREATION(INT:  INTEGER;VAR GROUPE:  INTEGER);
BEGIN
LIMABS:=LIMABS+1;
MATOBJ[LIMABS]:=INT;
MATPTR[NBGROUPES]:=LIMABS;
GROUPE:=NBGROUPES;
END;

BEGIN                (* DEBUT CALCUL *)
COMPTEUR:=MAXDIM;
LIMABS:=0;
NBGROUPES:=0;
MATOBJ[1]:=0;
MATPTR[1]:=0;
RESET(ENTREEB);
(* REWRITE(SORTIEC); *)
RESET(FICHTRI);
NOBJ:=ENTREEB@.INT;
WITH MATCARDLIENS DO
      CASE CLASSE OF
            1:FOR I:=2 TO NOBJ DO
                 FOR J:=1 TO NOBJ DO INT1[I,J]:=0;
            2:FOR I:=2 TO NOBJ DO
                   FOR J:=1 TO NOBJ DO RE1[I,J]:=0;
            3:FOR I:=1 TO NOBJ DO
                 FOR J:=1 TO NOBJ DO RE1[I,J]:=0;
            END;
MATPTR[0]:=0;
NOBJ:=NOBJ*(NOBJ-1) DIV 2;
IF FICHTRI@.RE >1 THEN
      BEGIN
      IF LANG=1 THEN WRITELN(' ERREUR FATALE: SIMILARITE > 1')
                ELSE WRITELN(' FATAL ERROR: SIMILARITY > 1');
      GOTO 77;
      END;
FOR I:=1 TO NOBJ DO
      BEGIN
      FUSION:=FALSE;
      NBTROUVE:=0;
      OBJET:=0;
      DONNEE:=FICHTRI@;GET(FICHTRI);
      WITH DONNEE DO
            BEGIN
            INT1:=INT DIV FACTMULT;
            INT2:=INT MOD FACTMULT;
            END;
      INCLUSION(INT1,GROUPE1,TROUVE1);
      INCLUSION(INT2,GROUPE2,TROUVE2);
      IF NOT((TROUVE1)AND(TROUVE2)) THEN
            BEGIN
            NBGROUPES:=NBGROUPES+1;
            IF NOT TROUVE1 THEN CREATION(INT1,GROUPE1);
            IF NOT TROUVE2 THEN CREATION(INT2,GROUPE2);
            END;
      IF (GROUPE1<>GROUPE2) THEN
            BEGIN
            J:=MATPTR[GROUPE1];
            K:=MATPTR[GROUPE2];
            J:=J-MATPTR[GROUPE1-1];
            K:=(K-MATPTR[GROUPE2-1])*J;
            IF GROUPE1<GROUPE2 THEN
                  BEGIN
                  J:=GROUPE2;
                  GROUPE2:=GROUPE1;
                  GROUPE1:=J;
                  END;
            IF NBTROUVE>0 THEN WITH MATCARDLIENS DO CASE CLASSE OF
                  1:  BEGIN
                     INT1[GROUPE1,GROUPE2]:=
                                 INT1[GROUPE1,GROUPE2]+1;
                     IF INT1[GROUPE1,GROUPE2]>=K*CRITERE-10E-30 THEN
 FUSIONNE;
                     END;
                  2:  BEGIN
                     RE1[GROUPE1,GROUPE2]:=
                               RE1[GROUPE1,GROUPE2]+DONNEE.RE;
                     IF RE1[GROUPE1,GROUPE2]>SUMSIM THEN FUSIONNE;
                     END;
                  3:  BEGIN
                     IF DONNEE.RE<=0 THEN GOTO 777;
                     RE1[GROUPE1,GROUPE2]:=
                     RE1[GROUPE1,GROUPE2]+DONNEE.RE;
                     IF RE1[GROUPE1,GROUPE2]/((RE1[GROUPE1,GROUPE2]
                           +RE1[1,GROUPE1]+RE1[1,GROUPE2])
                           *(MATPTR[GROUPE1]+MATPTR[GROUPE2]
                           -MATPTR[GROUPE1-1]-MATPTR[GROUPE2-1]))
                           >SUMSIM THEN FUSIONNE;
                      END;
                  END;
            END
      ELSE IF CLASSE=3 THEN MATCARDLIENS.RE1[1,GROUPE1]:=
                            MATCARDLIENS.RE1[1,GROUPE1]+DONNEE.RE;
      IF ((FUSION)OR(NBTROUVE=0)) THEN ECRITGROUPES(GROUPE1,GROUPE2);
      END;
777: NOEUD.VALEUR:=DONNEE.RE;
SORTIEP@:=NOEUD;PUT(SORTIEP);   (* PARAMETRE POUR LE DENDOGRAMME *)
END;

BEGIN  (* PROG PRINC *)
WRITELN;
IF LANG=1 THEN BEGIN
WRITELN(' P R O G R A M M E  I N T E R L N K');
WRITELN(' pour groupement a liaison proportionnelle.');
WRITELN(' Version 2.1b (Modifie pour 3.0)');
WRITELN(' Author: A. VAUDOR');END
ELSE BEGIN
WRITELN(' P R O G R A M   I N T E R L N K ');
WRITELN(' for intermediate-link linkage agglomerative clustering.');
WRITELN(' VERSION 2.1b (Modified for SIMIL 3.0)');
WRITELN(' Author: A. VAUDOR');END;
WRITELN;
CLASSE:=0;
SUMSIM:=0;
CLASSE:=1;
REPEAT
    IF LANG=1 THEN WRITELN(' PROPORTION DES LIENS (Connexite) ?    ')
    ELSE WRITELN(' CONNECTEDNESS ? ');
    READLN(CRITERE);
UNTIL (CRITERE>=0)AND(CRITERE<=1.0);
REWRITE(SORTIEP);
CALCUL;
77:IF LANG=1 THEN WRITELN(' Fin du groupement.')
             ELSE WRITELN(' End of the clustering.');
END.
