Program Mantel3(input,output,entreec,entree1,entree2,entree3); 
label 777;
const   maxnobj=1000;      (* Maximum number of objects               *) 
        petitnobj=200;     (* If nobj > petitnobj, the permutation    *) 
                           (* test is not performed  with option 0,   *) 
                           (* and the program stops with the other    *)
                           (* options. Make sure that MAXNOBJ is      *)
                           (* larger than or equal to PETITNOBJ.      *)
        nbmotssimil=1;     (* Parameter NBMOTS from program "simil"   *) 
        nbcar=10;
        rad=57.295779513;  (* 360 / (2  * pi)                         *) 
        epsilon=10e-7;
        maxreel=1.70E38;   (* Largest real number: use 10e73 for IBM, *)
                           (* 10E320 for Control Data, 1.7E38 for VAX *)
        nooption=0; 
        dow=1;
        smouse=2;
        hubert=3;
        lang=1;            (* Parametre de langue: 1=Francais 
                              language parameter : 2=English          *) 

(* ================================================================== *)
(* Purpose of the program:                                            *)
(*   - Mantel test, using both the random permutation procedure       *)
(*     and the asymptotic t-test. The raw z statistic printed by this *)
(*     program is one half that of Mantel (1967), but the t statistic *)
(*     as well as Hubert's standardization are computed as if the     *)
(*     matrices were square (the results have been checked). If the   *)
(*     user wishes to get only the approximate t-test, he should tell *)
(*     the program to compute zero (0) permutations.                  *)
(*   - This version of the program computes either the usual Mantel   *)
(*     statistic, or the normalized Mantel statistic [-1 <= z* <= 1], *)
(*     as suggested by Smouse, Long and Sokal.                        *)
(*   - The Hubert standardization of z is computed using the minimum  *)
(*     and maximum values obtaines during the permutations.           *)
(*   - This program can also compute partial Mantel tests, using the  *)
(*     method of Dow & Cheverud (Am. J. Phys. Anthropol. 68: 367-373, *)
(*     1985); the methods of Smouse, Long & Sokal (Syst. Zool. 35:    *)
(*     627-632, 1987); or the method of Hubert (Psychometrika 50:     *)
(*     449-467, 1985). These options are available only when there    *)
(*     are fewer objects than "PETITNOBJ" (line 4 of the program).    *)
(*   - Geographic distances (D) can be transformed into 1/D or        *)
(*     1/(D**2). This, however, is available only with options 1, 3   *)
(*     and 4, where the distances are computed by the program itself. *)
(*   - This program contains an option that enables the user to ask   *)
(*     for permutations limited to within subgroups of objects (Sokal,*)
(*     Lengyel, Derish, Wooten & Oden. Journal of Archaeological      *)
(*     Science 14: 615-633, 1987). The user indicates how many groups *)
(*     there are, when he receives the question                       *)
(*               "Number of groups to permute ?"                      *)
(*     She is also asked to list the object numbers that are members  *)
(*     of each subgroup. Object numbers can be listed one by one, or  *)
(*     blocks of objects can be described with a dash; for example:   *)
(*                1 4 7 9-32 38 67      would be a valid answer.      *)
(*   - Finally this program can be used, to compute Mantel            *)
(*     correlograms (Oden & Sokal. Syst. Zool. 35: 608-617, 1986).    *)
(*     Correlograms can be computed using the usual two-matrix Mantel *)
(*     test (computation type 0), or any of the partial Mantel tests  *)
(*     (computation types 1 to 3). Notice that the Mantel correlogram *)
(*     produces negative values of z in the small distance classes,   *)
(*     when there is positive autocorrelation.                        *)
(* Check and change the program parameters (above) before compiling.  *)
(*     This program uses an internal random number generator.         *)
(* How to read the permutation probabilities ?                        *)
(*     Contrary to previous versions of this program, one-tail        *)
(*     probabilities of the null hypothesis to be true are provided,  *)
(*     so that typically, probabilities smaller than 0.05 may be      *)
(*     considered significant. Whether we are in the right or the     *)
(*     left-hand tail can be judged either from the sign of the Mantel*)
(*     statistic, or by looking at the distribution of permutation    *)
(*     results (ST, EQ, GT). The true value is added to the "EQuals", *)
(*     following Hope (J. Roy. Stat. Soc. Ser. B 30: 582-598, 1968).  *)
(*     Example: if the permutation probability is 0.05 then           *)
(*              p(H0) < 0.05 , one-tail test.                         *)
(*     The precision of this probability is always the inverse of     *)
(*     the number of permutations selected by the user.               *)
(* ================================================================== *)
(* The program computes the following equations when UNSTANDARDIZED   *)
(* Mantel statistics are requested:                                   *)
(* Simple Mantel (NOOPTION): Sum ( a(ij) * b(ij) )                    *)
(* Dow and Cheverud (DOW): Sum ( a(ij) * (b-stand(ij) - c-stand(ij))  *)
(* Smouse Long & Sokal (SMOUSE): partial correlation of               *)
(*    A-stand and B-stand, controlling for C-stand                    *)
(* Hubert (HUBERT): Sum ( a(ij) * b(ij) * c(ij) )                     *)
(*                                                                    *)
(* The following equations are computed when STANDARDIZED Mantel      *)
(* statistics are requested:                                          *)
(* Simple Mantel (NOOPTION): Sum (a-stand(ij) * b-stand(ij)) / (n-1)  *)
(* Dow and Cheverud (DOW):                                            *)
(*    Sum (a-stand(ij) * (b-stand(ij) - c-stand(ij))stand) / (n-1)    *)
(* Smouse Long & Sokal (SMOUSE): partial correlation of               *)
(*    A-stand and B-stand, controlling for C-stand                    *)
(* Hubert (HUBERT): Sum (a-stand(ij) * (b(ij) * c(ij))stand) / (n-1)  *)
(*                                                                    *)
(* n is the number of distances in the half-matrix,                   *)
(* while A-stand refers to the half-matrix of standardized distances  *)
(* obtained by subtracting the mean of the distances and dividing by  *)
(* their standard deviation.                                          *)
(* ================================================================== *)
(* Files:                                                             *)
(*     Input and Output are connected to the user's terminal.         *)
(*     Entreec is a file containing the coordinates of each object.   *)
(*        It is to be used only with options 3 and 4.                 *)
(*     Entree1, Entree2 and Entree3 are (or: can be) "simil"          *)
(*        DISTANCE matrices. If similarity matrices are used instead, *)
(*        one has to be careful when interpreting the results.        *)
(*     To compute a normal, two-matrix Mantel test,                   *)
(*      - the first file is a "simil" file called Entree2.            *)
(*      - the second file is either a "simil" file called Entree1     *)
(*        (option 2), or a file containing "x" and "y" coordinates    *)
(*        (called Entreec, for options 3 or 4). Alternatively, if     *)
(*        the points form a rectangular and regular grid, no second   *)
(*        file is needed (option 1).                                  *)
(*     To compute a partial Mantel test,                              *)
(*        file a = Entree1                                            *)
(*        file b = Entree2                                            *)
(*        file c = Entree3                                            *)
(*      - computation type 1: Dow & Cheverud (a.(b-c)). permutations  *)
(*           on matrix "a".                                           *)
(*      - computation type 2: Smouse Long & Sokal (ab.c). permutation *)
(*           on one of the two matrices of regression residuals,      *)
(*           resulting from the regression of (a on c) and (b on c),  *)
(*           whose correlation gives the partial correlation (ab.c).  *)
(*      - computation type 3: Hubert (a.(bc)). permutations on "a".   *)
(*     To compute a Mantel correlogram (option 0),                    *)
(*      - the distance file is a "simil" file, attached to the job    *)
(*        as Entree2.                                                 *)
(*      - the file containing information as     Example, 6 objects:  *)
(*        to the distance classes is attached      1  1  2  3  3      *)
(*        to the job as file "Entreec". This          1  2  3  3      *)
(*        file must contain an upper triangular          1  2  2      *)
(*        matrix (without diagonal) with 1's,               1  1      *)
(*        2's, 3's, etc. representing the various              1      *)
(*        distance classes. This file can be                          *)
(*        produced by program "Auto2" (output file "Classef") of the  *)
(*        "R" package, or by any other appropriate program, or else   *)
(*        directly by hand using a line or screen editor. If a        *)
(*        distance class "0" is created, it will be skipped by the    *)
(*        Mantel correlogram procedure.                               *)
(* ================================================================== *)
        (* modification 1.01    1 juin 1989 *) 
        (* modification 1.02    5 sept 1990 *)  (* after P.L. and RRS *) 
        (* correction 1.0.01   24 avr  1989 *)
type    dataint=1..3; 
        data=record case dataint of 
                1:(re:real); 
                2:(int:integer);
                3:(car:packed array[1..nbcar] of char); 
                end;
        matint =array[1..petitnobj] of integer;
        matreel=array[1..maxnobj] of real;
        matsym=array[1..petitnobj,1..petitnobj] of real;
        datafile=file of data;
        datareel=file of real;
        alpha=packed array[1..10] of char;
var     nobj,i,j,k,l,m,pp,largeur,option,nbclasses,niveau,ad,total,
        nbgroupes,fich,eq,nbessais:integer; 
        x,zref,zmax,zmin,zz,signe,n,zhubert,probzz:real; 
        mat:matsym; 
        str:alpha; 
        car:char;
        minute,grille,simil,corr,spherique,error,desire,errnonfat:boolean;
        raddr,raddr2:matreel; 
        addr,addr2,groupes:matint;
        entreec:text; 
        entree1,entree2,entree3:datafile; 
        entree4,entree5,entree6:datareel; 

procedure erreur(i,j,k:integer);
begin 
if lang=1 then case i of
        0:writeln(' Distance nulle',j:3,k:3); 
        1:writeln(' Valeur incalculable, matrice sans variation');
        2:writeln
(' Matrice trop grande pour cette option. Changez le parametre petitnobj.');
        3:writeln(' Somme du nombre d''objets des groupes pas egal a',j:3);
        4:writeln(' Objet',j:3,' deja alloue a un autre groupe'); 
        5:writeln(' Matrices de tailles differentes');
        end 
else case i of
        0:writeln(' Distance is zero',j:3,k:3);
        1:writeln(' No variaton in matrix. z cannot be computed.');
        2:writeln
           (' Too many objects for this option. Change parameter petitnobj.'); 
        3:writeln(' Sum of objects of all groups different from',j:3);
        4:writeln(' Object',j:3,' already alloted to another group'); 
        5:writeln(' Matrices of different sizes');
        end;
goto 777; 
end;        (* erreur*) 

Function GGUBFS(VAR DSEED:REAL):REAL;                                           
CONST D2P31M=2147483647.0;                                                      
      D2P31 =2147483648.0;                                                      
VAR A:REAL;                                                                     
BEGIN                                                                           
A:=16807*DSEED;                                                                 
DSEED:=A-TRUNC(A/D2P31M)*D2P31M;                                                
GGUBFS:=DSEED/D2P31;                                                            
END;           (* end of the PASCAL version of GGUBFS, May 1987 *)

procedure valide(var j:integer;liminf,limsup:integer);
var termine:boolean;
begin 
termine:=false; 
repeat
        readln(j);
        if (j >= liminf) and (j <= limsup) then termine:=true 
        else begin 
        if lang=1 then writeln('    s.v.p.',liminf:3,' a ',limsup:3,'   ')
                  else writeln('    please',liminf:3,' to ',limsup:3,'   ');
        end;
until termine;
end;                (* valide *)

function validebool:boolean; 
begin 
while not(input@ in['0','O','o','Y','y','N','n']) do get(input);
validebool:=input@ in['0','O','o','Y','y']; 
readln;
end;

function gauss(x:real):real; 
var y,z,w:real; 
begin 
                        (* reference: cacm                *)
                        (* algorithme: 209                *)
                        (* auteur:d.ibbetson              *)
                        (* titre:gauss                    *)
                        (* traduit en pascal par a.vaudor *)
if x=0 then z:=0
else
        begin 
        y:=abs(x)/2;
        if y>=3 then z:=1 
        else if y<1 then
                begin 
                w:=y*y; 
                z:=((((((((0.000124818987*w 
                -0.001075204047)*w+0.005198775019)*w
                -0.019198292004)*w+0.059054035642)*w
                -0.151968751364)*w+0.319152932694)*w
                -0.531923007300)*w+0.797884560593)*y*2
                end 
            else
                begin 
                y:=y-2; 
                z:=(((((((((((((-0.000045255659*y 
                +0.000152529290)*y-0.000019538132)*y
                -0.000676904986)*y+0.001390604284)*y
                -0.000794620820)*y-0.002034254874)*y
                +0.006549791214)*y-0.010557625006)*y
                +0.011630447319)*y-0.009279453341)*y
                +0.005353579108)*y-0.002141268741)*y
                +0.000535310849)*y+0.999936657524 
                end 
        end;
if x>0 then gauss:=(z+1)/2 else gauss:=(1-z)/2;
end;        (* gauss *) 

procedure liscar;
var i:integer;
    j:real; 

        procedure first;
        begin 
        while not(entreec@ in['0'..'9','-']) do get(entreec); 
        if entreec@='-' then signe:=-1.0 else signe:=1.0;
        read(entreec,j);
        end;

        procedure next(deg:real); 
        var k:real; 
        begin 
        read(entreec,k);
        j:=j+signe*k/deg; 
        end;

begin 
reset(entreec); 
for i:=1 to nobj do 
        begin 
        first;
        if minute then begin next(60); next(3600);end;
        raddr[i]:=j/rad;
        first;
        if minute then begin next(60); next(3600);end;
        raddr2[i]:=j/rad; 
        end;
end;        (* liscar *)

function distangle(lat1,lon1,lat2,lon2:real):real;
begin 
lon1:=lon2-lon1;
lat1:=(sin(lat1)*sin(lat2)+cos(lat1)*cos(lat2)*cos(lon1)); 
if abs(lat1) > epsilon then
        begin 
        lat2:=arctan(sqrt(1-lat1*lat1)/lat1); 
        if lat1 < -epsilon then lat2:=3.1415926535+lat2;
        distangle:=lat2*60*rad; 
        end 
else distangle:=5400; 
end;        (* distangle *)

function distreg(i,j:integer):real; 
begin 
i:=i-1;j:=j-1;
distreg:=sqrt(sqr(i mod largeur - j mod largeur) 
                +sqr(i div largeur -j div largeur));
end;

function nosphere(lat1,lon1,lat2,lon2:real):real; 
begin 
nosphere:=sqrt(sqr(lat1-lat2)+sqr(lon1-lon2));
end;

procedure entete(var entree:datafile); 
var i,j:integer;
    donnee:data;
begin 
reset(entree);
if nobj <> entree@.int then erreur(5,0,0);
get(entree);get(entree);
for i:=1 to 13 do
   for j:=1 to nbmotssimil do get(entree);
donnee:=entree@;
get(entree);
if donnee.int<>0 then 
        for i:=1 to nobj do
                for j:=1 to nbmotssimil do get(entree); 
end;        (* entete *)

procedure fabric;
var i,j,transformation:integer; 
    x:real; 
begin 
if lang=1 then begin
writeln(' Transformation des distances (d) de la seconde matrice:'); 
writeln('    (0) pas de transformations (d)');
writeln('    (1) en l''inverse de la distance, 1/d'); 
writeln('    (2) en l''inverse de la distance au carre, 1/(d**2)');
end else begin
writeln(' Transformation of distances (d) in the second matrix:');
writeln('    (0) no transformation (d)'); 
writeln('    (1) the inverse of the distance, 1/d '); 
writeln('    (2) the inverse of the squared distance, 1/(d**2)'); 
end;
writeln(' ':8); 
valide(transformation,0,2);
rewrite(entree1);
entree1@.int:=nobj; 
put(entree1); 
for i:=1 to 2+13*nbmotssimil do begin entree1@.re:=0;put(entree1);end;
if (not(grille)) then liscar; 
for i:=1 to nobj do 
    for j:=i+1 to nobj do 
        begin 
        if grille then x:=distreg(i,j) 
        else
          begin 
          if spherique
          then x:=distangle(raddr[i],raddr2[i],raddr[j],raddr2[j])
          else x:=nosphere (raddr[i],raddr2[i],raddr[j],raddr2[j]);
          end;
        if x<=epsilon then erreur(0,i,j); 
        with entree1@ do
                case transformation of 
                        0:re:=x;
                        1:re:=1/x;
                        2:re:=1/(x*x); 
                        end; 
        put(entree1); 
        end;
reset(entree1); 
end;   (* fabric *) 

procedure centrereduit
   (var fich1:datafile;var fich2:datareel;corr,classe:boolean); 
var i,j,k:integer; 
    x,sumx,sumx2,moyenne,ecarttype:real;
begin 
sumx:=0;sumx2:=0;
if classe then reset(entreec) 
else entete(fich1); 
for i:=1 to nobj do 
        begin 
        for j:=i+1 to nobj do 
                begin 
                if classe then
                      begin
                      read(entreec,k); 
                      if k > nbclasses then nbclasses:=k;
                      if k=niveau then x:=1 else x:=0;
                      end 
                else
                      begin
                      x:=fich1@.re; 
                      get(fich1); 
                      end;
                sumx:=sumx+x; 
                sumx2:=sumx2+x*x; 
                end;
        end;
moyenne:=sumx/n;
ecarttype:=sqrt(sumx2-sumx*sumx/n); 
(* Notice that this is not really a standard deviation. The "standardized"
variables thus produced should be called pseudo-standardized, because
ECARTTYPE (the "standard deviation") is not divided by (N-1). The pseudo-
standardized variables are too small by a factor of SQRT(N-1), so that when
we compute the Mantel statistic, which is the sum of squares and cross products,
we don't have to divide that sum again by (N-1) in the case of the standardized
Mantel statistic. This is a way of saving some computer time under repeated
permutations.                                                                 *)
if ecarttype<epsilon then error:=true
else
  begin
  rewrite(fich2);
  if classe then reset(entreec) 
  else entete(fich1); 
  for i:=1 to nobj do 
        begin 
        for j:=i+1 to nobj do 
                begin 
                if classe then
                      begin
                      read(entreec,k); 
                      if k= niveau then x:=1 else x:=0; 
                      end 
                else
                       begin 
                      x:=fich1@.re; 
                      get(fich1); 
                      end;
                if corr then fich2@:=(x-moyenne)/ecarttype 
                else fich2@:=x; 
                put(fich2);
                end;
        end;
  end;
end;        (* centrereduit *)

procedure dowcheverud(var mat:matsym); 
var i,j:integer;
begin 
reset(entree6); 
for i:=1 to nobj do 
        begin 
        for j:=i+1 to nobj do 
                begin 
(*               mat[i,j]:=mat[i,j]-entree6@; *)
                mat[i,j]:=(mat[i,j]-entree6@)*sqrt(n-1); (* modification 1.02 *)
                get(entree6); 
                end;
        end;
end;        (* dow and cheverud *)

procedure lecture(var mat:matsym);
var i,j:integer;
    donnee:real;
begin 
reset(entree4);reset(entree5);
for i:=1 to nobj do 
        begin 
        for j:=i+1 to nobj do 
                begin 
                donnee:=entree5@;get(entree5);
                mat[i,j]:=donnee; 
                donnee:=entree4@;get(entree4);
                mat[j,i]:=donnee; 
                end;
        end;
end;        (* lecture *) 

procedure shellsort(var a: matreel;var b:matint;addr,n: integer); 
label 1; 
var i,j,k,l,m,o,w,p: integer; 
    x:real; 
begin 
n:=n-addr;
m:=(2*n-1) div 2;
while m<>0 do 
        begin 
        k:=n-m; 
        for j:=1 to k do
                begin 
                i:=j; 
                while i>=1 do 
                        begin 
                        o:=i+m+addr;
                        p:=i+addr;
                        if a[o]>=a[p] then goto 1;
                        x:=a[p];a[p]:=a[o];a[o]:=x; 
                        w:=b[p];b[p]:=b[o];b[o]:=w; 
                        i:=i-m; 
                        end; 
1:                end;
        m:=m  div 2;
        end;
end;        (* fin de shellsort *)

function val1(i,j:integer;var mat:matsym):real;
begin 
if i < j then val1:=mat[i,j] else val1:=mat[j,i]; 
end;

function val2(i,j:integer;var mat:matsym):real;
begin 
if i > j then val2:=mat[i,j] else val2:=mat[j,i]; 
end;

function z(var mat:matsym;var zmax,zmin:real):real; 
(* The Mantel statistic is computed here.                                     *)
var i,j,k:integer; 
    zz:real;
begin 
zz:=0;
for i:=1 to nobj do 
     begin
     k:=addr[i];
     for j:=1 to i-1 do zz:=zz+val2(addr2[j],addr2[i],mat)*val1(addr[j],k,mat); 
     end; 
z:=zz;
if zz > zmax then zmax:=zz;
if zz < zmin then zmin:=zz;
end;        (* z *) 

procedure initsmouse(var mat:matsym);
var i,j:integer;
    x1,x2,x3,sumx1x3,sumx2x3:real;
begin 
sumx1x3:=0; 
sumx2x3:=0; 
reset(entree6); 
for i:=1 to nobj do 
        begin 
        for j:=i+1 to nobj do 
                begin 
                x1:=mat[i,j]; 
                x2:=mat[j,i]; 
                x3:=entree6@; 
                get(entree6); 
                sumx1x3:=sumx1x3+x1*x3; 
                sumx2x3:=sumx2x3+x2*x3; 
                end;
        end;
if sumx1x3 < 1.0 then x1:=sqrt(1-sqr(sumx1x3)) else x1:=0; 
if sumx2x3 < 1.0 then x2:=sqrt(1-sqr(sumx2x3)) else x2:=0; 
if (x1 < epsilon) or (x2 < epsilon) then
      begin 
      if lang=1
        then writeln(' Valeur non calculee: matrice sans variation. ')
        else writeln(' No variation in matrix: no value computed. ');
      errnonfat:=true;
      end 
else
    begin 
    reset(entree6); 
      for i:=1 to nobj do 
        begin 
        for j:=i+1 to nobj do 
                begin 
                x3:=entree6@; 
                get(entree6); 
                mat[i,j]:=(mat[i,j]-sumx1x3*x3)/x1; 
                mat[j,i]:=(mat[j,i]-sumx2x3*x3)/x2; 
                end;
        end;
    end; 
end;        (* init smouse *) 

procedure inithubert(var mat:matsym);
var i,j:integer;
begin 
entete(entree3);
for i:=1 to nobj do 
        for j:=i+1 to nobj do 
                begin 
                mat[i,j]:=entree3@.re *mat[i,j]; 
                get(entree3); 
                end;
end;

procedure mad;
var i,j:integer;
    x,sumx,sumx2:real;
begin 
sumx:=0;sumx2:=0;
for i:=1 to nobj do 
   for j:=i+1 to nobj do
      begin 
(*     x:=mat[j,i];  *)
      x:=mat[i,j];                                       (* modification 1.02 *) 
      sumx:=sumx+x; 
      sumx2:=sumx2+x*x; 
      end;
sumx:=sumx/n; 
sumx2:=sqrt(sumx2-sumx*sumx*n); 
(* This is not really a standard deviation, since the division 
   by (N-1) is missing. See the note in Procedure CENTREREDUIT.               *)
if sumx2 < epsilon then erreur(2,0,0); 
for i:=1 to nobj do 
   for j:=i+1 to nobj do
(*    mat[j,i]:=(mat[j,i]-sumx)/sumx2; *)
     mat[i,j]:=(mat[i,j]-sumx)/sumx2;                    (* modification 1.02 *)
end;   (*  mad *)

procedure petitemat(var mat:matsym);
var i,j,sum:integer;

  procedure compte(zz,zref:real;var pp,eq:integer); 
  begin
  if zz < zref+epsilon then
     begin
     if zz > zref- epsilon then eq:=eq+1
     else pp:=pp+1; 
     end; 
  end;

begin 
errnonfat:=false;
lecture(mat); 
addr2:=addr;
case option of
        nooption:begin end;
        dow:dowcheverud(mat); 
        smouse:initsmouse(mat); 
        hubert:inithubert(mat); 
        end;        (* case *)
if (corr)and(option in[dow,hubert]) then mad; 
zref:=z(mat,zmax,zmin); 
if desire then
   for i:=1 to nbessais do
        begin 
        for j:=1 to nobj do raddr[j]:=ggubfs(x); 
        sum:=0; 
        for j:=1 to nbgroupes do
            begin
            shellsort(raddr,addr,sum,groupes[j]); 
            sum:=groupes[j]; 
            end;
        compte(z(mat,zmax,zmin),zref,pp,eq);
        end;
end;        (* petite matrices *) 

function approximation(n:integer;var mat:matsym;zref,zmax,zmin:real;b:boolean) 
                                                                    :real;
var i,j:integer;
    ax,bx,dx,ay,by,dy,gx,gy,kx,ky,x,y,sumx,sumy:real; 

        procedure entre(i,j:integer);
        begin 
        x:=mat[i,j];
        y:=mat[j,i];
        ax:=ax+x;
        ay:=ay+y;
        bx:=bx+x*x; 
        by:=by+y*y; 
        sumx:=sumx+x; 
        sumy:=sumy+y; 
        end;

begin 
ax:=0;ay:=0;bx:=0;by:=0;
dx:=0;dy:=0;
for i:=1 to n do
        begin 
        sumx:=0;sumy:=0;
        for j:=1 to i-1 do entre(i,j); 
        for j:=i+1 to n do entre(j,i); 
        dx:=dx+sumx*sumx; 
        dy:=dy+sumy*sumy; 
        end;
gx:=ax*ax;gy:=ay*ay;
kx:=gx+2*bx-4*dx;
ky:=gy+2*by-4*dy;
x:=(2*bx*by+4*(dx-bx)*(dy-by)/(n-2)+kx*ky/
        ((n-2)*(n-3))-gx*gy/(n*(n-1)))/(n*(n-1)); 
if x<=0 then erreur(1,0,0);
y:=ax*ay/(n*(n-1));   (* y = e(z) *)
ay:=2*zref-y;         (* = z-e(z)  *)
approximation:=ay/sqrt(x);
if b then 
      begin 
      if ay >= 0 then zhubert:=ay/(2*zmax-y)
      else zhubert:=ay/(y-2*zmin);
      end;
end;        (* approximation *) 

function grosapprox(n:integer):real;
var i,j:integer;
    ax,bx,dx,ay,by,dy,gx,gy,kx,ky,x,y,z,sumx,sumy:real; 
begin 
reset(entree4);reset(entree5);
ax:=0;ay:=0;bx:=0;by:=0;
dx:=0;dy:=0;
zref:=0; 
for i:=1 to n do begin raddr[i]:=0;raddr2[i]:=0;end;
for i:=1 to n do
        begin 
        sumx:=raddr[i]; 
        sumy:=raddr2[i];
        for j:=i+1 to n do
                begin 
                x:=entree4@; 
                get(entree4); 
                raddr[j]:=raddr[j]+x;
                ax:=ax+x; 
                sumx:=sumx+x; 
                bx:=bx+x*x;
                y:=entree5@; 
                get(entree5); 
                raddr2[j]:=raddr2[j]+y; 
                ay:=ay+y; 
                sumy:=sumy+y; 
                by:=by+y*y;
                zref:=zref+x*y; 
                end;
        dx:=dx+sumx*sumx; 
        dy:=dy+sumy*sumy; 
        end;
ax:=2*ax;ay:=2*ay; 
bx:=2*bx;by:=2*by; 
gx:=ax*ax;gy:=ay*ay;
kx:=gx+2*bx-4*dx;
ky:=gy+2*by-4*dy;
x:=(2*bx*by+4*(dx-bx)*(dy-by)/(n-2)+kx*ky/
        ((n-2)*(n-3))-gx*gy/(n*(n-1)))/(n*(n-1)); 
y:=ax*ay/(n*(n-1)); 
grosapprox:=(2*zref-y)/sqrt(x); 
end;

(* procedure ecritz(zref,zmax,zmin:real;pp,eq:integer;var mat:matsym);
begin 
write(' ':10,str); 
if zref < 10000 then write(zref:11:5) else write(zref:11); 
zz:=approximation(nobj,mat,zref,zmax,zmin,true); 
write(zhubert:11:5);
if pp < nbessais div 2 then pp:=pp+eq+1 
else pp:=pp-1;
write(pp/nbessais:15:5);
writeln(zz:11:5,gauss(zz):10:5);
end; *)                                            (* modification 1.02 *)

procedure ecritz(zref,zmax,zmin:real;pp,eq:integer;var mat:matsym);
var pg:integer;
    prob:real;
begin 
write(str);
if zref < 10000 then write(zref:11:5) else write(zref:11); 
zz:=approximation(nobj,mat,zref,zmax,zmin,true); 
write(zhubert:10:5);
pg:=nbessais+1-pp-eq;
if pp < nbessais div 2 then prob:=(pp+eq)/(nbessais+1)
else prob:=(pg+eq)/(nbessais+1);
write(pp:5,eq:5,pg:5,prob:12:5);
probzz:=gauss(zz);
if probzz > 0.5 then probzz:=1.0-probzz;
writeln(zz:10:5,probzz:10:5);
end;                                                     (* modification 1.02 *)

(* procedure init; 
var i:integer;
begin 
x:=0.98674532;
for i:=1 to 100 do zz:=ggubfs(x); 
if lang=1 then write(' ':11,'Calcul:',' ':29,'Permutations     Approximation') 
else write(' ':11,'Computation:',' ':23,' Permutations     Approximation'); 
writeln; 
write(' ':27);
writeln(car,'      ',car,' stand.        Prob(',car,')       t       Prob(t)'); 
writeln(' ':33,'**Hubert** ');
writeln; 
end; *)                                                  (* modification 1.02 *)

procedure init; 
var i:integer;
begin 
x:=0.98674532;
for i:=1 to 100 do zz:=ggubfs(x); 
if lang=1 then write(' ':1,'Calcul:',' ':39,'Permutations     Approximation') 
else write(' ':1,'Computation:',' ':33,' Permutations     Approximation'); 
writeln; 
write(' ':17);
if lang=1 then writeln
(car,'     ',car,' stand.   PP   EG   PG     Prob(',car,')       t     Prob(t)') 
else writeln(car,'     ',car,
                ' stand.   ST   EQ   GT     Prob(',car,')       t     Prob(t)'); 
writeln(' ':22,'**Hubert**                (Hope,1968)');
writeln; 
end;                                                     (* modification 1.02 *)

begin  (* prog princ *) 
(* termin(input);                              for IBM conversational systems *)
if lang=1 then
   begin 
   writeln(' P R O G R A M M E   M A N T E L   avec test par permutations');
   writeln; 
   writeln(' Auteur: A. Vaudor'); 
   end
else
   begin 
   writeln(' P R O G R A M   M A N T E L   with permutation test');
   writeln; 
   writeln(' Author: A. Vaudor'); 
   end;
writeln(' Departement de Sciences biologiques, Universite de Montreal,'); 
writeln(' C.P. 6128, Succursale a, Montreal, Quebec H3C 3J7.'); 
writeln; 
if lang=1 then
   begin 
   writeln(' Type de calcul:'); 
   writeln('    (0) Mantel entre deux matrices'); 
   end
else
   begin 
   writeln(' computation requested:'); 
   writeln('    (0) Mantel test for two matrices'); 
   end;
writeln('    (1) Dow & Cheverud (A.(B-C))');
writeln('    (2) Smouse, Long & Sokal (AB.C)');
writeln('    (3) Hubert (A.(BC))'); 
writeln('  ');
valide(option,0,3);                                      (* modification 1.01 *)
if lang=1 then
   begin 
   writeln(' Options pour la matrice "A":');
   writeln('    (0) Fichier d''entree en classes (pour correlogramme)'); 
   writeln('    (1) Grille reguliere (aucun fichier n''est requis)'); 
   writeln('    (2) Fichier de distances (ou de similarites) de simil');
   writeln('    (3) Fichier de coordonnees en degres, minutes et secondes');
   writeln('    (4) Fichier de coordonnees en degres decimaux');
   end
else
   begin 
   writeln(' Options for matrix "A":'); 
   writeln('    (0) Input file in classes (for a Mantel correlogram)'); 
   writeln('    (1) Regular lattice (no file is required)');
   writeln('    (2) Distance (or similarity) file from simil'); 
   writeln('    (3) File of coordinates in degrees, minutes and seconds');
   writeln('    (4) File of coordinates in decimal degrees'); 
   end;
writeln('  ');
valide(fich,0,4);
nbclasses:=0; 
niveau:=0;
grille:=false;simil:=false;minute:=false; 
case fich of
     0:begin 
       if lang=1 then
          begin 
          writeln(' **** Notez que dans ce correlogramme, l''autocorrelation ',
          'positive ');
          writeln('      produit des z negatifs a faible distance ');
          writeln; 
          end
       else
          begin 
          writeln(' **** Notice that in this correlogram, positive ',
             'autocorrelation produces '); 
          writeln('      negative values of z in the low distance classes'); 
          writeln; 
          end; 
       end;
     1:begin 
       grille:=true; 
       if lang=1 then writeln(' Largeur de cette grille reguliere ?')
                 else writeln(' Width of the regular lattice ?'); 
       readln(largeur); 
       end;
     2:simil:=true;
     3:minute:=true; 
     4:minute:=false;
     end;
reset(entree2); 
nobj:=entree2@.int; 
if (option > nooption) and (nobj > petitnobj) then erreur(2,0,0); 
n:=nobj*(nobj-1) div 2; 
corr:=option=smouse;
spherique:=false;
if fich in[3,4] then
      begin 
      if lang=1 then writeln 
      (' Vos coordonnees sont-elles plates (1) ou sur une sphere (2) ?')
      else writeln 
      (' Are these coordinates flat (1), or on a sphere (2) ?');
      writeln;
      valide(i,1,2);
      spherique:=i=2; 
      end;
if fich in[1,3,4] then fabric 
else if fich=2 then reset(entree1); 
if option <> smouse then
    begin 
    if lang=1 then write(' Desirez-vous obtenir la statistique z* normalisee') 
    else write(' Do you wish to compute the normalized statistic z*');
    writeln(' [-1 <= z* <= 1] ?');
    corr:=validebool; 
    end; 
if corr then car:='r' else car:='z';
desire:=true; 
if (nobj <= petitnobj) then
   begin 
   if lang=1 then writeln(' Nombre d''iterations ? -- (Recommande >= 250) ')
             else writeln(' Number of iterations ? -- (Recommended >= 250) ');
   valide(nbessais,0,15000); 
   desire:=nbessais <> 0; 
   if desire then
      begin 
      if lang = 1 then
         writeln(' Nombre de groupes a permuter ? (Probleme general: 1)  ')
      else
         writeln(' Number of groups to be permuted ? (General case: 1)  '); 
      valide(nbgroupes,1,nobj); 
      ad:=0;total:=0; 
      for i:=1 to nobj do begin raddr[i]:=0;addr2[i]:=0;end;
      for i:=1 to nbgroupes-1 do
         begin
         if lang = 1 then 
            writeln('   Nombre d''objets appartenant au groupe [',i:1,'] :')
         else 
            writeln('   Number of objects pertaining to group [',i:1,'] :');
         valide(groupes[i],1,nobj-total); 
         total:=total+groupes[i]; 
         groupes[i]:=total;
         if lang=1 then 
            writeln('   Numeros des objets appartenant a ce groupe :')
         else 
            writeln('   Object numbers pertaining to this group :'); 
         for j:=ad+1 to total do if raddr[j] <= 0 then
               begin
               read(k); 
               if ad=0 then l:=k
               else if k > 0 then l:=k else l:=addr[ad]+1; 
               k:=abs(k); 
               for m:=l to k do 
                     begin
                     ad:=ad+1;
                     addr[ad]:=m; 
                     raddr[ad]:=1;
                     if addr2[m] <> 0 then erreur(4,m,0)
                     else addr2[m]:=1; 
                     end; 
               end; 
         end; 
     if (total > nobj) then erreur (3,nobj,0) 
     else for i:=1 to nobj do if addr2[i]=0 then 
         begin
         ad:=ad+1; 
         addr[ad]:=i; 
         end; 
      groupes[nbgroupes]:=nobj; 
      end 
   else
      begin 
      groupes[1]:=nobj; 
      nbgroupes:=1; 
      for i:=1 to nobj do addr[i]:=i;
      end;
   end;
if nbgroupes > 1 then 
   begin 
   if lang = 1 then 
   writeln(' contenu des groupes')
   else
   writeln(' content of groups'); 
   for i:=1 to nbgroupes do
      begin 
      k:=0; 
      writeln(' [',i:1,']'); 
      if i=1 then l:=1 else l:=groupes[i-1]+1;
      for j:=l to groupes[i] do 
            begin
            write(addr[j]:4); 
            k:=k+1; 
            if k mod 20 = 0 then writeln; 
            end;
      writeln;
      end;
   writeln; 
   end;
writeln; 
if lang=1 then
   begin 
   writeln(' Test unilateral a gauche ou a droite: ');
   writeln(' Les probabilites sont significatives pres de zero.');
   writeln(' PP signifie Plus Petits,',
           ' EG EGaux et PG, Plus Grands que la stat. originale.');
   writeln(' La valeur originale est ajoutee aux EGaux,',
           ' suivant Hope (1968).');
   end
else
   begin 
   writeln(' One-tail test on the left or on the right:'); 
   writeln(' Probabilities near zero are significant.');
   writeln(' ST stands for Smaller Than, EQ EQual,',
           ' & GT Greater Than the original statistic.'); 
   writeln(' The original value is added to the EQuals,',
           ' following Hope (1968).');
   end;
writeln; 
if not ((nobj <= petitnobj) and (desire)) then
        if lang=1 then writeln(' ':16,' Test par approximation')
                  else writeln(' ':16,' Test by approximation '); 
writeln; 
repeat
    niveau:=niveau+1; 
    error:=false;
    centrereduit(entree1,entree4,corr,fich=0);
    centrereduit(entree2,entree5,((corr)and(option in[nooption,smouse]))
                   or(option=dow),false);                (* modification 1.02 *)
    if option in[dow,smouse] then centrereduit(entree3,entree6,true,fich=0);
    if niveau=1 then
       begin
       if (nobj <= petitnobj) and (desire) then init
       else writeln(' ':17,car,'          t      Prob(t)'); 
       end; 
    if fich =0 then 
       if lang=1 then writeln(' classe ',niveau:3)
                 else writeln(' class  ',niveau:3); 
    if not (error) then 
          begin 
          if (nobj <=petitnobj) then
                begin 
                zmax:=-maxreel;zmin:=maxreel; 
                pp:=0;
                eq:=1;                                    (* modification 1.2 *)
                 case option of
                    nooption    :str:='          ';       (* modification 1.2 *)
                    dow:         str:=' A.(B-C)  ';
                    smouse:      str:='   AB.C   ';
                    hubert:      str:='   A.BC   ';
                    end; 
                if desire then
                     begin
                     petitemat(mat);
                     if not(errnonfat) then ecritz(zref,zmax,zmin,pp,eq,mat);
                     end
               else 
                     begin
                     petitemat(mat);
                     if not(errnonfat) then 
                         begin
                           zz:=approximation(nobj,mat,zref,0,0,false);
                           writeln(' ',str,zref:10:5,zz:11:5,gauss(zz):10:5);
                        end; 
                     end; 
               end 
          else
                begin 
                zz:=grosapprox(nobj);
                probzz:=gauss(zz);
                if probzz > 0.5 then probzz:=1.0-probzz;
                writeln(' ':11,zref:10:5,zz:11:5,probzz:10:5); 
                end;
          end;
until niveau>=nbclasses;
777: writeln; 
if lang=1 then writeln(' Fin du programme.')
          else writeln(' End of the program.');
end.
