PROGRAM PCOORD(INPUT,OUTPUT,ENTREEB,SORTIEC,COORD);
(* ================================================================== *)
(*    PRINCIPAL COORDINATES ANALYSIS.                                 *)
(*    ENTREEB is the input SIMIL file.                                *)
(*    SORTIEC is the output file containing the principal coordinate  *)
(*            analysis.                                               *)
(*    COORD is an output file that contains the coordinates of the    *)
(*            objects, on as many axes as determined by the user,     *)
(*            up to the number of positive axes.                      *)
(* ================================================================== *)
LABEL 777;
CONST DIM=80200;      (* =DIMENSION*(DIMENSION+1) DIV 2 *)
      DIMENSION=400;  (* MAXIMUM NUMBER OF OBJECTS *)
      (* Modify "DIMENSION" to change the capacity of the program *)
      CHARLIM=116;    (* WIDTH OF THE GRAPH; =136 ON CDC *)
      BORNE=100;      (* ALSO RELATED TO GRAPH WIDTH; =120 ON CDC *)
      EPSILON=10E-7;
      NBMOTS=1;
      NBCAR=10;
      LANG=1;         (* Parametre de langue: 1=FRANCAIS
                         Language parameter : 2=ENGLISH  *)
TYPE MAT0=ARRAY[1..3,0..DIMENSION]OF REAL;
     VARIABLE=RECORD CASE INTEGER OF
              1:(INT:INTEGER);
              2:(RE:REAL);
              3:(CAR:PACKED ARRAY[1..NBCAR] OF CHAR);
              END;
      MAT=RECORD CASE BOOLEAN OF
      TRUE:(LIN:ARRAY[1..DIM]OF REAL);
      FALSE:(MULT:MAT0)
      END;
     MAT2=ARRAY[1..DIMENSION,1..DIMENSION]OF REAL;
     MAT1=ARRAY[0..DIMENSION]OF REAL;
     MAT3=ARRAY[1..3,1..DIMENSION]OF REAL;
     MAT4=PACKED ARRAY[1..DIMENSION]OF 0..1024;
     CARMAT=ARRAY[-5..CHARLIM] OF CHAR;
     ENS1=SET OF '0'..'9';
VAR I,J,K,P,NBDESC,DIMREF,DIMLARG,DIMLARG1,DIMLARG2,DIMLARG3,
     DIMLARG4:INTEGER;
    PTRMIN,PTRMAX,COMPTE,NBVALIDES,NBESPACES,NOBJ:INTEGER;
    X1,PLUSGRAND,PLUSPETIT,Y,Y1,FACTEUR,RAYONCARRE,VALMAX:REAL;
    DISTANCE:BOOLEAN;
    VARI:VARIABLE;
    ENTREEB:FILE OF VARIABLE;
    G:MAT;
    X:MAT2;
    PTR:MAT4;
    DIAGONALE:MAT1;
    MATRICE:PACKED ARRAY[1..DIM]OF 0..1024;
    CAR:CHAR;
    COPIE:FILE OF REAL;
    SORTIEC,COORD: TEXT;
    SUPPLT: TEXT;

PROCEDURE SYMMETRIC(N:INTEGER;VAR G:MAT;VAR X:MAT2;VAR A:MAT1);
LABEL 11,77;
VAR I,J,K,M,M1:INTEGER ;
    T,NORM,EPS,SINE,COSINE,LAMBDA,MU,A0,A1,B0,BETA,X0,X1,PROVI:REAL;
    B,C,CS,SN:MAT1;

FUNCTION MAX(A,B:REAL):REAL;
BEGIN
IF A>B THEN MAX:=A ELSE MAX:=B;
END;

PROCEDURE HOUSEHOLDER
(N:INTEGER;VAR G:MAT;VAR A,B:MAT1;VAR X:MAT2;VAR NORM:REAL) ;
VAR I,J,K,L:INTEGER;
    T,SIGMA,ALPHA,BETA,GAMMA,ABSB,PROVI:REAL;
    P:MAT1;
BEGIN
NORM:=0;ABSB:=0;
FOR K:=1 TO N-2 DO
      BEGIN
      A[K]:=G.LIN[(K*(K+1))DIV 2];
      SIGMA:=0;
      FOR I:=K+1 TO N DO SIGMA:=SIGMA+SQR(G.LIN[I*(I-1)DIV 2 +K]);
      T:=ABSB+ABS(A[K]);ABSB:=SQRT(SIGMA);
      NORM:=MAX(NORM,T+ABSB);ALPHA:=G.LIN[K*(K+3)DIV 2];
      IF ALPHA<0 THEN BETA:=ABSB ELSE BETA:=-ABSB;
      B[K]:=BETA;
      IF SIGMA<>0 THEN
            BEGIN
            GAMMA:=1/(SIGMA-ALPHA*BETA);
            G.LIN[K*(K+3) DIV 2]:=ALPHA-BETA;
            FOR I:=K+1 TO N DO
                  BEGIN
                   PROVI:=0;
                  FOR J:=K+1 TO I DO
                  PROVI:=PROVI+G.LIN[I*(I-1) DIV 2+J]*
                       G.LIN[J*(J-1) DIV 2+K];
                  FOR J:=I+1 TO N DO
                  PROVI:=PROVI+G.LIN[J*(J-1)DIV 2+I]
                     *G.LIN[J*(J-1) DIV 2+K];
                  P[I]:=PROVI*GAMMA;
                  END;
            T:=0;
            FOR I:=K+1 TO N DO T:=T+G.LIN[I*(I-1)DIV 2+K]*P[I];
            T:=T*0.5*GAMMA;
            FOR I:=K+1 TO N DO P[I]:=P[I]-T*G.LIN[I*(I-1) DIV 2+K];
            FOR I:= K+1 TO N DO
                FOR J :=K+1 TO I DO
                  G.LIN[I*(I-1)DIV 2+J] :=G.LIN[I*(I-1)DIV 2+J]
            -G.LIN[I*(I-1) DIV 2+K]*P[J]-P[I]*G.LIN[J*(J-1)DIV 2+K];
            FOR I:=2 TO N DO
                  BEGIN
                  PROVI:=0;
                  FOR J :=K+1 TO N DO
                  PROVI:=PROVI+X[I,J]*G.LIN[J*(J-1)DIV 2+K];
                  P[I]:=GAMMA*PROVI;
                  END;
            FOR I:=2 TO N DO
              FOR J:=K+1 TO N DO
                  X[I,J]:=X[I,J]-P[I]*G.LIN[J*(J-1)DIV 2 +K];
            END;
      END;
L:=N*(N-1) DIV 2;
A[N-1]:=G.LIN[L];A[N]:=G.LIN[L+N];B[N-1]:=G.LIN[L-1+N];
T:=ABS(B[N-1]);
NORM:=MAX(NORM,ABSB+ABS(A[N-1])+T);
NORM:=MAX(NORM,T+ABS(A[N]));
END;            (* FIN DE HOUSEHOLDER *)

BEGIN            (* DEBUT DE SYMMETRIC *)
FOR I:=1 TO N DO
      BEGIN
      X[I,I]:=1;
      FOR J:=I+1 TO N DO
            BEGIN
            X[I,J]:=0;
            X[J,I]:=0;
            END;
      END;
B[N]:=0;
HOUSEHOLDER(N,G,A,B,X,NORM);
EPS:=NORM*1.3E-7;
B[0]:=0;MU:=0;M:=N;
11:IF M=0 THEN GOTO 77
    ELSE
      BEGIN
      I:=M-1;K:=M-1;
      M1:=M-1;
      END;
IF ABS(B[K])<=EPS THEN
      BEGIN
      G.LIN[M*(M+1)DIV 2]:=A[M];
      M:=K;
      GOTO 11;
      END;
REPEAT I:=I- 1 UNTIL ABS(B[I])<=EPS;
K:=I+1;
B0:=SQR(B[M1]);A1:=SQRT(SQR(A[M1]-A[M])+4*B0);
T:=A[M1]*A[M]-B0; A0:=A[M1]+A[M];
IF A0>=0 THEN LAMBDA:=A0+A1 ELSE LAMBDA:=A0-A1;
T:=T/LAMBDA;
IF ABS(T-MU)<0.5*ABS(T) THEN BEGIN MU:=T;LAMBDA:=T;END
ELSE IF ABS(LAMBDA-MU)<0.5*ABS(LAMBDA) THEN MU:=LAMBDA
     ELSE BEGIN MU:=T;LAMBDA:=0;END;
A[K]:=A[K]-LAMBDA; BETA:=B[K];
FOR J:=K TO M1 DO
      BEGIN
      A0:=A[J];A1:=A[J+1]-LAMBDA;B0:=B[J];
      T:=SQRT(SQR(A0)+SQR(BETA));
       COSINE:=A0/T;CS[J]:=COSINE;
      SINE:=BETA/T;SN[J]:=SINE;
      A[J]:=COSINE*A0+SINE*BETA;A[J+1]:=-SINE*B0+COSINE*A1;
      B[J]:=COSINE*B0+SINE*A1;BETA:=B[J+1];
      B[J+1]:=COSINE*BETA;C[J]:=SINE*BETA;
      END;
B[K-1]:=0;C[K-1]:=0;
FOR J:=K TO M1 DO
      BEGIN
      SINE:= SN[J];COSINE:=CS[J];
      A0:=A[J];B0:=B[J];
      B[J-1]:=B[J-1]*COSINE+C[J-1]*SINE;
      A[J]:=A0*COSINE+B0*SINE+LAMBDA;
      B[J]:=-A0*SINE+B0*COSINE;A[J+1]:=A[J+1]*COSINE;
      FOR I:=1 TO N DO
            BEGIN
            X0:=X[I,J];X1:=X[I,J+1];
            X[I,J]:=X0*COSINE+X1*SINE;X[I,J+1] :=-X0*SINE+X1*COSINE;
            END;
      END;
A[M]:=A[M]+LAMBDA;
GOTO 11;
77:END;

PROCEDURE NOUVELLESCOORD;
VAR I,J:INTEGER;
BEGIN
REWRITE(COORD);
FOR J:=1 TO NBDESC DO
      BEGIN
      FOR I:=1 TO NBESPACES DO
            BEGIN
            WRITE(COORD,X[J,PTR[I]]*SQRT(DIAGONALE[I]):9:5,' ');
            IF I MOD 8=0 THEN WRITELN(COORD);
            END;
      IF NBESPACES MOD 8 <>0 THEN WRITELN(COORD);
      END;
END;          (* FIN NOUVELLES COORDONNEES *)

PROCEDURE LECTURE(VAR NBDESC:INTEGER);
VAR I,J,K:INTEGER;
    X,TOTAL:REAL;
   TEMP:VARIABLE;

   PROCEDURE ECRITDATA;
   VAR I,J,K:INTEGER;
       TEMP:VARIABLE;
   BEGIN
   J:=0;
   FOR I:=1 TO NBMOTS DO
      BEGIN
      TEMP:=ENTREEB@;GET(ENTREEB);
      FOR K:=1 TO NBCAR DO
            BEGIN
            J:=J+1;
            IF J<=10 THEN WRITE(SORTIEC,TEMP.CAR[K]);
            END;
      END;
   END;  (* ECRITDATA *)

BEGIN
RESET(ENTREEB);
VARI:=ENTREEB@;
NBDESC:=VARI.INT;
GET(ENTREEB);VARI:=ENTREEB@;
NOBJ:=VARI.INT;
GET(ENTREEB);
IF LANG=1 THEN BEGIN
WRITELN(SORTIEC,' NOMBRE D OBJETS : ',NBDESC:4);
WRITELN(SORTIEC,' NOMBRE DE DESCRIPTEURS: ',NOBJ:4);
WRITE(SORTIEC,' TITRE: ');
END ELSE BEGIN
WRITELN(SORTIEC,' NUMBER OF OBJECTS : ',NBDESC:4);
WRITELN(SORTIEC,' NUMBER OF DESCRIPTORS: ',NOBJ:4);
WRITE(SORTIEC,' TITLE: ');
END;
FOR I:=1 TO 10 DO ECRITDATA;
WRITELN(SORTIEC);
WRITE(SORTIEC,' DATE ');
ECRITDATA;
WRITELN(SORTIEC);
IF LANG=1 THEN WRITE(SORTIEC,' FONCTION ')
          ELSE WRITE(SORTIEC,' FUNCTION ');
ECRITDATA;ECRITDATA;
WRITELN(SORTIEC);
WRITELN(SORTIEC);
TEMP:=ENTREEB@;
GET(ENTREEB);
IF TEMP.INT<>0 THEN
      BEGIN
      FOR I:=1 TO NBDESC DO
            BEGIN
            FOR J:=1 TO NBMOTS DO GET(ENTREEB);
            END;
      END;
FOR I:=1 TO NBDESC DO DIAGONALE[I]:=0;
TOTAL:=0;
K:=0;
     (* REMPLISSAGE DE LA MATRICE *)
FOR I:=1 TO NBDESC DO
      BEGIN
      FOR J:=I+1 TO NBDESC DO
            BEGIN
            VARI:=ENTREEB@;GET(ENTREEB);
            IF DISTANCE THEN X:=(-SQR(VARI.RE)/2)
            ELSE X:=(-SQR(1-VARI.RE)/2);
            G.LIN[(J-1)*(J) DIV 2 +I]:=X;
            DIAGONALE[I]:=DIAGONALE[I]+X;
            DIAGONALE[J]:=DIAGONALE[J]+X;
            TOTAL:=TOTAL+X+X;
            END;
      G.LIN[I*(I+1) DIV 2 ]:=0;
      END;
FOR I:=1 TO NBDESC DO DIAGONALE[I]:=DIAGONALE[I]/NBDESC;
TOTAL:=TOTAL/NBDESC/NBDESC;
K:=0;
FOR I:=1 TO NBDESC DO
      BEGIN
      FOR J:=1 TO I DO
            BEGIN
            K:=K+1;
            G.LIN[K]:=G.LIN[K]-DIAGONALE[I]-DIAGONALE[J]+TOTAL;
            END;
      END;
END;         (* FIN LECTURE *)

PROCEDURE TRACELIGNE(VAR G:MAT0;POINTEUR:MAT4;FACTEUR
:REAL;PTRDIM,DIM,PTR,PTR1,REFE,NBDESC:INTEGER);
LABEL 77;
VAR I,J,K,L,M,L1,L2,L3,LOG,X,Y,COMPTEUR:INTEGER;
    OCCUPE:BOOLEAN;
    MATCAR:CARMAT;


PROCEDURE DEBORDE(Y,L,LOG:INTEGER);
VAR I:INTEGER;
BEGIN
I:=Y+1;
REPEAT I:=I-1 UNTIL (MATCAR[I]IN['0'..'9'])OR (I<Y-LOG-1);
IF MATCAR[I] IN[' ','.'] THEN I:=Y+1;
WHILE MATCAR[I-1] IN['0'..'9'] DO I:=I-1;
REPEAT
      WRITE(SUPPLT,MATCAR[I]);
      I:=I+1;
UNTIL MATCAR[I]IN [' ','.'];
WRITELN(SUPPLT,'=',L:3);
END;            (* FIN DE DEBORDE *)

PROCEDURE INITIALISE(REFE:INTEGER);
VAR I:INTEGER;
BEGIN
IF REFE MOD 12=0 THEN
      BEGIN
      FOR I:=-5 TO 0 DO MATCAR[I]:=' ';
      FOR I:=1 TO DIMLARG3+2 DO
            BEGIN
            MATCAR[I*2]:=' ';
            MATCAR[I*2-1]:='.';
            END;
      END
ELSE
      BEGIN
      FOR I:=-5 TO DIMLARG1+3 DO MATCAR[I]:=' ';
      FOR I:=0 TO DIMLARG2 DO MATCAR[I*20]:='.';
      END;
END;

BEGIN
WRITELN(SORTIEC
,'   /\ X',CHR(PTR+ORD('0')),'        <======== X' ,CHR(PTR1+ORD('0')));
WRITELN(SORTIEC,'   ||');
WRITELN(SORTIEC,'   ||');
G[PTR,NBDESC+1]:=0;
K:=TRUNC(PLUSGRAND*FACTEUR*0.6);
IF PLUSPETIT>=0
THEN X:=-1 ELSE X:=TRUNC(PLUSPETIT)-(TRUNC(PLUSPETIT) MOD 12)-13;
WRITELN(SORTIEC);
IF K MOD 12 <> 0 THEN K:=K+12-(K MOD 12);
WRITELN (SORTIEC,' ');
INITIALISE(K);
IF DIM<PTRDIM THEN
         FOR J:=K DOWNTO X+1 DO
            BEGIN
            FOR I:=-2 TO DIMLARG1 DO WRITE(SORTIEC,MATCAR[I]);
            IF J MOD 12=0 THEN WRITE(SORTIEC,J/(FACTEUR*0.6):7:3);
            WRITELN(SORTIEC,' ');
            INITIALISE(J-1);
            END;
IF DIM<PTRDIM THEN GOTO 77;
WHILE DIM>=PTRDIM DO
      BEGIN
      COMPTEUR:=0;
      X:=TRUNC(G[PTR,DIM]*FACTEUR*0.6);Y:=TRUNC(G[PTR1,DIM]*FACTEUR);
      IF K MOD 12=0 THEN COMPTEUR:=-1;
      WHILE ((X=K) AND (DIM>=PTRDIM)) DO
            BEGIN
            COMPTEUR:=COMPTEUR+1;
            Y:=DIMLARG1-(Y+DIMLARG4-REFE*DIMREF);
            L:=POINTEUR[DIM];
            L1:=L DIV 100;
            L2:=L MOD 100 DIV 10;
            L3:=L MOD 10;
            IF L1<>0 THEN LOG:=3
            ELSE IF L2<>0 THEN LOG:=2
                 ELSE LOG:=1;
            OCCUPE:=FALSE;
            FOR M:=Y-LOG-1 TO Y+1 DO IF NOT(MATCAR[M] IN[' ','.'])
            THEN OCCUPE:=TRUE;
            IF NOT OCCUPE THEN
                  BEGIN
                  MATCAR[Y]:=CHR(L3+ORD('0'));
                  IF ((L2<>0)OR(L1<>0))
                  THEN MATCAR[Y-1]:=CHR(L2+ORD('0'));
                  IF L1<>0 THEN MATCAR[Y-2]:=CHR(L1+ORD('0'));
                  END
            ELSE DEBORDE(Y,L,LOG);
            DIM:=DIM-1;
            IF DIM>=PTRDIM THEN
            BEGIN X:=TRUNC(G[PTR,DIM]*FACTEUR*0.6);
                  Y:=TRUNC(G[PTR1,DIM]*FACTEUR);END
            ELSE
                  BEGIN
                  IF PLUSPETIT>=0 THEN X:=-1
                  ELSE X:=TRUNC(PLUSPETIT)-(TRUNC(PLUSPETIT) MOD 12)-13;
                  END;
            END;
         FOR J:=K DOWNTO X+1 DO
            BEGIN
            FOR I:=-2 TO DIMLARG1 DO WRITE(SORTIEC,MATCAR[I]);
            IF J MOD 12=0 THEN WRITE(SORTIEC,J/(FACTEUR*0.6):7:3);
            WRITELN(SORTIEC,' ');
            INITIALISE(J-1);
            END;
      K:=X;
      END;
77: WRITELN(SORTIEC,' ');
FOR I:=COMPTE TO COMPTE+DIMLARG2
DO WRITE(SORTIEC,(DIMLARG4-I*20)/FACTEUR:7:3,' ':13);
WRITELN(SORTIEC,' ');
END;            (* FIN DU TRACAGE *)



PROCEDURE NOUVELESPACE(VAR G:MAT;VAR X:MAT2);
VAR I,J,K,L:INTEGER;
    Y:REAL;
BEGIN
FOR I:=1 TO NBVALIDES DO
      BEGIN
      Y:=SQRT(DIAGONALE[I]);
      K:=PTR[I];
      FOR J:=1 TO NBDESC DO G.MULT[I,J]:=X[J,K]*Y;
      END;
END;           (* FIN POSITIONNEMENT ESPACE REDUIT *)

PROCEDURE SHELLSORT(VAR A:MAT;MIN,N,REFE:INTEGER;VAR PTR:MAT4);
LABEL 1;
VAR I,J,K,L,M,O,P:INTEGER;
     W:REAL;
BEGIN
FOR I:=1 TO N DO M:=2*(I-MIN)+1;
M:=M DIV 2;
WHILE M<>0 DO
      BEGIN
      K:=N-M-MIN+1;
      FOR J:=1 TO K DO
            BEGIN
            I:=J;
            WHILE I>=1 DO
                BEGIN
                P:=I+MIN-1;
                IF A.MULT[REFE,P+M]>=A.MULT[REFE,P] THEN GOTO 1;
                O:=P+M;
                W:=A. MULT[1,P];A.MULT[1,P]:=A.MULT[1,O];A.MULT[1,O]:=W;
                W:=A.MULT[2,P];A.MULT[2,P]:=A.MULT[2,O];A.MULT[2,O]:=W;
                W:=A.MULT[3,P];A.MULT[3,P]:=A.MULT[3,O];A.MULT[3,O]:=W;
                L:=PTR[P];PTR[P]:=PTR[O];PTR[O]:=L;
                I:=I-M;
                END;
1:            END;
      M:=M DIV 2;
      END;
END;            (* FIN DE SHELLSORT *)

PROCEDURE SHELL(VAR A:MAT1;N:INTEGER;VAR PTR:MAT4);
LABEL 1;
VAR I,J,K,L,M,O,I1:INTEGER;
    W:REAL;
BEGIN
FOR I:=1 TO N DO M:=2*I-1;
M:=M DIV 2;
WHILE M<>0 DO
      BEGIN
      K:=N-M;
      FOR J:=1 TO K DO
            BEGIN
            I:=J;
            WHILE I>=1 DO
                  BEGIN
                  IF A[I+M]<=A[I] THEN GOTO 1;
                  O:=I+M;
                  W:=A[I];A[I]:=A[O];A[O]:=W;
                  I1:=PTR[I];PTR[I]:=PTR[O];PTR[O]:=I1;
                  I:=I-M;
                  END;
1:          END;
      M:=M DIV 2;
      END;
END;     (* FIN DE SHELL *)



PROCEDURE DESSINE(PTR1,PTR2,NBDESC:INTEGER);
VAR I:INTEGER;
    CAR:CHAR;
BEGIN
REWRITE(SUPPLT);
WRITE(SUPPLT,' ');
PTRMIN:=1;PTRMAX:=NBDESC;
PLUSGRAND:=G.MULT[PTR1,1];PLUSPETIT:=PLUSGRAND;
FOR I:=2 TO NBDESC DO IF G.MULT[PTR1,I]>PLUSGRAND
THEN PLUSGRAND:=G.MULT[PTR1,I]
      ELSE IF G.MULT[PTR1,I]<PLUSPETIT
         THEN PLUSPETIT:=G.MULT[PTR1,I];
PLUSPETIT:=PLUSPETIT*FACTEUR*0.6;
DIMLARG1:=DIMLARG;
I:=1;
IF DIMLARG>BORNE THEN DIMREF:=BORNE ELSE DIMREF:=DIMLARG;
COMPTE:=DIMLARG DIV 20;
REPEAT
      IF DIMLARG1>=BORNE THEN DIMLARG1:=BORNE;
      DIMLARG2:=DIMLARG1 DIV 20;DIMLARG3:=DIMLARG1 DIV 2;
      Y:=(I*BORNE-DIMLARG/2)/FACTEUR;
      PTRMAX:=PTRMIN;
      WHILE ((G.MULT[PTR2,PTRMAX]<=Y)AND(PTRMAX<=NBDESC))
      DO PTRMAX:=PTRMAX+1;
      PTRMAX:=PTRMAX-1;
      COMPTE:=COMPTE-DIMLARG2;
      IF PTRMAX-PTRMIN>=1 THEN SHELLSORT(G,PTRMIN,PTRMAX,PTR1,PTR);
      TRACELIGNE(G.MULT,PTR,FACTEUR,PTRMIN,PTRMAX,PTR1,PTR2,I-1,NBDESC);
      WRITELN(SORTIEC);WRITELN(SORTIEC);
      DIMLARG1:=DIMLARG-I*BORNE;
      I:=I+1;
      PTRMIN:=PTRMAX+1;
UNTIL PTRMAX>=NBDESC;
RESET(SUPPLT);
WHILE NOT(EOF(SUPPLT))DO
      BEGIN
      READ(SUPPLT,CAR);
      WRITE(SORTIEC,CAR);
      IF EOLN(SUPPLT) THEN WRITELN(SORTIEC);
      END;
REWRITE(SUPPLT);
END;            (* FIN DE DESSINE *)

PROCEDURE DECIDE(NBDESC:INTEGER);
VAR I,J,K:INTEGER;
BEGIN WRITELN(SORTIEC);
IF LANG=1 THEN WRITELN(SORTIEC,' POSITION DANS L''ESPACE REDUIT ')
ELSE WRITELN(SORTIEC,' POSITION IN THE REDUCED SPACE ');
WRITELN(SORTIEC);
NOUVELESPACE(G,X);
FOR J:=1 TO NBDESC DO
      BEGIN
      WRITE(SORTIEC,J:4);
      FOR K:=1 TO NBVALIDES DO WRITE(SORTIEC,'  ',G.MULT[K,J]:20:5);
      WRITELN(SORTIEC);
      END;
FOR I:=1 TO NBDESC DO PTR[I]:=I;
SHELLSORT(G,1,NBDESC,2,PTR);
FOR I:=1 TO 3 DO G.MULT[I,NBDESC+1]:=0;
IF ABS(G.MULT[2,1]) >ABS(G.MULT[2,NBDESC])
THEN FACTEUR:=ABS(G.MULT[2,1]) ELSE FACTEUR:=ABS(G.MULT[2,NBDESC]);
FOR I:=1 TO NBDESC DO IF ABS(G.MULT[3,I])>FACTEUR
 THEN FACTEUR:=ABS(G.MULT[3,I]);
FACTEUR:=DIMLARG/(2*FACTEUR);
RAYONCARRE:=2/NBDESC*SQR(FACTEUR);
WRITELN(SORTIEC);WRITELN(SORTIEC);
DESSINE(1,2,NBDESC);
IF (NBVALIDES>2) THEN
      BEGIN
      SHELLSORT(G,1,NBDESC,3,PTR);
      IF ABS(G.MULT[3,1])>ABS(G.MULT[3,NBDESC])
      THEN Y:=ABS(G.MULT[3,1])ELSE Y:=ABS(G.MULT[3,NBDESC]);
      DIMLARG:=TRUNC(Y*FACTEUR);
      DIMLARG:=(DIMLARG-(DIMLARG MOD 20)+20)*2;
      DIMLARG4:=DIMLARG DIV  2;
      WRITELN(SORTIEC);WRITELN(SORTIEC);
      DESSINE(1,3,NBDESC);
      WRITELN(SORTIEC);WRITELN(SORTIEC);
      DESSINE(2,3,NBDESC);
      END;
END;            (* FIN DE DECIDE *)

BEGIN    (* PROG PRINC *)
DISTANCE:=FALSE;
I:=1;
DIMLARG:=1;
REWRITE(SORTIEC);
WHILE DIMLARG MOD 4 <> 0 DO
      BEGIN IF LANG=1
THEN WRITELN(' LARGEUR DU GRAPHIQUE? (en pouces: multiples de 4)  ')
ELSE WRITELN(' WIDTH OF THE GRAPH? (in inches: multiples of 4)  ');
      READLN(DIMLARG);
      IF DIMLARG MOD 4 <> 0 THEN IF LANG=1 THEN WRITE(' ERREUR')
                                           ELSE WRITE(' ERROR');
      END;
IF LANG=1 THEN WRITELN
(' LA MATRICE D''ENTREE EST DE SIMILARITES OU DE DISTANCES? (S ou D)')
          ELSE WRITELN
(' IS THE INPUT FILE A SIMILARITY OR A DISTANCE FILE? (Write S or D)');
WHILE NOT (INPUT@ IN['S','s','D','d']) DO GET(INPUT);
DISTANCE:=INPUT@ IN ['D','d']; READLN;
IF LANG=1 THEN BEGIN WRITELN
(' REECRITURE DES OBJETS DANS LE NOUVEL ESPACE (Fichier "COORD"):');
WRITELN(' COMBIEN DE COORDONNEES VOULEZ-VOUS ?  (0 si aucun) ');
      END ELSE BEGIN WRITELN
(' RE-WRITING THE COORDINATES OF THE OBJECTS (File "COORD"):');
WRITELN(' HOW MANY AXES DO YOU WANT? (Type 0 if you don''t want any) ');
          END;
READLN(NBESPACES);
WRITELN(SORTIEC);
WRITELN(SORTIEC,'1');
IF LANG=1 THEN WRITELN (SORTIEC,
' A N A L Y S E   E N   C O O R D O N N E E S   P R I N C I P A L E S ')
ELSE WRITELN
(SORTIEC,' P R I N C I P A L   C O O R D I N A T E   A N A L Y S I S ');
WRITELN(SORTIEC);
WRITELN(SORTIEC,' DEPARTEMENT DE SCIENCES BIOLOGIQUES');
WRITELN(SORTIEC,' UNIVERSITE DE MONTREAL ');
WRITELN(SORTIEC);
IF LANG=1 THEN BEGIN WRITELN
(SORTIEC,' Programme PCOORD Version 2.1b (Modifie pour SIMIL 3.0)');
WRITELN(SORTIEC,' Auteur: A. VAUDOR'); END
ELSE BEGIN WRITELN
(SORTIEC,' Program PCOORD Version 2.1b (Modified for SIMIL 3.0)');
WRITELN(SORTIEC,' Author: A. VAUDOR'); END;
WRITELN(SORTIEC);
IF LANG=1 THEN WRITELN(' TITRE DU TRAVAIL ?  ')
          ELSE WRITELN(' TITLE OF THE RUN ?  ');
WRITE(SORTIEC,' ');READ(CAR);WRITE(SORTIEC,CAR);
WHILE NOT (EOLN) DO BEGIN READ(CAR);WRITE(SORTIEC,CAR);END;
WRITELN(SORTIEC);
WRITELN(SORTIEC);
DIMLARG:=DIMLARG*10;
DIMLARG4:=DIMLARG DIV 2;
LECTURE(NBDESC);
SYMMETRIC(NBDESC,G,X,DIAGONALE);
FOR I:=1 TO NBDESC DO PTR[I]:=I;
SHELL(DIAGONALE,NBDESC,PTR);
NBVALIDES:=0;
WHILE ((DIAGONALE[NBVALIDES+1]>EPSILON)AND(NBVALIDES<NBDESC)) DO
                 NBVALIDES:=NBVALIDES+1;
IF NBVALIDES < NBESPACES THEN
      BEGIN
      NBESPACES:=NBVALIDES;
      IF LANG=1 THEN WRITELN (' FICHIER "COORD" :SEULEMENT ',
                   NBVALIDES:1,' COORDONNEES SERONT ECRITES')
      ELSE WRITELN(' FILE "COORD" : ONLY ',
                   NBVALIDES:1,' COORDINATES WILL BE WRITTEN');
      END;
IF NBVALIDES>3 THEN NBVALIDES:=3;
IF LANG=1
THEN WRITELN(SORTIEC,'          VALEURS PROPRES     % DE VARIANCE  ')
ELSE WRITELN(SORTIEC,'            EIGENVALUES       % OF VARIANCE  ');
X1:=0;Y:=0;
FOR I:=1 TO NBDESC DO X1:=X1+DIAGONALE[I];
IF DIAGONALE[NBDESC] < 0 THEN
      BEGIN
      Y:=-DIAGONALE[NBDESC];
      X1:=X1+NBDESC*Y;
      END;
FOR I:=1 TO NBDESC DO
      BEGIN
      WRITELN(SORTIEC,DIAGONALE[I]:20:5,(DIAGONALE[I]+Y)*100/X1:20:5);
      END;
WRITELN(SORTIEC); IF LANG=1 THEN WRITELN
(SORTIEC,' POUR LES TROIS PREMIERES VALEURS PROPRES (COLONNES): ')
ELSE WRITELN(SORTIEC,' FOR THE FIRST THREE EIGENVALUES (COLUMNS): ');
IF NBVALIDES>1 THEN
      BEGIN
      IF NBESPACES > 0 THEN NOUVELLESCOORD;
      DECIDE(NBDESC);
      END
ELSE IF LANG=1
THEN WRITELN(' IL N''Y A QU''UNE SEULE VALEUR PROPRES POSITIVES ')
ELSE WRITELN(' THERE IS ONLY A SINGLE POSITIVE EIGENVALUE ');
777:IF LANG=1 THEN WRITELN(' Fin du programme.')
              ELSE WRITELN(' End of the program.');
END.
