PROGRAM VERNORM(INPUT,OUTPUT,ENTREEC,SORTIEC,TITRE);
     (* Corrections to VERNORM *)
     (* Correction  -  Date    *)
     (* 3.0.01      28 Feb. 84 *)
     (* 3.0.02      28 Mar. 84 *)
     (* 3.0.03      16 Mar. 84 *)
     (* 3.0.04      19 Mar. 84 *)
     (* 3.0.05      29 May  84 *)
     (* 3.0.06      12 Sep. 84 *)
     (* 3.0.07      19 Sep. 84 *)
     (* 3.0.08       2 Apr. 86 *)
     (* 3.0.09       6 May  87 *)
     (* 3.0.10       8 Oct  87 *)
LABEL 777;
CONST MAXNOBJ=1000;
      MAXVAR=1000;   (* MAXVAR <=MAXNOBJ *)
      MAXTRANSP=10000;
      MAXREEL=1.70E38; (* MAX FOR THIS COMPUTER *)
      EPSILON=10E-7;
      NBMOTS=16;     (* MAXNOBJ DIV 59 *)
      NBBITS=59;     (* N. BITS BY COMPUTER WORD *)
      NBBITSL1=58;   (* NBBITS-1 *)
      LANG=1;        (* Parametre de langue: 1=FRANCAIS
                        Language parameter : 2=ENGLISH  *)
TYPE  TRANSP=ARRAY[1..MAXTRANSP] OF REAL;
      MATCALC=ARRAY[1..MAXNOBJ] OF REAL;
      PTRMAT=@MATCALC;
      MATBOOL=ARRAY[0..NBMOTS] OF SET OF 0..NBBITSL1;
      PTRBOOL=@MATBOOL;
      FICHREEL=FILE OF REAL;
      PTRTRANSP=@TRANSP;
      MATVAR=ARRAY[1..MAXVAR] OF REAL;
      PTRVAR=@MATVAR;
      MATINT=ARRAY[1..MAXVAR] OF INTEGER;
      PTRINT=@MATINT;
      STAT=ARRAY[1..5,4..23] OF REAL;
      PTRSTAT=@STAT;
      ALFA=PACKED ARRAY[1..10] OF CHAR;
VAR I,J,K,NOBJ,NBVAR,MODELE,DEPLACEMENT,ABSENCE,NBCLASSES,OPTION,
    CHOIX:INTEGER;
    NBCHAR,CHAMP,FRACTION,OPTIONDEPT:INTEGER;
    IDENT,TRANSPOSITION,ENTIER,ERROR,NOOPTION,ALLOUEA,ALLOUEB,
    ALLOUEL:BOOLEAN;
    DEJAINIT,DEJAAJUSTE,DEJACLASSE,ADDTITRE,COMPACTE:BOOLEAN;
    X,A,A5,B,B1,B3,B4,B5,VYX,LAMBDA,MINF,MAXF:REAL;
    POURTRANSP:PTRTRANSP;
    MATOPTION:ARRAY[1..MAXVAR] OF INTEGER;
    ABST:ARRAY[1..100] OF CHAR;
    MATC1,MATC2:PTRMAT;
    MATV1,MATV2,MATV3,MATV4,MATV5,LAMBDAS,PTRA,PTRB,CLASSES,MIN,
    MAX:PTRVAR;
    MINLOCAL,MAXLOCAL:PTRVAR;
    MATI1:PTRINT;
    LIL:PTRSTAT;
    ENTREEC,SORTIEC,TITRE:TEXT;
    TEMP1,TEMP2:FICHREEL;

 PROCEDURE TROUVERR(I,J:INTEGER);
 BEGIN
 IF LANG=1 THEN BEGIN
 WRITE(' ERREUR FATALE:');
 CASE I OF
       1:WRITELN(' VARIABLE ',J:4,': VECTEUR VIDE');
       2:WRITELN(' VALEUR ',J:4,' <= 0 ');
       3:WRITELN(' PAS ASSEZ DE VARIABLES POUR CE MODELE ');
       4:WRITELN(' LE FICHIER CONTIENT MOINS DE VALEURS QUE DECLARE');
       5:WRITELN(' PAS ASSEZ DE VALEURS PRESENTES, VARIABLE: ',J:4);
       6:BEGIN
         WRITE(' JE NE PEUX CALCULER LA VARIANCE, OU ELLE EST DE ZERO');
         IF J<>0 THEN WRITE(' VARIABLE ',J:4);
         WRITELN;
         END;
       7:WRITELN(' SYMBOLE(S) NON VALIDE(S) ');
       8:WRITELN(' CE DESCRIPTEUR A UNE VARIANCE NULLE ');
       END;  (* CASE *)
 END ELSE BEGIN
 WRITE(' FATAL ERROR:');
 CASE I OF
       1:WRITELN(' VARIABLE ',J:4,': EMPTY VECTOR');
       2:WRITELN(' VALUE ',J:4,' <= 0 ');
       3:WRITELN(' INSUFFICIENT NUMBER OF VARIABLES FOR THIS MODEL');
       4:WRITELN(' FEWER VALUES IN DATA FILE THAN YOU DECLARED');
       5:WRITELN(' INSUFFICIENT NUMBER OF VALUES, VARIABLE: ',J:4);
       6:BEGIN
         WRITE(' I CANNOT COMPUTE THE VARIANCE, OR IT IS ZERO');
         IF J<>0 THEN WRITE(' VARIABLE ',J:4);
         WRITELN;
         END;
       7:WRITELN(' INVALID SYMBOL(S)');
       8:WRITELN(' THIS DESCRIPTOR HAS A NULL VARIANCE ');
       END;  (* CASE *)
 END;
 ERROR:=TRUE;
 END;   (* FIN ERREUR *)

FUNCTION GAUSS(X:REAL):REAL;
VAR Y,Z,W:REAL;
BEGIN
                              (* REFERENCE: CACM                *)
                              (* ALGORITHME: 209                *)
                              (* AUTEUR:D.IBBETSON              *)
                              (* TITRE:GAUSS                    *)
                              (* TRADUIT EN PASCAL PAR A.VAUDOR *)
IF X=0 THEN Z:=0
ELSE
      BEGIN
      Y:=ABS(X)/2;
      IF Y>=3 THEN Z:=1
      ELSE IF Y<1 THEN
            BEGIN
            W:=Y*Y;
            Z:=((((((((0.000124818987*W
            -0.001075204047)*W+0.005198775019)*W
            -0.019198292004)*W+0.059054035642)*W
            -0.151968751364)*W+0.319152932694)*W
            -0.531923007300)*W+0.797884560593)*Y*2
            END
          ELSE
            BEGIN
            Y:=Y-2;
            Z:=(((((((((((((-0.000045255659*Y
            +0.000152529290)*Y-0.000019538132)*Y
            -0.000676904986)*Y+0.001390604284)*Y
            -0.000794620820)*Y-0.002034254874)*Y
            +0.006549791214)*Y-0.010557625006)*Y
            +0.011630447319)*Y-0.009279453341)*Y
            +0.005353579108)*Y-0.002141268741)*Y
            +0.000535310849)*Y+0.999936657524
            END
      END;
IF X>0 THEN GAUSS:=(Z+1)/2 ELSE GAUSS:=(1-Z)/2;
END;      (* GAUSS *)

FUNCTION FTEST(F:REAL;DF1,DF2:INTEGER):REAL;
VAR F1,F2,X,FT,VP,XX,THETA,STH,CTH,STS,CTS,A,B,XI,GAMMA,CBRF:REAL;
BEGIN
                              (* REFENCE:CACM                   *)
                              (* ALGORITHME:346                 *)
                              (* AUTEUR:J.MORRIS                *)
                              (* TITRE:FTEST PROBABILITIES      *)
                              (* TRADUIT EN PASCAL PAR A.VAUDOR *)
IF F=0 THEN FTEST:=1.0
ELSE
      BEGIN
      F1:=DF1;F2:=DF2;FT:=0;
      X:=F2/(F2+F1*F);VP:=F1+F2-2.0;
      IF ((DF1 MOD 2 =0) AND (DF1<500)) THEN
            BEGIN
            XX:=1-X;
            F1:=F1-2;
            WHILE F1>1 DO
                  BEGIN
                  VP:=VP-2;
                  FT:=XX*VP/F1*(1+FT);
                  F1:=F1-2;
                  END;
            IF X<>0 THEN FT:=EXP((0.5*F2)*LN(X))*(1+FT) ELSE FT:=0;
            END
      ELSE IF ((DF2 MOD 2=0)AND(DF2<500)) THEN
            BEGIN
             F2:=F2-2;
            WHILE F2>1 DO
                  BEGIN
                  VP:=VP-2;
                  FT:=X*VP/F2*(1.0+FT);
                  F2:=F2-2;
                  END;
            IF X<>1 THEN FT:=1-EXP((0.5*F1)*LN(1-X))*(1+FT) ELSE FT:=1;
            END
            ELSE IF DF1+DF2<=500 THEN
                  BEGIN
                  THETA:=ARCTAN(SQRT(F1*F/F2));
                  STH:=SIN(THETA);CTH:=COS(THETA);
                  STS:=SQR(STH);CTS:=SQR(CTH);
                  A:=0;B:=0;
                  IF DF2>1 THEN
                        BEGIN
                        F2:=F2-2.0;
                        WHILE F2>2 DO
                              BEGIN
                              A:=CTS*(F2-1.0)/F2*(1.0+A);
                              F2:=F2-2;
                              END;
                        A:=STH*CTH*(1.0+A);
                        END;
                  A:=THETA+A;
                  IF DF1>1 THEN
                        BEGIN
                        F1:=F1-2;
                        WHILE F1>2 DO
                              BEGIN
                              VP:=VP-2;
                              B:=STS*VP/F1*(1.0+B);
                              F1:=F1-2;
                              END;
                        GAMMA:=1.0;F2:=0.5*DF2;
                        XI:=1;
                        WHILE XI<=F2 DO
                              BEGIN
                              GAMMA:=XI*GAMMA/(XI-0.5);
                              XI:=XI+1;
                              END;
                        B:=GAMMA*STH*EXP(DF2*LN(CTH))*(1.0+B);
                        END;
                  FT:=1.0+0.636619772368*(B-A);
                  END
      ELSE
            BEGIN
            F1:=2.0/(9.0*F1);F2:=2.0/(9.0*F2);
            CBRF:=(EXP(LN(F)/3));  (* CORRECTION 3.0.10 *)
            FT:=GAUSS(-((1.0-F2)*CBRF+F1-1.0)/SQRT(F2*SQRT(CBRF)+F1));
            END;
      IF FT<0 THEN FTEST:=0 ELSE FTEST:=FT;
      END;
END;   (* FTEST *)

PROCEDURE FINVERSE(VAR A:REAL;PROB:REAL;DF1,DF2:INTEGER);
VAR I,J:INTEGER;
    NOUVEAUL,DELTA: REAL;
BEGIN     (* FINVERSE *)
DELTA:=1;
REPEAT
      DELTA:=DELTA*2;
      NOUVEAUL:=FTEST(DELTA,DF1,DF2);
UNTIL NOUVEAUL < PROB;
A:=DELTA;
WHILE ABS(NOUVEAUL-PROB) > EPSILON DO
      BEGIN
      DELTA:=DELTA/2;
      IF NOUVEAUL > PROB THEN A:=A+DELTA
      ELSE A:=A-DELTA;
      NOUVEAUL:=FTEST(A,DF1,DF2);
      END;
END;     (* FIN FINVERSE *)


FUNCTION TQUANTILE(P,N:REAL):REAL;  (* ALGORITHME 396 A.C.M *)
VAR HALFPI,A,B,C,D,X,Y:REAL;
BEGIN
IF N=2 THEN TQUANTILE:=SQRT(2/(P*(2-P))-2)
ELSE
      BEGIN
      HALFPI:=1.5707963268;
      IF N=1 THEN
            BEGIN
            P:=P*HALFPI;
            TQUANTILE:=COS(P)/SIN(P);
            END
      ELSE
            BEGIN
            A:=1/(N-0.5);B:=48/SQR(A);
            C:=((20700*A/B-98)*A-16)*A+96.36;
            D:=((94.5/(B+C)-3)/B+1)*SQRT(A*HALFPI)*N;
            X:=D*P;Y:=EXP((2/N)*LN(X));
            IF Y > 0.05+A THEN
                  BEGIN
                  X:=-1.959963984548082;
                  Y:=X*X;
                  IF N < 5 THEN C:=C+0.3*(N-4.5)*(X+0.6);
                  C:=(((0.05*D*X-5)*X-7)*X-2)*X+B+C;
                  Y:=(((((0.4*Y+6.3)*Y+36)*Y+94.5)/C-Y-3)/B+1)*X;
                  Y:=A*SQR(Y);
                  IF Y >0.002 THEN Y:=EXP(Y)-1
                  ELSE Y:=0.5*SQR(Y)+Y;
                  END
            ELSE Y:=((1/(((N+6)/(N*Y)-0.089*D-0.822)*
                    (N+2)*3)+0.5/(N+4))*Y-1)*(N+1)/(N+2)+1/Y;
            TQUANTILE:=SQRT(N*Y);
            END;
      END;
END; (* TQUANTILE *)

PROCEDURE INIT(VAR L:STAT);
BEGIN
DEJAINIT:=TRUE;
(* What follows is a Kolmogorov-Smirnov critical values table,
   as modified by Lilliefors (1967) *)
L[5, 4]:=0.300;L[4, 4]:=0.319;L[3, 4]:=0.352;L[2, 4]:=0.381;
L[1, 4]:=0.417;
L[5, 5]:=0.285;L[4, 5]:=0.299;L[3, 5]:=0.315;L[2, 5]:=0.337;
L[1, 5]:=0.405;
L[5, 6]:=0.265;L[4, 6]:=0.277;L[3, 6]:=0.294;L[2, 6]:=0.319;
L[1, 6]:=0.364;
L[5, 7]:=0.247;L[4, 7]:=0.258;L[3, 7]:=0.276;L[2, 7]:=0.300;
L[1, 7]:=0.348;
L[5, 8]:=0.233;L[4, 8]:=0.244;L[3, 8]:=0.261;L[2, 8]:=0.285;
L[1, 8]:=0.331;
L[5, 9]:=0.223;L[4, 9]:=0.233;L[3, 9]:=0.249;L[2, 9]:=0.271;
L[1, 9]:=0.311;
L[5,10]:=0.215;L[4,10]:=0.224;L[3,10]:=0.239;L[2,10]:=0.258;
L[1,10]:=0.294;
L[5,11]:=0.206;L[4,11]:=0.217;L[3,11]:=0.230;L[2,11]:=0.249;
L[1,11]:=0.284;
L[5,12]:=0.199;L[4,12]:=0.212;L[3,12]:=0.223;L[2,12]:=0.242;
L[1,12]:=0.275;
L[5,13]:=0.190;L[4,13]:=0.202;L[3,13]:=0.214;L[2,13]:=0.234;
L[1,13]:=0.268;
L[5,14]:=0.183;L[4,14]:=0.194;L[3,14]:=0.207;L[2,14]:=0.227;
L[1,14]:=0.261;
L[5,15]:=0.177;L[4,15]:=0.187;L[3,15]:=0.201;L[2,15]:=0.220;
L[1,15]:=0.257;
L[5,16]:=0.173;L[4,16]:=0.182;L[3,16]:=0.195;L[2,16]:=0.213;
L[1,16]:=0.250;
L[5,17]:=0.169;L[4,17]:=0.177;L[3,17]:=0.189;L[2,17]:=0.206;
L[1,17]:=0.245;
L[5,18]:=0.166;L[4,18]:=0.173;L[3,18]:=0.184;L[2,18]:=0.200;
L[1,18]:=0.239;
L[5,19]:=0.163;L[4,19]:=0.169;L[3,19]:=0.179;L[2,19]:=0.195;
L[1,19]:=0.235;
L[5,20]:=0.160;L[4,20]:=0.166;L[3,20]:=0.174;L[2,20]:=0.190;
L[1,20]:=0.231;
L[5,21]:=0.149;L[4,21]:=0.153;L[3,21]:=0.165;L[2,21]:=0.180;
L[1,21]:=0.203;
L[5,22]:=0.131;L[4,22]:=0.136;L[3,22]:=0.144;L[2,22]:=0.161;
L[1,22]:=0.187;
L[5,23]:=0.736;L[4,23]:=0.768;L[3,23]:=0.805;L[2,23]:=0.886;
L[1,23]:=1.031;
END;   (* FIN INIT *)

 PROCEDURE VERIFIE(ENTIER:BOOLEAN);
 VAR J,COMPTELIGNES,NOMBRE,TOTAL:INTEGER;
     MIN,MAX,LOCMIN,LOCMAX,X:REAL;
     ERREUR:BOOLEAN;
 BEGIN
 RESET(ENTREEC);
 COMPTELIGNES:=0;
 MIN:=MAXREEL;
 MAX:=(-MIN);
 TOTAL:=0;
 IF LANG=1
       THEN WRITELN(' LIGNE    N. DE VALEURS       MIN         MAX')
       ELSE WRITELN(' LINE     N. OF VALUES        MIN         MAX');
 WHILE NOT(EOF(ENTREEC)) DO
       BEGIN
       ERREUR:=FALSE;
       COMPTELIGNES:=COMPTELIGNES+1;
       LOCMIN:=1.7E38;
       LOCMAX:=(-LOCMIN);
       NOMBRE:=0;
       IF ((IDENT)AND(TOTAL MOD NBVAR=0)) THEN FOR J:=1 TO 10 DO
       GET(ENTREEC);
       WHILE NOT((EOLN(ENTREEC))OR(EOF(ENTREEC))) DO
             BEGIN
             IF ENTREEC@ =' ' THEN GET(ENTREEC)
             ELSE IF ENTREEC@ IN ['-','0'..'9'] THEN
                   BEGIN
                   NOMBRE:=NOMBRE+1;
                   TOTAL:=TOTAL+1;
                   IF ENTIER THEN  BEGIN READ(ENTREEC,J); X:=J;END
                   ELSE READ(ENTREEC,X);
                   IF X<MIN THEN MIN:=X;
                   IF X>MAX THEN MAX:=X;
                   IF X<LOCMIN THEN LOCMIN:=X;
                   IF X>LOCMAX THEN LOCMAX:=X;
                   END
                   ELSE BEGIN GET(ENTREEC);ERREUR:=TRUE;END;
             END;
       WRITE(COMPTELIGNES:6,NOMBRE:14);
       IF ERREUR THEN TROUVERR(7,0)
       ELSE IF NOMBRE>0 THEN WRITELN(LOCMIN:12:2,LOCMAX:12:2)
             ELSE WRITELN;
       READLN(ENTREEC);
       END;
 WRITELN;
 IF LANG=1 THEN BEGIN
            WRITELN(' PLUS PETITE VALEUR DANS LE FICHIER:',MIN:8:2);
            WRITELN(' PLUS GRANDE VALEUR DANS LE FICHIER:',MAX:8:2);END
 ELSE BEGIN WRITELN(' SMALLEST VALUE IN THE DATA FILE:',MIN:8:2);
            WRITELN(' LARGEST  VALUE IN THE DATA FILE:',MAX:8:2);END;
 WRITELN;
 IF TOTAL > NOBJ*NBVAR THEN
       BEGIN
       IF LANG=1 THEN WRITELN
 (' ATTENTION: IL Y A PLUS DE VALEURS DANS LE FICHIER QUE DECLARE ')
       ELSE WRITELN
 (' CAREFUL: THERE ARE MORE VALUES IN THE DATA FILE THAN YOU DECLARED');
       WRITELN;
       END;
 IF TOTAL <NOBJ*NBVAR THEN TROUVERR(4,0);
 END;    (* FIN VERIFIE *)

PROCEDURE LECTURE(VAR TEMP:FICHREEL;VAR MATOBJ:MATCALC;VAR MATV:MATVAR);
VAR I,J:INTEGER;
    X,MINX:REAL;
    CAR:CHAR;
BEGIN
RESET(ENTREEC);
REWRITE(TEMP);
FOR I:=1 TO NBVAR DO MATV[I]:=MAXREEL;
IF ((IDENT)AND(NOT(TRANSPOSITION))) THEN REWRITE(TITRE);
FOR I:=1 TO NOBJ DO
      BEGIN
      MINX:=MAXREEL;
      IF IDENT THEN
            BEGIN
            FOR J:=1 TO 10 DO
                  BEGIN
                  CAR:=ENTREEC@;
                  GET(ENTREEC);
                  IF NOT(TRANSPOSITION) THEN
                        BEGIN
                        TITRE@:=CAR;
                        PUT(TITRE);
                        END;
                  END;
            IF NOT(TRANSPOSITION) THEN WRITELN(TITRE);
            END;
      FOR J:=1 TO NBVAR DO
            BEGIN
            READ(ENTREEC,X);
            TEMP@:=X;
            PUT(TEMP);
            IF X<MINX THEN MINX:=X;
            IF X<MATV[J] THEN MATV[J]:=X;
            END;
      IF IDENT THEN READLN(ENTREEC);
      MATOBJ[I]:=MINX;
      END;
IF OPTIONDEPT IN[1,3] THEN
      BEGIN
      MINX:=MAXREEL;
      FOR I:=1 TO NBVAR DO IF MATV[I]<MINX THEN MINX:=MATV[I];
      FOR I:=1 TO NBVAR DO MATV[I]:=MINX;
      FOR I:=1 TO NOBJ DO MATOBJ[I]:=MINX;
      END;
END;    (* LECTURE *)

PROCEDURE BORNES(VAR A:INTEGER;B,C:INTEGER);
BEGIN
WHILE NOT(A IN[B..C]) DO
      BEGIN
      IF LANG=1 THEN WRITELN(' S.V.P. ',B:1,' A ',C:1,'   ')
                ELSE WRITELN(' PLEASE ',B:1,' TO ',C:1,'   ');
      READLN(A);
      END;
END;    (* BORNES *)

PROCEDURE EFFDEPT(VAR TEMP1,TEMP2:FICHREEL;VAR MATH,MINDEP:MATCALC;
VAR MATV:MATVAR);
VAR I,J:INTEGER;
    X:REAL;
BEGIN
RESET(TEMP1);REWRITE(TEMP2);
IF TRANSPOSITION THEN
      BEGIN
      FOR I:=1 TO NOBJ DO
            BEGIN
            X:=MINDEP[I]-MATH[I];
            FOR J:=1 TO NBVAR DO
                  BEGIN
                  IF TEMP1@<>ABSENCE THEN TEMP2@:=TEMP1@+X
                  ELSE TEMP2@:=ABSENCE;          (* CORRECTION 3.0.04 *)
                  PUT(TEMP2);GET(TEMP1);
                  END;
            END;
      END
ELSE
      BEGIN
      FOR J:=1 TO NBVAR DO MATV[J]:=MINDEP[J]-MATV[J];
      FOR I:=1 TO NOBJ DO
            BEGIN
            FOR J:=1 TO NBVAR DO
                  BEGIN
                  IF TEMP1@<>ABSENCE THEN TEMP2@:=TEMP1@+MATV[J]
                  ELSE TEMP2@:=ABSENCE;          (* CORRECTION 3.0.04 *)
                  PUT(TEMP2);GET(TEMP1);
                  END;
            END;
      END;
END;   (* FIN EFFDEPT *)

PROCEDURE TRANSPOSE(VAR A:TRANSP;M,N:INTEGER);
LABEL 1;
VAR I,J,K,ILESS1,MNLESS1,DONE,JN,MODLESSN:INTEGER;
    T:REAL;
BEGIN
MNLESS1:=M*N-1;
MODLESSN:=MNLESS1-N;
DONE:=MNLESS1-1;
K:=0;ILESS1:=1;
FOR I:=2 TO DONE DO
      BEGIN
      IF K <= MODLESSN THEN
            BEGIN
            K:=K+N;
            J:=K;
            END
      ELSE
            BEGIN
            K:=K-MODLESSN;
            J:=K;
            END;
1:    IF J < ILESS1 THEN
            BEGIN
            JN:=J*N;
            J:=JN-JN DIV MNLESS1*MNLESS1;
            GOTO 1;
            END;
      J:=J+1;
      T:=A[I];A[I]:=A[J];A[J]:=T;
      ILESS1:=I;
      END;
END;        (* FIN TRANSPOSE *)

PROCEDURE TRANSPFICH(VAR FICH,FICH1:FICHREEL;VAR MAT:TRANSP);
VAR I,J,LARGEUR,NBDEFOIS,ASAUTER:INTEGER;

   PROCEDURE LIS(IND:INTEGER);
   VAR I,J,K,PTRLARGEUR:INTEGER;
   BEGIN
   RESET(FICH);
   K:=0;
   PTRLARGEUR:=ASAUTER+LARGEUR+1;
   FOR I:=1 TO NOBJ DO
         BEGIN
         FOR J:=1 TO ASAUTER DO GET(FICH);
         FOR J:=1 TO LARGEUR DO
            BEGIN
            K:=K+1;
            MAT[K]:=FICH@;
            GET(FICH);
            END;
         FOR J:=PTRLARGEUR TO NBVAR DO GET(FICH);
         END;
   END;

   PROCEDURE ECRIT;
   VAR I,J:INTEGER;
   BEGIN
   J:=NOBJ*LARGEUR;
   FOR I:=1 TO J DO
      BEGIN
      FICH1@:=MAT[I];
      PUT(FICH1);
      END;
   END;    (* FIN ECRIT *)

BEGIN   (* TRANSPFICH *)
REWRITE(FICH1);
LARGEUR:=MAXTRANSP DIV NOBJ;
NBDEFOIS:=NBVAR DIV LARGEUR;
ASAUTER:=0;
FOR I:=1 TO NBDEFOIS DO
      BEGIN
      LIS(I);
      TRANSPOSE(MAT,NOBJ,LARGEUR);
      ECRIT;
      ASAUTER:=ASAUTER+LARGEUR;
      END;
LARGEUR:=NBVAR-NBDEFOIS*LARGEUR;
LIS(NBDEFOIS+1);
TRANSPOSE(MAT,NOBJ,LARGEUR);
ECRIT;
END;   (* TRANSPOSITION FICHIER *)

FUNCTION FONCTION(X:REAL;I:INTEGER):REAL;
VAR Y,MINL,MAXL:REAL;
BEGIN
IF MATOPTION[I]<=0 THEN FONCTION:=X
ELSE CASE MATOPTION[I] OF
      1,2,3,4:IF ABS(B)<EPSILON THEN FONCTION:=LN(X)ELSE
      FONCTION:=EXP(LN(X)*B);
      5:IF ABS(B)<EPSILON THEN FONCTION:=A*LN(X)
                ELSE FONCTION:=A*EXP(B*LN(X));
      6:BEGIN
        Y:=LAMBDAS@[I];
        IF ABS(Y) <= EPSILON THEN FONCTION:=LN(X)
        ELSE FONCTION:=(EXP(Y*LN(X))-1)/Y;
        END;
      7:IF LAMBDA <=EPSILON THEN FONCTION:=LN(X)
      ELSE FONCTION:=(EXP(LAMBDA*LN(X))-1)/LAMBDA;
      9:BEGIN
        MAXL:=MAX@[I];
        MINL:=MIN@[I];
        MAXL:=(MAXL-MINL)/CLASSES@[I];
        FONCTION:=TRUNC((X-MINL)/MAXL-EPSILON)+1;
        END;
     10:FONCTION:=PTRA@[I]+PTRB@[I]*X; (* CORRECTION 3.0.10 *)
     11:BEGIN
        IF X<=0 THEN BEGIN TROUVERR(2,I);GOTO 777;END
        ELSE IF PTRA@[I]=0 THEN FONCTION:=LN(X)
             ELSE FONCTION:=EXP(PTRA@[I]*LN(X));
        END;
     12:IF X >= 0 THEN FONCTION:=EXP(X)
        ELSE BEGIN TROUVERR(2,I);GOTO 777;END;
     13:BEGIN
        X:=PTRA@[I]+PTRB@[I]*X;
        IF X>0 THEN FONCTION:=LN(X)
        ELSE BEGIN TROUVERR(2,I);GOTO 777;END;
        END;
      14:BEGIN
         FONCTION:=(X-PTRA@[I])/PTRB@[I];
         END;
     END;
END;  (* FIN FONCTION *)

   PROCEDURE BOXCOX(N:INTEGER;VAR MAT:MATCALC;
                  VAR DEPLT,LAMBDAS,MATTEMP:MATVAR;
                  VAR PRESENT:MATINT);
   CONST EPSILON=10E-7;
   VAR I,J,K,NOBJ,NBPRES:INTEGER;
       LNY,LAMBDA1,LAMBDA2,SUMX2,X,DELTA:REAL;

      FUNCTION L(LAMBDA:REAL):REAL;
      VAR I,J:INTEGER;
          X,SUMX:REAL;
      BEGIN
      SUMX2:=0;SUMX:=0;
      IF ABS(LAMBDA) > EPSILON THEN FOR I:=1 TO NOBJ DO
         BEGIN
         X:=EXP(LAMBDA*LN(MAT[I]))/LAMBDA;
         SUMX2:=SUMX2+SQR(X);
         SUMX:=SUMX+X;
         END
      ELSE FOR I:=1 TO NOBJ DO SUMX2:=SUMX2+SQR(LN(MAT[I]));
      SUMX2:=(SUMX2-SQR(SUMX)/NOBJ)/(NOBJ-1);
      IF SUMX2 > 0 THEN SUMX2:=-LN(SUMX2)/2
      ELSE BEGIN TROUVERR(6,0);GOTO 777;END;         (* CORRECTION 3.0.09 *)
      L:=SUMX2;
      END;         (* FIN LIKELIHOOD *)

      FUNCTION LPRIME(LAMBDA:REAL):REAL;
      VAR I,J,K:INTEGER;
          X,SUMX,Y:REAL;
      BEGIN
      SUMX2:=0;SUMX:=0;
      RESET(TEMP1);
      FOR I:=1 TO NBVAR DO BEGIN DEPLT[I]:=0;MATTEMP[I]:=0;END;
      FOR J:=1 TO N DO
            BEGIN
            FOR I:=1 TO NBVAR DO
                  BEGIN
                  X:=TEMP1@;GET(TEMP1);
                  IF X<>ABSENCE THEN
                        BEGIN
                        X:=(X)*LNY;
                        IF ABS(LAMBDA)>EPSILON THEN
                              X:=EXP(LAMBDA*LN(X))/LAMBDA
                        ELSE X:=LN(X);
                        SUMX2:=SUMX2+SQR(X);
                        SUMX:=SUMX+X;
                        MATTEMP[I]:=MATTEMP[I]+SQR(X);
                        DEPLT[I]:=DEPLT[I]+X;
                        END;
                  END;
            END;
      SUMX2:=(SUMX2-SQR(SUMX)/NBPRES)/(NBPRES-1);   (* =L *)
      IF SUMX2 > 0 THEN SUMX2 :=-LN(SUMX2)*(NBPRES-1)
      ELSE BEGIN TROUVERR(6,0);GOTO 777;END;       (* CORRECTION 3.0.09 *)
      X:=0;SUMX:=0;
      FOR I:=1 TO NBVAR DO
            BEGIN
            K:=PRESENT[I]-1;
            Y:=MATTEMP[I];
            Y:=(Y-SQR(DEPLT[I])/(K+1))/K;
            X:=X+K*Y;
            SUMX:=SUMX+K*LN(Y);
            END;
      SUMX2:=SUMX2-(NBPRES-1)*LN(X/(NBPRES-1))+SUMX;
      LPRIME:=SUMX2;
      END;  (* FIN LPRIME *)


      PROCEDURE EVALUE(VAR LAMBDA:REAL);
      VAR I,J:INTEGER;
          NOUVEAUL,ANCIENL: REAL;

      BEGIN     (* EVALUE *)
      LAMBDA:=0.5;
      DELTA:=1;
      IF MODELE=6 THEN
            BEGIN
            ANCIENL:=L(-0.5);
            NOUVEAUL:=L(0.5);
            END
      ELSE
            BEGIN
            ANCIENL:=LPRIME(-0.5);
            NOUVEAUL:=LPRIME(0.5);
            END;
      IF ANCIENL>NOUVEAUL THEN DELTA:=-DELTA;
      REPEAT
            ANCIENL:=NOUVEAUL;
            LAMBDA:=LAMBDA+DELTA;
            IF MODELE=6 THEN NOUVEAUL:=L(LAMBDA)
            ELSE NOUVEAUL:=LPRIME(LAMBDA);
      UNTIL NOUVEAUL < ANCIENL;
      DELTA:=DELTA*1.1;
      WHILE ABS(DELTA) > EPSILON DO
            BEGIN
            DELTA:=-2*DELTA;
            REPEAT
                  ANCIENL:=NOUVEAUL;
                  DELTA:=DELTA/2;
                  LAMBDA:=LAMBDA+DELTA;
                  IF MODELE=6 THEN NOUVEAUL:=L(LAMBDA)
                  ELSE NOUVEAUL:=LPRIME(LAMBDA);
            UNTIL NOUVEAUL < ANCIENL;
            END;
      END;     (* FIN EVALUE *)

      PROCEDURE LIMITS(VAR LAMBDA1:REAL;DELTA:REAL;
                     FUNCTION L(M:REAL):REAL; N:INTEGER);
      VAR CHI:REAL;
      BEGIN
      CHI:=L(LAMBDA)-1.9205/N;
      LAMBDA1:=LAMBDA;
      WHILE ABS(DELTA) > 0.0001 DO
         BEGIN
         WHILE L(LAMBDA1+DELTA)> CHI DO
               BEGIN
               LAMBDA1:=LAMBDA1+DELTA;
               END;
         DELTA:=DELTA/10;
         END;
      END;   (* FIN LIMITS *)

   BEGIN   (* BOXCOX *)
   IF MODELE = 6 THEN
      BEGIN
      WRITELN;WRITELN;
      IF LANG=1 THEN WRITELN(' TRANSFORMATION DE BOX ET COX')
                ELSE WRITELN(' BOX-COX TRANSFORMATION');
      WRITELN;
      RESET(TEMP2);
      FOR I:=1 TO NBVAR DO IF MATOPTION[I]=6 THEN
         BEGIN
         WRITELN('    VARIABLE ',I:4);
         LAMBDA:=1;
         LNY:=0;
         NOBJ:=0;
         FOR J:=1 TO N DO
               BEGIN
               X:=TEMP2@;
               GET(TEMP2);
               IF X<> ABSENCE THEN
                     BEGIN
                     NOBJ:=NOBJ+1;
                     MAT[NOBJ]:=X;
                     LNY:=LNY+LN(X);
                     END;
               END;
         IF NOBJ<2 THEN TROUVERR(5,I);
         IF NOT ERROR THEN
               BEGIN
               LNY:=EXP((-LNY)/NOBJ);
               FOR J:=1 TO NOBJ DO MAT[J]:=MAT[J]*LNY;
               EVALUE(LAMBDA);
               LIMITS(LAMBDA1,-1,L,N);
               LIMITS(LAMBDA2, 1,L,N);
IF LANG=1 THEN
BEGIN          WRITELN( ' LIMITE DE L''I.C. DE LAMBDA',LAMBDA1:10:5);
               WRITELN( '                     LAMBDA',LAMBDA :10:5);
               WRITELN( ' LIMITE DE L''I.C. DE LAMBDA',LAMBDA2:10:5);
END ELSE BEGIN
               WRITELN( '     LIMIT OF C.I. OF LAMBDA',LAMBDA1:10:5);
               WRITELN( '                      LAMBDA',LAMBDA :10:5);
               WRITELN( '     LIMIT OF C.I. OF LAMBDA',LAMBDA2:10:5);
END;
               IF (((LAMBDA1 <= 1) AND(LAMBDA2 >= 1))
                  OR((LAMBDA1 >= 1)AND(LAMBDA2 <= 1)))
                  THEN MATOPTION[I]:=0;
               LAMBDAS[I]:=LAMBDA;
               END;
         END
      ELSE FOR J:=1 TO N DO GET(TEMP2);       (* CORRECTION 3.0.03 *)
      END
   ELSE
      BEGIN
      NOBJ:=0;LNY:=0;NBPRES:=0;
      RESET(TEMP1);
      WRITELN;WRITELN;
      IF LANG=1 THEN WRITELN
         (' TRANSFORMATION BOX-COX AVEC TEST DE BARTLETT ')
      ELSE WRITELN
         (' BOX-COX WITH BARTLETT''S TEST OF HOMOGENEITY OF VARIANCES');
      WRITELN;
      FOR I:=1 TO NBVAR DO PRESENT[I]:=0;
      FOR I:=1 TO N DO
         FOR J:=1 TO NBVAR DO
            BEGIN
            X:=TEMP1@;
            GET(TEMP1);
            IF X<> ABSENCE THEN
               BEGIN
               NBPRES:=NBPRES+1;
               PRESENT[J]:=PRESENT[J]+1;
               LNY:=LNY+LN(X);
               END;
            END;
      IF NOT ERROR THEN
            BEGIN
            LNY:=EXP((-LNY)/NBPRES);
            EVALUE(LAMBDA);
            LIMITS(LAMBDA1,-1,LPRIME,NBPRES);
            LIMITS(LAMBDA2, 1,LPRIME,NBPRES);
            WRITELN;
IF LANG=1 THEN
BEGIN       WRITELN( ' LIMITE DE L''I.C. DE LAMBDA',LAMBDA1:10:5);
            WRITELN( '                     LAMBDA',LAMBDA :10:5);
            WRITELN( ' LIMITE DE L''I.C. DE LAMBDA',LAMBDA2:10:5);
END ELSE BEGIN
            WRITELN('  LIMIT OF C.I. OF LAMBDA',LAMBDA1:10:5);
            WRITELN('                   LAMBDA',LAMBDA :10:5);
            WRITELN('  LIMIT OF C.I. OF LAMBDA',LAMBDA2:10:5);
END;
            IF ((LAMBDA1<1)AND(LAMBDA2>1)) THEN LAMBDA:=1;
            END;
      END;
   END;     (* FIN BOXCOX *)
   PROCEDURE CLASSE(VAR MIN,MAX:MATVAR);
   VAR I,J:INTEGER;
       X,MINL,MAXL:REAL;
   BEGIN
   RESET(TEMP2);
   FOR I:=1 TO NBVAR DO
      BEGIN
      IF MATOPTION[I]=9 THEN
            BEGIN
            MINL:=MAXREEL;
            MAXL:=-MAXREEL;
            FOR J:=1 TO NOBJ DO
                  BEGIN
                  X:=TEMP2@;GET(TEMP2);
                  IF X<>ABSENCE THEN
                        BEGIN
                        IF X > MAXL THEN MAXL:=X;
                        IF X < MINL THEN MINL:=X;
                        END;
                  END;
            IF MINL=MAXL THEN TROUVERR(6,I);
            MIN[I]:=MINL;
            MAX[I]:=MAXL;
            END
      ELSE FOR J:=1 TO NOBJ DO GET(TEMP2);
      END;
   END;   (* FIN CLASSE *)


   PROCEDURE ENTREDONNEE(VAR EXPSIG,EXPYBAR,YBARRE,SIGMA:MATVAR);
   VAR I,J:INTEGER;
       X,YBAR:REAL;
   BEGIN
   RESET(TEMP1);
   FOR I:=1 TO NBVAR DO
         BEGIN
         EXPSIG[I]:=0;
         EXPYBAR[I]:=0;
         YBARRE [I]:=0;
         END;
   FOR I:=1 TO NOBJ DO
         FOR J:=1 TO NBVAR DO
         BEGIN
         X:=TEMP1@;GET(TEMP1);
         IF X<> ABSENCE THEN
               BEGIN
               IF X<=0 THEN TROUVERR(2,J);
               EXPSIG[J]:=EXPSIG[J]+X*X;
               EXPYBAR[J]:=EXPYBAR[J]+X;
               YBARRE[J]:=YBARRE[J]+1;
               END;
         END;
   FOR I:=1 TO NBVAR DO IF YBARRE[I]=0 THEN TROUVERR(1,I);
   FOR I:=1 TO NBVAR DO
         BEGIN
         X:=EXPYBAR[I];
         YBAR:=YBARRE[I];
         EXPSIG[I]:=(EXPSIG[I]-X*X/YBAR)/(YBAR-1);
         EXPYBAR[I]:=EXPYBAR[I]/YBAR;
         YBARRE[I]:=LN(EXPYBAR[I]);
         IF EXPSIG[I] > 0 THEN SIGMA[I] :=LN(EXPSIG[I])
         ELSE TROUVERR(6,I);
         END;
   END;    (* FIN ENTREDONNEE *)

   PROCEDURE SHELLSORT(VAR A,B: MATVAR;N: INTEGER);
   LABEL 1;
   VAR I,J,K,L,M,O: INTEGER;
       W:REAL;
   BEGIN
   M:=2*N-1 DIV 2;
   WHILE M<>0 DO
           BEGIN
           K:=N-M;
           FOR J:=1 TO K DO
                   BEGIN
                   I:=J;
                   WHILE I>=1 DO
                           BEGIN
                           IF A[I+M]>=A[I] THEN GOTO 1;
                           O:=I+M;
                           W:=A[I];A[I]:=A[O];A[O]:=W;
                           W:=B[I];B[I]:=B[O];B[O]:=W;
                           I:=I-M;
                           END;
   1:                 END;
           M:=M  DIV 2;
           END;
   END;        (* FIN DE SHELLSORT *)

   PROCEDURE AJUSTE(NBVAR:INTEGER;VAR A,B:REAL;
                     VAR EXPSIG,EXPYBAR,SIGMA,YBARRE,TEMP:MATVAR);

      PROCEDURE MODELII;
      VAR I,J,N:INTEGER;
          X1,Y1,X,Y,X2,Y2,XY,B2,C,SYX,LIMITE,D,H:REAL;

         FUNCTION ARCSIN(R:REAL):REAL;
         BEGIN
         ARCSIN:=1.570796327 -ARCTAN(SQRT(1-R*R)/R);
         END;    (* FIN ARCSIN *)

         FUNCTION TAN(R:REAL):REAL;
         BEGIN
         TAN:=SIN(R)/COS(R);
         END;    (* FIN TAN *)


         PROCEDURE MOD3(X2,Y2,XY:REAL);
         VAR I,J,RESTE:INTEGER;
             SX2,SY2,C,X1,DIFFPTR:REAL;
             ERR:BOOLEAN;
             PTR:ARRAY[0..3]OF INTEGER;
         BEGIN
          RESTE:=NBVAR MOD 3;
          PTR[0]:=0;
          PTR[1]:=NBVAR DIV 3;
          PTR[2]:=2*PTR[1];
          PTR[3]:=NBVAR;
          IF RESTE >0 THEN
             BEGIN
             PTR[2]:=PTR[2]+1;
             IF RESTE=2 THEN PTR[1]:=PTR[1]+1;
             END;
          SX2:=0;SY2:=0;
          FOR I:=PTR[2]+1 TO PTR[3] DO
             BEGIN
             SX2:=SX2+SIGMA[I];
             SY2:=SY2+YBARRE[I];
             END;
         FOR I:=1 TO PTR[1] DO
             BEGIN
             SX2:=SX2-SIGMA[I];
             SY2:=SY2-YBARRE[I];
             END;
          IF SX2 > 0 THEN B3:=SY2/SX2
          ELSE TROUVERR(8,0);
          FOR I:=1 TO 3 DO
             BEGIN
             SX2:=0;SY2:=0;
             FOR J:=PTR[I-1]+1 TO PTR[I] DO
                BEGIN
                SX2:=SX2+SIGMA[J];
                SY2:=SY2+YBARRE[J];
                END;
             DIFFPTR:=PTR[I]-PTR[I-1];
             X2:=X2-SQR(SX2)/DIFFPTR;
             Y2:=Y2-SQR(SY2)/DIFFPTR;
             XY:=XY-(SX2*SY2)/DIFFPTR;
             END;
         C:=TQUANTILE(0.05,NBVAR-3);           (* CORRECTION 3.0.06 *)
          X1:=0;
          FOR I:=PTR[1] DOWNTO 1 DO X1:=X1+SIGMA[I];
          FOR I:=PTR[2]+1 TO NBVAR DO X1:=X1-SIGMA[I];
          X1:=X1/PTR[1];
          C:=(PTR[1]*X1*X1)*(NBVAR-3)/(2*C*C);
          LIMITE:=C *
                (B3 * B3 * X2 + Y2 - 2 * B3 * XY) - X2 * Y2 - XY * XY;
         WRITE( ' BARTLETT       |');
         IF LIMITE>=0 THEN
               BEGIN
               LIMITE:=SQRT(LIMITE);
                WRITE( ((B3*C-XY)-LIMITE)/(C-X2):15:5);
                WRITE(B3:15:5);
                WRITELN( ((B3*C-XY)+LIMITE)/(C-X2):15:5);
               END
         ELSE WRITELN(B3:30:5);
         END;  (* MODEL3 BARTLETT *)

         PROCEDURE MOD4(X2,Y2,XY:REAL);                 (* MAJOR AXIS *)
         VAR I,J:INTEGER;
             LIMITE,D,H,L1,L2,NBVARL1:REAL;
         BEGIN
         NBVARL1:=NBVAR-1;
         X2:=(X2-X*X/NBVAR)/(NBVAR-1);
         Y2:=(Y2-Y*Y/NBVAR)/(NBVARL1);
         XY:=(XY-X*Y/NBVAR)/(NBVARL1);
         D:=SQRT(SQR(X2+Y2) -4*(X2*Y2-XY*XY));
         L1:=(X2+Y2+D)/2;
         B4:=(L1-X2)/XY;
         L2:=(X2+Y2-D)/2;
         FINVERSE(H,0.05,1,NBVAR-2);
         H:=SQRT(H/(L1/L2+L2/L1-2)/(NBVAR-2))*2;
         LIMITE:=TAN(ARCTAN(B4)+0.5*ARCSIN(H));
         IF LANG=1 THEN WRITE(' AXE MAJEUR     |',LIMITE:15:5)
                   ELSE WRITE(' MAJOR AXIS     |',LIMITE:15:5);
         LIMITE:=TAN(ARCTAN(B4)-0.5*ARCSIN(H));
         WRITELN(B4:15:5,LIMITE:15:5);
         END;   (* END MODEL 4 *)


      PROCEDURE NONLINEAR(VAR A,EXPOSANT:REAL);
      VAR I,J:INTEGER;
          NOUVEAUL,ANCIENL,DELTA: REAL;

            FUNCTION TAYLOR(VAR A:REAL;B:REAL):REAL;
            VAR I:INTEGER;
                SUMX2B,SUMYXB,X,DIST:REAL;
            BEGIN
            SUMX2B:=0;SUMYXB:=0;
            FOR I:=1 TO NBVAR DO
                  BEGIN
                  IF ABS(B) > EPSILON THEN X:=EXP(B*LN(EXPSIG[I]))
                  ELSE X:=LN(EXPSIG[I]);
                  SUMYXB:=SUMYXB+X*EXPYBAR[I];
                  SUMX2B:=SUMX2B+X*X;
                  TEMP[I]:=X;
                  END;
             A:=SUMYXB/SUMX2B;
             DIST:=0;
             FOR I:=1 TO NBVAR DO
                  BEGIN
                  DIST:=DIST+SQR(EXPYBAR[I]-TEMP[I]*A);
                  END;
             TAYLOR:=DIST;
             END; (* TAYLOR *)

      BEGIN     (* NONLINEAR *)
      EXPOSANT:=0.5;
      DELTA:=1;
      ANCIENL:=TAYLOR(A,-0.5);
      NOUVEAUL:=TAYLOR(A,0.5);
      IF ANCIENL < NOUVEAUL THEN DELTA:=-DELTA;
      REPEAT
            ANCIENL:=NOUVEAUL;
            EXPOSANT:=EXPOSANT+DELTA;
            NOUVEAUL:=TAYLOR(A,EXPOSANT);
      UNTIL NOUVEAUL > ANCIENL;
      DELTA:=DELTA*1.1;
      WHILE ABS(DELTA) > EPSILON DO
            BEGIN
            DELTA:=-2*DELTA;
            REPEAT
                  ANCIENL:=NOUVEAUL;
                  DELTA:=DELTA/2;
                  EXPOSANT:=EXPOSANT+DELTA;
                  NOUVEAUL:=TAYLOR(A,EXPOSANT);
            UNTIL NOUVEAUL > ANCIENL;
            END;
      IF LANG=1 THEN WRITE(' NON LINEAIRE   |')
                ELSE WRITE(' NONLINEAR      |');
      WRITELN(B5:30:5);
      END;     (* FIN NONLINEAR *)

      BEGIN
      X:=0;Y:=0;X2:=0;Y2:=0;XY:=0;
      FOR I:=1 TO NBVAR DO
         BEGIN
         X1:=SIGMA[I];
         Y1:=YBARRE[I];
         X:=X+X1;
         Y:=Y+Y1;
         X2:=X2+X1*X1;
         Y2:=Y2+Y1*Y1;
         XY:=XY+X1*Y1;
         END;
      SYX:=(XY-X*Y/NBVAR);
      B1:=SYX/(X2-X*X/NBVAR);
      SYX:=SQRT(((Y2-Y*Y/NBVAR-SYX*B1)/(NBVAR-2))/(X2-X*X/NBVAR));
         C:=TQUANTILE(0.05,NBVAR-2);             (* CORRECTION 3.0.07 *)
      SYX:=SYX*C;
      IF MODELE IN[0,1] THEN
         BEGIN
         IF LANG=1 THEN WRITE(' LINEAIRE SIMPLE|',B1+SYX:15:5,B1:15:5)
                   ELSE WRITE(' SIMPLE LINEAR  |',B1+SYX:15:5,B1:15:5);
         WRITELN(B1-SYX:15:5);
         END;     (* MODEL 1 *)
      VYX:=SQRT((Y2-Y*Y/NBVAR)/(X2-X*X/NBVAR));
      IF MODELE IN[0,2] THEN
         BEGIN
IF LANG=1 THEN
     WRITELN(' AXE MAJ. REDUIT|',VYX+SYX:15:5,VYX:15:5,VYX-SYX:15:5)
ELSE WRITELN(' REDUCED MAJ. A.|',VYX+SYX:15:5,VYX:15:5,VYX-SYX:15:5);
         END;
      IF ((MODELE IN[0,3])AND(NBVAR>3)) THEN MOD3(X2,Y2,XY);
      IF ((MODELE IN[0,4])AND(NBVAR>=4)) THEN MOD4(X2,Y2,XY);
                                                 (* CORRECTION 3.0.03 *)
      IF ((MODELE IN[0,5])AND(NBVAR>=3)) THEN NONLINEAR(A5,B5);
      END;    (* MODELII1 *)


   BEGIN     (* AJUSTE *)
   IF MODELE=0 THEN DEJAAJUSTE:=TRUE;            (* CORRECTION 3.0.01 *)
   RESET(ENTREEC);
   DEJAAJUSTE:=TRUE;
   ENTREDONNEE(EXPSIG,EXPYBAR,YBARRE,SIGMA);
   IF NOT ERROR THEN
         BEGIN
         SHELLSORT(SIGMA,YBARRE,NBVAR);
         WRITELN;WRITELN;
    IF LANG=1 THEN WRITELN
    ('     MODELE     |         LIM. SUP.       PENTE       LIM. INF.')
    ELSE WRITELN
    ('     MODEL      |         SUP. LIM.       SLOPE       INF. LIM.');
    WRITELN('                |---------------------------------------',
                                                             '-------');
         MODELII;
         END;
   END;    (* FIN AJUSTE *)

   PROCEDURE HISTOGRAMMES(VAR MAT:MATINT;VAR MATREEL:MATCALC);
   VAR I,J,K,NBTROUVES:INTEGER;
       X,MINL,MAXL:REAL;

      PROCEDURE ECRITHISTO(IND:INTEGER);
      VAR I,J,MAX:INTEGER;
      BEGIN
      MAX:=0;
      FOR I:=1 TO NBCLASSES DO IF MAT[I]>MAX THEN MAX:=MAT[I];
      IF MAX > 79 THEN
            BEGIN
            X:=79/MAX;
            FOR I:=1 TO NBCLASSES DO MAT[I]:=ROUND(MAT[I]*X);
            END;
      WRITELN;
      WRITELN(' VARIABLE :',IND:3);
      FOR I:=1 TO NBCLASSES DO
            BEGIN
            WRITE(' |');
            FOR J:=1 TO MAT[I] DO WRITE('*');
            WRITELN;
            END;
      WRITE(' ');
      FOR J:=0 TO 79 DO WRITE('-');
      WRITELN;
      IF MAX <= 79 THEN WRITELN(MAX:MAX+2)       (* CORRECTION 3.0.05 *)
      ELSE WRITELN(MAX:ROUND(MAX*X)+2);
      WRITELN;
      END;   (* ECRITHISTO *)

   BEGIN
   RESET(TEMP2);
   WRITELN;
   IF LANG=1 THEN WRITELN(' HISTOGRAMMES') ELSE WRITELN(' HISTOGRAMS');
   WRITELN;
   IF LANG=1 THEN WRITELN(' NOMBRE DE CLASSES? (LA REGLE DE STURGE ',
   'SUGGERE ',ROUND(LN(NOBJ)/LN(10)*3.33)+1:3,' CLASSES; MAX = ',NOBJ:3,
   ' CLASSES)')
            ELSE WRITELN(' HOW MANY CLASSES? (STURGE''S RULE SUGGESTS ',
   ROUND(LN(NOBJ)/LN(10)*3.33)+1:3,' CLASSES; MAX = ',NOBJ:3,
   ' CLASSES)');
   READLN(NBCLASSES);
   FOR I:=1 TO NBVAR DO
      BEGIN
      FOR J:=1 TO NBCLASSES DO MAT[J]:=0;
      MINL:=MAXREEL;MAXL:=-MAXREEL;
      NBTROUVES:=0;
      FOR J:=1 TO NOBJ DO
            BEGIN
            X:=TEMP2@;GET(TEMP2);
            IF X<>ABSENCE THEN
                  BEGIN
                  NBTROUVES:=NBTROUVES+1;
                  IF MATOPTION[I]<>9 THEN X:=FONCTION(X,I);
                  IF X > MAXL THEN MAXL:=X;
                  IF X < MINL THEN MINL:=X;
                  MATREEL[NBTROUVES]:=X;
                  END;
            END;
      MAXL:=(MAXL-MINL)/NBCLASSES;
      FOR J:=1 TO NBTROUVES DO
            BEGIN
            K:=TRUNC((MATREEL[J]-MINL)/MAXL-EPSILON)+1;
            MAT[K]:=MAT[K]+1;
            END;
      ECRITHISTO(I);
      END;
   END;   (* FIN HISTOGRAMMES *)
   PROCEDURE CENTREREDUIT(VAR MOY,VARI:MATVAR);
   VAR I,J,NBPRESENTS:INTEGER;
       X,MOYENNE,VARIANCE:REAL;
   BEGIN
   RESET(TEMP2);
   FOR I:=1 TO NBVAR DO
      BEGIN
      IF MATOPTION[I]=14 THEN
            BEGIN
            NBPRESENTS:=0;MOYENNE:=0;VARIANCE:=0;
            FOR J:=1 TO NOBJ DO
                  BEGIN
                  X:=TEMP2@;GET(TEMP2);
                  IF X<>ABSENCE THEN
                       BEGIN
                        NBPRESENTS:=NBPRESENTS+1;
                        MOYENNE:=MOYENNE+X;
                        VARIANCE:=VARIANCE+X*X;
                        END;
                  END;
            IF NBPRESENTS>1 THEN
                  BEGIN
                  MOYENNE:=MOYENNE/NBPRESENTS;
                  VARIANCE:=(VARIANCE-MOYENNE*MOYENNE*NBPRESENTS)/
                  (NBPRESENTS-1);
                  END
            ELSE TROUVERR(6,I);
            MOY[I]:=MOYENNE;
            IF VARIANCE > 0 THEN VARI[I]:=SQRT(VARIANCE)
            ELSE TROUVERR(6,I);
            END
      ELSE FOR J:=1 TO NOBJ DO GET(TEMP2);
      END;
   END;   (* CENTRE ET REDUIT *)


   PROCEDURE SHELL(VAR A: MATVAR;N: INTEGER);
   LABEL 1;
   VAR I,J,K,L,M,O: INTEGER;
       W:REAL;
   BEGIN
   M:=2*N-1 DIV 2;
   WHILE M<>0 DO
           BEGIN
           K:=N-M;
           FOR J:=1 TO K DO
                   BEGIN
                   I:=J;
                   WHILE I>=1 DO
                           BEGIN
                           IF A[I+M]>=A[I] THEN GOTO 1;
                           O:=I+M;
                           W:=A[I];A[I]:=A[O];A[O]:=W;
                           I:=I-M;
                           END;
   1:                 END;
           M:=M  DIV 2;
           END;
   END;        (* FIN DE SHELL *)

PROCEDURE LILLIEFORS(VAR MAT,RES1,RES2:MATVAR;VAR LIL:STAT);
VAR I,J,K,N:INTEGER;
   X,TOTAL,MOYENNE,VARIANCE,DIST,DIST1,PGDIST,POINT,PGDIST1,VALLIM:REAL;

   FUNCTION INTERP(P1,P2:INTEGER):REAL;
   VAR NN:INTEGER;
   BEGIN
   IF N MOD 5=0 THEN NN:=5 ELSE NN:=N MOD 5;
   INTERP:=(LIL[CHOIX,P2]-LIL[CHOIX,P1])/5*(NN)+LIL[CHOIX,P1];
   END;

   PROCEDURE ECRITLILY(DEBUT,FIN:INTEGER);
   VAR I:INTEGER;
   BEGIN
   WRITELN;
   WRITE(' VARIABLE  :');
   FOR I:=DEBUT TO FIN DO WRITE(I:5,'  ');
   WRITELN;
   WRITE(' DISTANCE  :');
   FOR I:=DEBUT TO FIN DO WRITE(RES1[I]:7:4);
   WRITELN;
   IF LANG=1 THEN WRITE(' VAL. CRIT.:') ELSE WRITE(' CRIT. VAL.:');
   FOR I:=DEBUT TO FIN DO WRITE(RES2[I]:7:4);
   WRITELN;
   IF LANG=1 THEN WRITE(' HYPOTHESE :') ELSE WRITE(' HYPOTHESIS:');
   FOR I:=DEBUT TO FIN DO
      BEGIN
      IF RES1[I]<0 THEN WRITE('    NC ')
      ELSE
            BEGIN
            IF RES1[I]>RES2[I] THEN WRITE('     R ')
            ELSE WRITE('    NR ');
            END;
      END;
   WRITELN;WRITELN;
   END;   (* ECRITLILY *)

BEGIN         (* LILLIE *)
WRITELN;
IF LANG=1 THEN BEGIN
WRITELN(' TEST DE KOLMOGOROV-SMIRNOV (TABLE DE LILLIEFORS )');WRITELN;
WRITELN(' HYPOTHESE : R=REJETEE, NR=NON REJETEE, NC=NON CALCULABLE ');
END ELSE BEGIN
WRITELN(' KOLMOGOROV-SMIRNOV TESTS (LILLIEFORS TABLE)');WRITELN;
WRITELN(' HYPOTHESIS: R=REJECTED, NR=NOT REJECTED, NC=NOT COMPUTABLE');
END;  WRITELN;
RESET(TEMP2);
FOR I:=1 TO NBVAR DO
      BEGIN
      TOTAL:=0;VARIANCE:=0;N:=0;PGDIST:=0;PGDIST1:=0;
      FOR K:=1 TO NOBJ DO
         BEGIN
         X:=TEMP2@;GET(TEMP2);
         IF X<>ABSENCE THEN
            BEGIN
            X:=FONCTION(X,I);
            TOTAL:=TOTAL+X;
            VARIANCE:=VARIANCE+SQR(X);
            N:=N+1;
            MAT[N]:=X;
            END;
         END;
      IF ((N<4) OR (VARIANCE*N <= TOTAL*TOTAL+EPSILON)) THEN RES1[I]:=-1
      ELSE
         BEGIN
         VARIANCE:=SQRT((VARIANCE-SQR(TOTAL)/N)/(N-1));
         MOYENNE:=TOTAL/N;
         SHELL(MAT,N);
         X:=0;
         POINT:=0;
         FOR J:=1 TO N DO
               BEGIN
               POINT:=GAUSS((MAT[J]-MOYENNE)/VARIANCE);
               DIST1:=ABS(POINT-(J-1)/N);
               X:=J/N;
               DIST:= ABS(POINT-X);
               IF DIST>PGDIST THEN PGDIST:=DIST;
               IF DIST1>PGDIST1 THEN PGDIST1:=DIST1;
               END;
         IF PGDIST1>PGDIST THEN PGDIST:=PGDIST1;
         IF N<=20 THEN
                BEGIN
                  VALLIM:=LIL[CHOIX,N];
                END
         ELSE IF N<=25 THEN
                  BEGIN
                  VALLIM:=INTERP(20,21);
                  END
              ELSE IF N<=30 THEN
                 BEGIN
                  VALLIM:=INTERP(21,22);
                 END
                  ELSE
                  BEGIN
                  VALLIM:=LIL[CHOIX,23]/SQRT(N);
                  END;
          RES1[I]:=PGDIST;RES2[I]:=VALLIM;
          END;
      END;
FOR I:=1 TO NBVAR DIV 7 DO ECRITLILY((I-1)*7+1,I*7);
IF NBVAR MOD 7<>0 THEN ECRITLILY((NBVAR DIV 7)*7+1,NBVAR);
END;


PROCEDURE REECRIT;
VAR I,J,K,KK,COMPTEUR:INTEGER;
    X,MINL,MAXL:REAL;
    MATCAR:ALFA;
    GLOBAL,NOOP:BOOLEAN;

   PROCEDURE MINMAX(X:REAL);
   VAR NEC,NBF,SIGNE:INTEGER;
   BEGIN
   SIGNE:=0;
   IF X< 0 THEN
      BEGIN
      X:=-X;
      SIGNE:=1;
      END;
   NEC:=TRUNC(LN(X+EPSILON)/LN(10))+2;
   NEC:=NEC+SIGNE;
   IF FRACTION > 0 THEN NEC:=NEC+1;
   IF CHAMP-FRACTION < NEC THEN
      BEGIN
      CHAMP:=NEC+1+FRACTION;
      IF ADDTITRE THEN NBF:=70 DIV CHAMP
      ELSE NBF:=80 DIV CHAMP;
      IF NBF=0 THEN NBF:=1;
IF LANG=1 THEN WRITELN(' CHAMP INSUFFISANT; NOUVEAU FORMAT: ',NBF:1,'F',
                CHAMP:1,'.',FRACTION:1)
ELSE  WRITELN(' INSUFFICIENT FIELD; NEW FORMAT: ',NBF:1,'F',
                CHAMP:1,'.',FRACTION:1);
      END;
   END;

BEGIN   (* REECRIT *)
WRITELN;
NOOP:=FALSE;
IF LANG=1
THEN WRITELN(' TRANSFORMATIONS EFFECTUEES SUR LE FICHIER DE SORTIE:')
ELSE WRITELN(' TRANSFORMATIONS WRITTEN TO OUTPUT FILE:');
IF MATOPTION[1]<=0 THEN
      BEGIN
      NOOP:=TRUE;
      FOR I:=2 TO NBVAR DO IF MATOPTION[I]> 0 THEN NOOP:=FALSE;
      END;
IF NOOP THEN BEGIN
IF LANG=1 THEN WRITELN('   AUCUNE TRANSFORMATION N''A ETE EFFECTUEE')
          ELSE WRITELN('   NO DATA TRANSFORMATION WAS MADE');
END ELSE
   BEGIN
   J:=MATOPTION[1];
   IF ((J > 0)AND(J <=5)) THEN WRITELN('  TAYLOR')
   ELSE
      BEGIN
      IF J=7 THEN WRITELN('  BOX-COX-BARTLETT')
      ELSE
         BEGIN
IF LANG=1 THEN BEGIN
WRITELN(' 0=pas de transformation, A=Box-Cox, B=division en classes');
WRITELN(' C=votre choix de transformation, D=var. centree reduite');
END ELSE BEGIN
WRITELN(' 0=no transformation, A=Box-Cox, B=division into classes');
WRITELN(' C=your choice of transformation, D=data standardized');
END;     WRITE(' ');
         FOR I:=1 TO NBVAR DO
               BEGIN
               IF MATOPTION[I]<=0 THEN WRITE('0')
               ELSE CASE MATOPTION[I] OF
                    6:WRITE('A');
                    9:WRITE('B');
                   10,11,12,13:WRITE('C');     (* correction 3.0.08 *)
                   14:WRITE('D');
                    END;
               IF I MOD 70=0 THEN BEGIN WRITELN;WRITE(' ');END;
               END;
         WRITELN;WRITELN;
         END;
      END;
   END;
RESET(TEMP1);
REWRITE(TEMP2);
REWRITE(SORTIEC);
MINL:=MAXREEL;
MAXL:=-MAXREEL;
GLOBAL:=(COMPACTE)AND(NOT(MATOPTION[1] IN[1..5,7]));
IF GLOBAL THEN
   FOR I:=1 TO NBVAR DO
      BEGIN
      MINLOCAL@[I]:=MINL;
      MAXLOCAL@[I]:=MAXL;
      END;
FOR I:=1 TO NOBJ DO
      BEGIN
      FOR J:=1 TO NBVAR DO
            BEGIN
            X:=TEMP1@;GET(TEMP1);
            IF X<>ABSENCE THEN
                  BEGIN
                  X:=FONCTION(X,J);
                  IF MATOPTION[J]<>9 THEN
                        BEGIN
                        IF X<MINL THEN MINL:=X;
                        IF X>MAXL THEN MAXL:=X;
                        IF GLOBAL THEN
                              BEGIN
                              IF X < MINLOCAL@[J] THEN MINLOCAL@[J]:=X;
                              IF X > MAXLOCAL@[J] THEN MAXLOCAL@[J]:=X;
                              END;
                        END;
                  END;
            TEMP2@:=X;PUT(TEMP2);
            END;
      END;
IF MINF < MAXF THEN
      BEGIN
      MINMAX(MINF);
      MINMAX(MAXF);
      END
ELSE
      BEGIN
      MINMAX(MINL);
      MINMAX(MAXL);
      END;
IF GLOBAL THEN
      BEGIN
      FOR I:=1 TO NBVAR DO MAXLOCAL@[I]:=MAXLOCAL@[I]-MINLOCAL@[I];
      END;
MAXF:=MAXF-MINF;
MAXL:=MAXL-MINL;
RESET(TEMP2);
FOR I:=1 TO NOBJ DO
      BEGIN
      COMPTEUR:=0;
      IF ADDTITRE THEN
            BEGIN
(*          FOR K:=1 TO 10 DO READ(TITRE,MATCAR[K]);                  *)
            K:=0;           (* MODIFICATION FOR VARIABLE-LENGTH FILES *)
            WHILE (NOT(EOLN(TITRE)) AND (K<10)) DO
                BEGIN
                K:=K+1;
                READ(TITRE,MATCAR[K]);
                END;
            FOR KK:=(K+1) TO 10 DO MATCAR[KK]:=' ';     (* END MODIF. *)
            READLN(TITRE);
            COMPTEUR:=COMPTEUR+10;
            WRITE(SORTIEC,MATCAR);
            END;
      FOR J:=1 TO NBVAR DO
            BEGIN
            IF COMPTEUR+CHAMP >80 THEN
                  BEGIN
                  COMPTEUR:=0;
                  WRITELN(SORTIEC);
                  IF ADDTITRE THEN
                        BEGIN
                        WRITE(SORTIEC,'          ');
                        COMPTEUR:=10;
                        END;
                  END;
            X:=TEMP2@;GET(TEMP2);
            COMPTEUR:=COMPTEUR+CHAMP;
            IF X=ABSENCE THEN
                  BEGIN
                  FOR K:=CHAMP-1 DOWNTO NBCHAR DO WRITE(SORTIEC,' ');
                                                 (* CORRECTION 3.0.02 *)
                  FOR K:=1 TO NBCHAR DO WRITE(SORTIEC,ABST[K]);
                  END
            ELSE
                  BEGIN
                  IF COMPACTE THEN
                      BEGIN
                      IF GLOBAL THEN
                         X:=((X-MINL)/MAXL)*MAXF+MINF
                      ELSE X:=((X-MINLOCAL@[J])/MAXLOCAL@[J])*MAXF+MINF;
                      END;
                  IF FRACTION > 0 THEN WRITE(SORTIEC,X:CHAMP:FRACTION)
                  ELSE WRITE(SORTIEC,ROUND(X):CHAMP);
                  END;
            END;
      WRITELN(SORTIEC);
      END;
END;   (* FIN REECRIT *)

PROCEDURE CHERCHEMODELE;
VAR I,J,K:INTEGER;
    X,Y:REAL;

   PROCEDURE VALIDE;
   VAR I,J,K:INTEGER;
   BEGIN
   IF MATOPTION[1 ]IN[0..5,7]THEN FOR I:=1 TO NBVAR DO MATOPTION[I]:=-1;
   IF LANG=1
   THEN WRITELN(' COMBIEN DE VARIABLES VOULEZ-VOUS TRANSFORMER ?')
   ELSE WRITELN(' HOW MANY VARIABLES DO YOU WISH TO TRANSFORM ?');
   READLN(J);
   IF J < NBVAR THEN
      BEGIN
   IF LANG=1 THEN WRITELN(' INSCRIVEZ LES NUMEROS DE CES VARIABLES ')
             ELSE WRITELN(' TYPE IN  THESE VARIABLES'' NUMBERS   ');
      FOR I:=1 TO J DO
         BEGIN
         READ(K);
         MATOPTION[K]:=MODELE;
         IF MODELE IN[10,11,13] THEN PTRA@[K]:=X;
         IF MODELE IN[10,13] THEN PTRB@[K]:=Y;
         END;
      READLN;
      END
   ELSE FOR I:=1 TO NBVAR DO
      BEGIN                                      (* CORRECTION 3.0.01 *)
      MATOPTION[I]:=MODELE;
      IF MODELE IN[10,11,13] THEN PTRA@[I]:=X;
      IF MODELE IN[10,13] THEN PTRB@[I]:=Y;
      END;
   END;   (* FIN VALIDE *)

BEGIN   (* CHERCHEMODELE *)
CASE OPTION OF
      0:BEGIN
IF LANG=1 THEN BEGIN
        WRITELN(' MODELE DE TAYLOR ');
        WRITELN('   OPTIONS:');
        WRITELN('      0: TOUTES LES OPTIONS SERONT CALCULEES ');
        WRITELN('      1: REGRESSION LINEAIRE SIMPLE ');
        WRITELN('      2: REGRESSION PAR L''AXE MAJEUR REDUIT ');
        WRITELN('      3: METHODE DES TROIS GROUPES DE BARTLETT ');
        WRITELN('      4: REGRESSION PAR L''AXE MAJEUR ');
        WRITELN('      5: REGRESSION NON-LINEAIRE ');
END ELSE BEGIN
        WRITELN(' TAYLOR''S MODEL');
        WRITELN('   OPTIONS:');
        WRITELN('      0: ALL THE OPTIONS BELOW WILL BE COMPUTED');
        WRITELN('      1: SIMPLE LINEAR REGRESSION');
        WRITELN('      2: REDUCED MAJOR AXIS REGRESSION');
        WRITELN('      3: BARTLETT''S THREE-GROUP METHOD');
        WRITELN('      4: MAJOR AXIS REGRESSION');
        WRITELN('      5: NONLINEAR REGRESSION');
END;    WRITELN('      ');READLN(MODELE);
        BORNES(MODELE,0,5);
        IF NOT(DEJAAJUSTE) THEN
            BEGIN
            NEW(MATV1);NEW(MATV2);NEW(MATV3);NEW(MATV4);NEW(MATV5);
            AJUSTE(NBVAR,A,B,MATV1@,MATV2@,MATV3@,MATV4@,MATV5@);
            DISPOSE(MATV1);DISPOSE(MATV2);DISPOSE(MATV3);DISPOSE(MATV5);
            END;
        IF MODELE<>0 THEN                        (* CORRECTION 3.0.01 *)
            BEGIN
            CASE MODELE OF
               1:B:= B1;
               2:B:= VYX;
               3:B:= B3;
               4: B:= B4;
               5: BEGIN B:= B5;A:=A5;END;
                  END;
            B:=1-B/2;                            (* CORRECTION 3.0.01 *)
            END;
        FOR I:=1 TO NBVAR DO MATOPTION[I]:=MODELE;
        END;
      1:BEGIN
        MODELE:=6;
        VALIDE;
        NEW(MATC1);NEW(MATV1);NEW(MATV3);NEW(MATI1);
        IF NOT(ALLOUEL) THEN BEGIN NEW(LAMBDAS);ALLOUEL:=TRUE;END;
        BOXCOX(NOBJ,MATC1@,MATV1@,LAMBDAS@,MATV3@,MATI1@);
        DISPOSE(MATC1);DISPOSE(MATV1);DISPOSE(MATV3);DISPOSE(MATI1);
        END;
      2:BEGIN
        MODELE:=7;
        NEW(MATC1);NEW(MATV1);NEW(MATV3);NEW(MATI1);
        IF NOT(ALLOUEL) THEN  NEW(LAMBDAS);
        BOXCOX(NOBJ,MATC1@,MATV1@,LAMBDAS@,MATV3@,MATI1@);
        DISPOSE(LAMBDAS);ALLOUEL:=FALSE;
        DISPOSE(MATC1);DISPOSE(MATV1);DISPOSE(MATV3);DISPOSE(MATI1);
        FOR I:=1 TO NBVAR DO MATOPTION[I]:=MODELE;
        END;
      3:BEGIN
        NBCLASSES:=ROUND(LN(NOBJ)/LN(10)*3.33)+1;
        MODELE:=9;
        VALIDE;
        IF NOT(DEJACLASSE) THEN NEW(CLASSES);
        IF LANG=1 THEN WRITELN(' DESIREZ-VOUS QUE TOUTES LES VARIABLES',
                                   ' AIENT LE MEME NOMBRE DE CLASSES?')
        ELSE WRITELN(' DO YOU WANT ALL VARIABLES ',
                                 'TO HAVE THE SAME NUMBER OF CLASSES?');
        WHILE NOT(INPUT@ IN['0','O','o','Y','y','N','n']) DO GET(INPUT);
        IF INPUT@ IN['0','O','o','Y','y'] THEN
BEGIN
 READLN;
 IF LANG=1
 THEN WRITELN(' NOMBRE DE CLASSES? ',
           '(LA REGLE DE STURGE SUGGERE ',NBCLASSES:3,' CLASSES)  ')
 ELSE WRITELN(' NUMBER OF CLASSES? ',
           '(STURGE''S RULE SUGGESTS ',NBCLASSES:3,' CLASSES)  ');
 READLN(NBCLASSES);
 FOR I:=1 TO NBVAR DO IF MATOPTION[I]=9 THEN CLASSES@[I]:=NBCLASSES;
END ELSE BEGIN
 READLN;
 IF LANG=1 THEN BEGIN
 WRITELN(' INSCRIVEZ LE NOMBRE DE CLASSES DESIRE POUR CHAQUE VARIABLE');
 WRITELN(' (LA REGLE DE STURGE SUGGERE ',NBCLASSES:3,' CLASSES)  ');
 END ELSE BEGIN
 WRITELN(' TYPE IN  THE NUMBER OF CLASSES YOU WANT FOR EACH VARIABLE');
 WRITELN(' (STURGE''S RULE SUGGESTS ',NBCLASSES:3,' CLASSES)  ');
 END;
 FOR I:=1 TO NBVAR DO IF MATOPTION[I]=9 THEN
            BEGIN
            READ(CLASSES@[I]);
            END;
 READLN;
END;
        IF NOT DEJACLASSE THEN
           BEGIN
           NEW(MIN);NEW(MAX);
           CLASSE(MIN@,MAX@);
           DEJACLASSE:=TRUE;
           END;
        END;
      4:BEGIN
        WRITELN(' TRANSFORMATIONS');
        WRITELN('   OPTIONS:');
        WRITELN('      1:Y''= A + BY');
        WRITELN('      2:Y''= Y *EXP(A)');
        WRITELN('      3:Y''= EXP(Y)');
        WRITELN('      4:Y''= LN(A + BY)');
        WRITELN('      ');
        READLN(J);
        BORNES(J,1,4);
        CASE J OF
            1,4:BEGIN
                IF LANG=1 THEN WRITELN(' ENTREZ A et B  ')
                          ELSE WRITELN(' ENTER A and B  ');
                READLN(X,Y);
                IF J=1 THEN MODELE:=10 ELSE MODELE:=13;
                IF NOT(ALLOUEA) THEN BEGIN NEW(PTRA);ALLOUEA:=TRUE;END;
                IF NOT(ALLOUEB) THEN BEGIN NEW(PTRB);ALLOUEB:=TRUE;END;
                END;
            2:BEGIN
           IF LANG=1 THEN WRITELN(' ENTREZ A') ELSE WRITELN(' ENTER A');
              READLN(X);
              MODELE:=11;
              IF NOT(ALLOUEA) THEN BEGIN NEW(PTRA);ALLOUEA:=TRUE;END;
            END;
            3:MODELE:=12;
            END;
        VALIDE;
        END;
     5:BEGIN
       NEW(MATI1);NEW(MATC1);
       HISTOGRAMMES(MATI1@,MATC1@);
       DISPOSE(MATI1);DISPOSE(MATC1);
       END;
      6:BEGIN
        MODELE:=14;
        VALIDE;
        IF NOT(ALLOUEA) THEN BEGIN NEW(PTRA);ALLOUEA:=TRUE;END;
        IF NOT(ALLOUEB) THEN BEGIN NEW(PTRB);ALLOUEB:=TRUE;END;
        CENTREREDUIT(PTRA@,PTRB@);
        END;
      7:BEGIN
        REPEAT
IF LANG=1 THEN WRITELN(' SEUIL DE SIGNIFICATION DESIRE: INSCRIVEZ ')
          ELSE WRITELN(' LEVEL OF SIGNIFICANCE REQUESTED: TYPE ');
        WRITELN('     1 = 1 %, 2 = 5 %, 3 = 10 %, 4 = 15 %, 5 = 20 % ');
        READLN(CHOIX);
        UNTIL CHOIX IN[1..5];
        IF NOT(DEJAINIT) THEN BEGIN NEW(LIL);INIT(LIL@);END;
        NEW(MATV1);NEW(MATV2);NEW(MATV3);
        LILLIEFORS(MATV1@,MATV2@,MATV3@,LIL@);
        DISPOSE(MATV1);DISPOSE(MATV2);DISPOSE(MATV3);
        END;
      8:BEGIN
        MINF:=0;MAXF:=0;
        IF LANG=1 THEN WRITELN
        (' NOMBRE D''ESPACES DANS LESQUELS LES NOMBRES SERONT ECRITS? ')
        ELSE WRITELN
        (' HOW MANY SPACES DO YOU ALLOW TO WRITE EACH VALUE?  ');
        READLN(CHAMP);
IF LANG=1 THEN WRITELN(' COMBIEN DE DECIMALES APRES LE POINT?   ')
          ELSE WRITELN(' HOW MANY DECIMAL PLACES?   ');
        READLN(FRACTION);
IF LANG=1 THEN WRITELN(' CODE DESIRE POUR LES VALEURS ABSENTES: ')
          ELSE WRITELN(' CODE FOR MISSING VALUES: ');
        NBCHAR:=0;
        GET(INPUT);
        WHILE NOT(EOLN(INPUT)) DO
            BEGIN
            NBCHAR:=NBCHAR+1;
            ABST[NBCHAR]:=INPUT@;GET(INPUT);
            END;
        READLN;
        WHILE ABST[NBCHAR]=' ' DO NBCHAR:=NBCHAR-1;
IF LANG=1 THEN BEGIN
   WRITELN(' DESIREZ-VOUS IMPOSER UNE ECHELLE AUX VALEURS ');
   WRITELN(' EN FIXANT VOUS-MEME LE MINIMUM ET LE MAXIMUM? '); END
ELSE WRITELN
    (' DO YOU WISH TO SCALE ALL VALUES BETWEEN IMPOSED MIN. AND MAX.?');
WHILE NOT (INPUT@ IN['0','O','o','Y','y','N','n']) DO GET(INPUT);
        IF INPUT@ IN['0','O','o','Y','y'] THEN
        BEGIN
          READLN;
          COMPACTE:=TRUE;
IF LANG=1 THEN WRITELN(' INSCRIVEZ LE MINIMUM ET LE MAXIMUM: ')
          ELSE WRITELN(' TYPE IN  THE MINIMUM AND THE MAXIMUM: ');
          READLN(MINF,MAXF);
        END ELSE BEGIN
          READLN;
          COMPACTE:=FALSE;
        END;
        IF (((TRANSPOSITION)OR(NOT(IDENT)))AND(NOT(EOF(TITRE)))) THEN
          BEGIN
          IF LANG=1 THEN WRITELN
(' AVEZ-VOUS PREPARE UN FICHIER DE NOMS D''OBJETS? (Fichier "TITRE")?')
          ELSE WRITELN
         (' HAVE YOU PREPARED A FILE OF OBJECT NAMES? (File "TITLE")?');
       WHILE NOT (INPUT@ IN['0','O','o','Y','y','N','n']) DO GET(INPUT);
          ADDTITRE:=INPUT@ IN ['0','O','o','Y','y'];READLN;
          END;
        IF (ADDTITRE) THEN RESET(TITRE);
        IF ((COMPACTE)AND(NOT(MATOPTION[1] IN[1..5,7]))) THEN
            BEGIN NEW(MINLOCAL);NEW(MAXLOCAL);END;
        REECRIT;
        END;
      END;
END;   (* CHERCHE MODELE *)

BEGIN   (* PROG PRINC *)
ERROR:=FALSE;
ALLOUEA:=FALSE;ALLOUEB:=FALSE;ALLOUEL:=FALSE;
DEJAINIT:=FALSE;
DEJAAJUSTE:=FALSE;
DEJACLASSE:=FALSE;
WRITELN;
IF LANG=1 THEN BEGIN
WRITELN(' P R O G R A M M E   V E R N O R M  ');
WRITELN(' pour VERifier et NORMaliser les tableaux de donnees ');
WRITELN(' VERSION 3.0b');
WRITELN(' AUTEUR: A. VAUDOR.');
END ELSE BEGIN
WRITELN(' P R O G R A M   V E R N O R M  to VERify and NORMalize data');
WRITELN;
WRITELN(' VERSION 3.0b');
WRITELN(' AUTHOR: A. VAUDOR.');
END;
WRITELN;
IF LANG=1 THEN WRITELN(' LES 10 PREMIERES COLONNES ',
                   'CONTIENNENT-ELLES LES NOMS DES OBJETS? (o ou n)' )
ELSE WRITELN
(' ARE THE FIRST 10 COLUMNS USED TO WRITE THE OBJECT NAME? (y or n)' );
WHILE NOT (INPUT@ IN ['0','O','o','Y','y','N','n']) DO GET(INPUT);
IDENT:=INPUT@ IN['0','O','o','Y','y']; READLN;
IF LANG=1 THEN WRITELN(' NOMBRE D''OBJETS (LIGNES)?')
ELSE WRITELN(' NUMBER OF OBJECTS (ROWS)?');
READLN(NOBJ);
IF LANG=1 THEN WRITELN(' NOMBRE DE DESCRIPTEURS (COLONNES)?  ')
ELSE WRITELN(' NUMBER OF DESCRIPTORS (COLUMNS)?  ');
READLN(NBVAR);
IF LANG=1 THEN WRITELN(' CODE DESIGNANT L''ABSENCE D''INFORMATION?  ')
ELSE WRITELN(' CODE FOR MISSING VALUES?  ');
READLN(ABSENCE);
IF LANG=1 THEN WRITELN
(' DESIREZ-VOUS EFFECTUER LA VERIFICATION DU FICHIER DE DONNEES?   ')
ELSE WRITELN(' DO YOU WISH TO CHECK THE DATA FILE?   ');
WHILE NOT (INPUT@ IN ['0','O','o','Y','y','N','n']) DO GET(INPUT);
IF INPUT@ IN['0','O','o','Y','y'] THEN
  BEGIN
      READLN;
IF LANG=1 THEN WRITELN
(' S''AGIT-IL D''UN FICHIER DE DONNEES NE CONTENANT QUE DES ENTIERS? ')
ELSE WRITELN(' DOES THE DATA FILE CONTAIN ONLY INTEGER NUMBERS?  ');
WHILE NOT (INPUT@ IN ['0','O','o','Y','y','N','n']) DO GET(INPUT);
      ENTIER:=INPUT@ IN['0','O','o','Y','y'];READLN;
      VERIFIE(ENTIER);
  END ELSE READLN;
IF LANG=1
THEN WRITELN(' DESIREZ-VOUS TRANSPOSER LE FICHIER DE DONNEES? ')
ELSE WRITELN(' DO YOU WISH TO TRANSPOSE THE DATA FILE?   ');
WHILE NOT (INPUT@ IN ['0','O','o','Y','y','N','n']) DO GET(INPUT);
TRANSPOSITION:=INPUT@ IN['0','O','o','Y','y']; READLN;
OPTIONDEPT:=0;
IF LANG=1 THEN BEGIN
WRITELN(' DESIREZ-VOUS RENDRE TOUTES LES DONNEES POSITIVES?');
WRITELN('(CECI EST NECESSAIRE ',
  'POUR LES TRANF. DE TAYLOR, BOX-COX ET BOX-COX-BARTLETT)');END
ELSE BEGIN WRITELN(' DO YOU WISH TO MAKE ALL DATA POSITIVE?');
WRITELN('(THIS IS REQUIRED ',
              'FOR TAYLOR, BOX-COX AND BOX-COX-BARTLETT TRANSF.)');END;
WHILE NOT (INPUT@ IN ['0','O','o','Y','y','N','n']) DO GET(INPUT);
IF INPUT@ IN['0','O','o','Y','y'] THEN
BEGIN
 READLN;
 WRITELN('   OPTIONS');
 IF LANG=1 THEN BEGIN
 WRITELN('   1: LE PROGRAMME CALCULERA UNE TRANSLATION ',
                'POUR TOUT LE FICHIER (MIN:0.1)');
 WRITELN('   2: LE PROGRAMME CALCULERA UNE TRANSLATION ',
                'POUR CHAQUE VARIABLE (MIN:0.1)');
 WRITELN('   3: SI VOUS DESIREZ IMPOSER LE MINIMUM ',
                'POUR TOUT LE FICHIER');
 WRITELN('   4: SI VOUS DESIREZ IMPOSER LE MINIMUM ',
                'POUR CHAQUE VARIABLE');
 END ELSE BEGIN
 WRITELN('   1: PROGRAM WILL SCALE THE WHOLE DATA FILE (MIN:0.1)');
 WRITELN('   2: PROGRAM WILL SCALE EACH VARIABLE SEPARATELY (MIN:0.1)');
 WRITELN('   3: YOU WISH TO GIVE THE MINIMUM FOR THE WHOLE DATA FILE');
 WRITELN('   4: YOU WISH TO GIVE THE MINIMUM FOR EACH VARIABLE');
 END;
 WRITELN('   ');READLN(OPTIONDEPT);
  BORNES(OPTIONDEPT,1,4);
  IF TRANSPOSITION THEN K:=NOBJ ELSE K:=NBVAR;
  NEW(MATC2);
  CASE OPTIONDEPT OF
      1,2:FOR I:=1 TO K DO MATC2@[I]:=0.1;
      3:BEGIN
        IF LANG=1 THEN WRITELN(' VALEUR MINIMUM ')
                  ELSE WRITELN(' MINIMUM VALUE  ');
        READLN(X);
        FOR I:=1 TO K DO MATC2@[I]:=X;
        END;
      4:BEGIN
        IF LANG=1 THEN
        WRITELN(' INSCRIVEZ LA VALEUR MINIMALE DE CHAQUE VARIABLE: ')
        ELSE WRITELN(' TYPE IN  EACH VARIABLE''S MINIMUM VALUE:  ');
        FOR I:=1 TO K DO READ(MATC2@[I]); READLN;
        END;
      END;
END ELSE READLN;
NEW(MATC1);NEW(MATV1);
IF TRANSPOSITION THEN
      BEGIN
      IF OPTIONDEPT > 0 THEN
            BEGIN
            LECTURE(TEMP1,MATC1@,MATV1@);
            EFFDEPT(TEMP1,TEMP2,MATC1@,MATC2@,MATV1@);
            END
      ELSE LECTURE(TEMP2,MATC1@,MATV1@);
      END
ELSE
      BEGIN
      IF OPTIONDEPT > 0 THEN
            BEGIN
            LECTURE(TEMP2,MATC1@,MATV1@);
            EFFDEPT(TEMP2,TEMP1,MATC1@,MATC2@,MATV1@);
            END
      ELSE LECTURE(TEMP1,MATC1@,MATV1@);
      END;
DISPOSE(MATC1);DISPOSE(MATV1);
IF OPTIONDEPT >0 THEN DISPOSE(MATC2);
NEW(POURTRANSP);
IF TRANSPOSITION THEN
      BEGIN
      TRANSPFICH(TEMP2,TEMP1,POURTRANSP@);
      I:=NOBJ;
      NOBJ:=NBVAR;
      NBVAR:=I;
      END
ELSE
      BEGIN
      TRANSPFICH(TEMP1,TEMP2,POURTRANSP@);
      END;
DISPOSE(POURTRANSP);
FOR I:=1 TO NBVAR DO MATOPTION[I]:=-1;
REPEAT
   NOOPTION:=TRUE;
   WRITELN;
IF LANG=1 THEN WRITELN
(' DESIREZ-VOUS EFFECTUER UNE MANIPULATION SUR LE FICHIER? (O ou N)')
ELSE WRITELN
(' DO YOU WISH TO DO SOMETHING WITH THE DATA FILE? (y or n)');
WHILE NOT (INPUT@ IN ['0','O','o','Y','y','N','n']) DO GET(INPUT);
IF INPUT@ IN['0','O','o','Y','y'] THEN
     BEGIN
     READLN;
     NOOPTION:=FALSE;
     WRITELN('  OPTIONS');
  IF LANG=1 THEN BEGIN
     WRITELN('    0: TAYLOR (homogeneise les variances)');
     WRITELN('    1: BOX-COX (normalise les donnees)');
     WRITELN('    2: BOX-COX-BARTLETT ',
               '(normalise les donnees ET homogeneise les variances)');
     WRITELN('    3: DIVISION EN CLASSES');
     WRITELN('    4: VOTRE CHOIX DE TRANSFORMATION');
     WRITELN('    5: HISTOGRAMMES');
     WRITELN('    6: VARIABLES CENTREES REDUITES)');
     WRITELN('    7: TESTS DE NORMALITE Kolmogorov-Smirnov-Lilliefors');
     WRITELN('    8: REECRITURE DU FICHIER DE DONNEES');
  END ELSE BEGIN
     WRITELN('    0: TAYLOR (to homogenize variances)');
     WRITELN('    1: BOX-COX (to normalize data)');
     WRITELN('    2: BOX-COX-BARTLETT ',
                     '(to normalize data AND homogenize variances)');
     WRITELN('    3: DIVISION INTO CLASSES');
     WRITELN('    4: YOUR CHOICE OF A TRANSFORMATION');
     WRITELN('    5: HISTOGRAMS');
     WRITELN('    6: STANDARDIZE DATA (Z-scores)');
     WRITELN('    7: TESTING NORMALITY: Kolmogorov-Smirnov-Lilliefors');
     WRITELN('    8: RE-WRITE THE DATA FILE');
  END;
     WRITELN('    ');READLN(OPTION);
     BORNES(OPTION,0,8);
     CHERCHEMODELE;
     END ELSE READLN;
UNTIL (NOOPTION)OR(OPTION=8);
777:IF LANG=1 THEN WRITELN(' Fin du programme. ')
              ELSE WRITELN(' End of the program. ');
END.
